////////////////////////////////////////////////////////////////////////
// get_recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.get_recordings")

// <%pre>
#line 1 "get_recordings.ecpp"


#include <exception.h>
#include <tools.h>
#include <recman.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("get_recordings");

static const char* rawData = " \000\000\000.\000\000\0002\000\000\000O\000\000\000U\000\000\000Z\000\000\000]\000\000"
  "\000g\000\000\000vdr_restart = ;\n  recordings_tree_re_created = ;\n    recs[]=[]\n        ";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("get_recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::vector< int > r = qparam.getvector< int >("r");
time_t vdr_start = qparam.get< time_t >("vdr_start", ( 0));
time_t recordings_tree_creation = qparam.get< time_t >("recordings_tree_creation", ( 0));
  // </%args>

  // <%cpp>
#line 15 "get_recordings.ecpp"

  reply.setContentType("text/javascript");
  bool error = false;
  if (vdr_start != 0 && vdr_start != LiveSetup().GetVdrStart()) {
    esyslog("live ERROR, get_recordings.ecpp, vdr restarted");
    error = true;
  }
  
  reply.out() << _tntChunks[0]; // vdr_restart = 
#line 23 "get_recordings.ecpp"
  reply.sout() << ( error?"true":"false");
  reply.out() << _tntChunks[1]; // ;\n  
#line 24 "get_recordings.ecpp"

  if (!error) {
    bool recordings_tree_re_created = false;
    RecordingsTreePtr recordingsTree(RecordingsManager::GetRecordingsTree());
    if (recordings_tree_creation != 0 && recordings_tree_creation != RecordingsManager::GetLastRecordingsUpdate() ) {
      isyslog("live INFO, get_recordings.ecpp, recordings tree re-created");
      recordings_tree_re_created = true;
    }
    
  reply.out() << _tntChunks[2]; // recordings_tree_re_created = 
#line 33 "get_recordings.ecpp"
  reply.sout() << ( recordings_tree_re_created?"true":"false");
  reply.out() << _tntChunks[3]; // ;\n    
#line 34 "get_recordings.ecpp"

/*
    esyslog("live, get_recordings.ecpp, qparam as url = %s", qparam.getUrl().c_str() );
    if(qparam.paramcount())
      esyslog("live, get_recordings.ecpp, qparam[0] = %s", qparam[0].c_str() );

    esyslog("live, get_recordings.ecpp, r size = %d", (int)r.size());
    if (r.size() > 0)
      esyslog("live, get_recordings.ecpp, r[0] = %d", r[0]);
*/

    cToSvConcat<0> recording_item;
    recording_item.reserve(5000);
    size_t rec_size = RecordingsManager::all_recordings[(int)(RecordingsManager::eSortOrder::id)].size();
    for (int recording: r) {
      RecordingsItemRec *rPtr = nullptr;
      if ((size_t)recording < rec_size) rPtr = RecordingsManager::all_recordings[(int)(RecordingsManager::eSortOrder::id)][recording];
      if (rPtr) {
//      dsyslog("live, get_recordings.ecpp, write recording %d, rPtr->Id() %d", recording, rPtr->Id() );
        recording_item.clear();
        rPtr->AppendAsJSArray(recording_item);
        
  reply.out() << _tntChunks[4]; // recs[
#line 56 "get_recordings.ecpp"
  reply.out() << (cToSvInt(rPtr->Id()));
  reply.out() << _tntChunks[5]; // ]=[
#line 56 "get_recordings.ecpp"
  reply.out() << ( recording_item );
  reply.out() << _tntChunks[6]; // ]\n        
#line 57 "get_recordings.ecpp"

      } else esyslog("live ERROR, get_recordings.ecpp, recording %i not found", recording);
    }
  }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
