////////////////////////////////////////////////////////////////////////
// login.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.login")

// <%pre>
#line 1 "login.ecpp"


#include <setup.h>
#include <users.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("login");

static const char* rawData = "<\000\000\000=\000\000\000\257\000\000\000\274\000\000\000\275\000\000\000\?\001\000\000|"
  "\001\000\000\031\002\000\000[\002\000\000\231\002\000\000\007\003\000\000L\003\000\000\243\003\000\000\005\004\000"
  "\0009\004\000\000\n\n<html>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />"
  "\n    <title>VDR-Live - </title>\n    \n\n  </head>\n  <body onload=\"document.auth.login.focus()\">\n  <div class=\""
  "loginwin\">\n    <div class=\"boxheader\"><div class=\"caption\"></div></div>\n    <div class=\"login_content\">\n   "
  "   <img src=\"\" alt=\"VDR Live\" />\n      <form name=\"auth\">\n        <input type=\"hidden\" name=\"action\" valu"
  "e=\"login\" />\n        <input type=\"hidden\" name=\"redirect\" value=\"\" />\n        <table class=\"login\">\n    "
  "      <tr>\n            <td>:</td>\n            <td><input type=\"text\" name=\"login\" value=\"\" size=\"15\" maxlen"
  "gth=\"15\" /></td>\n            <td>&nbsp;</td>\n          </tr>\n          <tr>\n            <td>:</td>\n           "
  " <td><input type=\"password\" name=\"password\" value=\"\" size=\"15\" maxlength=\"15\" /></td>\n            <td><but"
  "ton class=\"login\" type=\"submit\"></button></td>\n          </tr>\n        </table>\n      </form>\n      <div clas"
  "s=\"message\">\n        \n      </div>\n    </div>\n  </div>\n  </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("login " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string login = qparam.get< std::string >("login");
std::string password = qparam.get< std::string >("password");
std::string action = qparam.get< std::string >("action");
std::string redirect = qparam.get< std::string >("redirect");
  // </%args>

#line 16 "login.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 18 "login.ecpp"


std::string message;
std::string targetUrl = qparam.has("redirect") && !redirect.empty() ? redirect : LiveSetup().GetStartScreenLink();

if (LiveSetup().CheckLocalNet(request.getPeerIp())) {
  logged_in = true;
  return reply.redirect(targetUrl);
}
if (action == "login") {
  if (Users.ValidLogin(login, password)) {
    logged_in = true;
    cUsers::logged_in_user = login;
  } else {
    message = tr("Wrong username or password");
  }
} else if (action == "logout") {
  logged_in = false;
  cUsers::logged_in_user = "";
}
if (logged_in || !LiveSetup().UseAuth()) return reply.redirect(targetUrl);


  reply.out() << _tntChunks[0]; // \n
  // <& pageelems.doc_type ...
  { 
#line 41 "login.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 41 "login.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 45 "login.ecpp"
  reply.sout() << ( tr("Login") );
  reply.out() << _tntChunks[2]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 46 "login.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 46 "login.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n  </head>\n  <body onload="document.auth.login.focus()">\n  <div class="loginwin">\n    <div class="boxheader"><div class="caption">
#line 53 "login.ecpp"
  reply.sout() << ( tr("VDR Live Login") );
  reply.out() << _tntChunks[5]; // </div></div>\n    <div class="login_content">\n      <img src="
#line 55 "login.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo_login.png") );
  reply.out() << _tntChunks[6]; // " alt="VDR Live" />\n      <form name="auth">\n        <input type="hidden" name="action" value="login" />\n        <input type="hidden" name="redirect" value="
#line 58 "login.ecpp"
  reply.sout() << ( targetUrl );
  reply.out() << _tntChunks[7]; // " />\n        <table class="login">\n          <tr>\n            <td>
#line 61 "login.ecpp"
  reply.sout() << ( tr("User") );
  reply.out() << _tntChunks[8]; // :</td>\n            <td><input type="text" name="login" value="
#line 62 "login.ecpp"
  reply.sout() << ( login );
  reply.out() << _tntChunks[9]; // " size="15" maxlength="15" /></td>\n            <td>&nbsp;</td>\n          </tr>\n          <tr>\n            <td>
#line 66 "login.ecpp"
  reply.sout() << ( tr("Password") );
  reply.out() << _tntChunks[10]; // :</td>\n            <td><input type="password" name="password" value="
#line 67 "login.ecpp"
  reply.sout() << ( password );
  reply.out() << _tntChunks[11]; // " size="15" maxlength="15" /></td>\n            <td><button class="login" type="submit">
#line 68 "login.ecpp"
  reply.sout() << ( tr("Login") );
  reply.out() << _tntChunks[12]; // </button></td>\n          </tr>\n        </table>\n      </form>\n      <div class="message">\n        
#line 73 "login.ecpp"
  reply.sout() << ( message );
  reply.out() << _tntChunks[13]; // \n      </div>\n    </div>\n  </div>\n  </body>\n</html>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
