////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}

std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" (");
      result.append(actor.role);
      result.append(")");
    }
  }
  return result;
}
bool getLanguage(std::string &language, const char *env_name) {
  const char *env_language = std::getenv(env_name);
  bool found = env_language && strlen(env_language) >= 2;
  if (found) language.append(env_language, 2);
  return found;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stream_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stream_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    hls_recording_type hls_recording;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    stream_recording_type stream_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\220\006\000\000\221\006\000\000\223\006\000\000\001\007\000\000\002\007\000\000\004\007"
  "\000\000\200\007\000\000\201\007\000\000\355\007\000\000\274\010\000\000\275\010\000\000\277\010\000\000\322\010\000"
  "\000\323\010\000\000\324\010\000\000\356\010\000\000\367\010\000\000\004\t\000\000!\t\000\000*\t\000\0001\t\000\000G"
  "\t\000\000H\t\000\000I\t\000\000K\t\000\000e\t\000\000f\t\000\000h\t\000\000t\t\000\000\215\t\000\000\221\t\000\000"
  "\223\t\000\000\241\t\000\000\261\t\000\000\262\t\000\000\264\t\000\000\267\t\000\000\273\t\000\000\275\t\000\000\320"
  "\t\000\000\327\t\000\000\331\t\000\000\332\t\000\000\347\t\000\000\356\t\000\000\365\t\000\000\376\t\000\000\377\t"
  "\000\000\001\n\000\000+\n\000\000-\n\000\000P\n\000\000R\n\000\000o\n\000\000v\n\000\000\177\n\000\000\207\n\000\000"
  "\210\n\000\000\212\n\000\000\251\n\000\000\267\n\000\000\276\n\000\000\307\n\000\000\317\n\000\000\320\n\000\000\322"
  "\n\000\000\355\n\000\000\373\n\000\000\002\013\000\000\013\013\000\000\023\013\000\000\024\013\000\000\026\013\000"
  "\0006\013\000\000M\013\000\000T\013\000\000]\013\000\000e\013\000\000f\013\000\000h\013\000\000q\013\000\000\210\013"
  "\000\000\217\013\000\000\230\013\000\000\234\013\000\000\241\013\000\000\242\013\000\000\243\013\000\000\245\013\000"
  "\000\277\013\000\000\300\013\000\000\321\013\000\000\330\013\000\000\341\013\000\000\345\013\000\000\352\013\000\000"
  "\353\013\000\000\355\013\000\000\361\013\000\000\362\013\000\000\025\014\000\000#\014\000\000*\014\000\0003\014\000"
  "\000;\014\000\000<\014\000\000>\014\000\000a\014\000\000o\014\000\000v\014\000\000\177\014\000\000\207\014\000\000"
  "\211\014\000\000\213\014\000\000\266\016\000\000\316\016\000\000\344\016\000\000\375\016\000\000\027\017\000\000/\017"
  "\000\000v\017\000\000\200\017\000\000\242\017\000\000\254\017\000\000\321\017\000\000\272\020\000\000$\021\000\000%"
  "\021\000\000'\021\000\000\244\021\000\000\365\022\000\000\025\023\000\000{\023\000\000\204\023\000\000\215\023\000"
  "\000\226\023\000\000\237\023\000\000\336\023\000\000\347\023\000\000\031\024\000\000\177\024\000\000\253\024\000\000"
  "\303\024\000\000\304\024\000\000\306\024\000\000\315\024\000\000\324\024\000\000\335\024\000\000\344\024\000\000\023"
  "\025\000\000,\025\000\0005\025\000\000C\025\000\000E\025\000\000\242\025\000\000\305\025\000\000\357\025\000\000\366"
  "\025\000\000\370\025\000\000\243\026\000\000\252\026\000\000\261\026\000\000\006\027\000\000\010\027\000\000-\027\000"
  "\000;\027\000\000G\027\000\000P\027\000\000_\027\000\000\260\027\000\000\264\027\000\000\270\027\000\000\311\027\000"
  "\000\312\027\000\000\314\027\000\000\357\027\000\000*\030\000\000[\030\000\000\217\030\000\000\224\030\000\000\317"
  "\030\000\000\007\031\000\000\013\031\000\000F\031\000\000}\031\000\000\202\031\000\000\275\031\000\000\365\031\000"
  "\000\372\031\000\000\016\032\000\000+\032\000\0002\032\000\000J\032\000\000j\032\000\000\261\032\000\000&\033\000\000"
  "\233\033\000\000\300\033\000\000\310\033\000\000\330\033\000\000\356\033\000\000\023\034\000\000\032\034\000\000P\034"
  "\000\000k\034\000\000m\034\000\000\204\034\000\000\206\034\000\000\216\034\000\000\262\034\000\000\271\034\000\000"
  "\372\034\000\000\036\035\000\000K\035\000\000o\035\000\000\217\035\000\000\254\035\000\000\340\035\000\000\004\036"
  "\000\000\034\036\000\000J\036\000\000i\036\000\000\201\036\000\000\257\036\000\000\316\036\000\000\350\036\000\000"
  "\351\036\000\000\031\037\000\000\032\037\000\000;\037\000\000M\037\000\000O\037\000\000[\037\000\000m\037\000\000\211"
  "\037\000\000\222\037\000\000\231\037\000\000\265\037\000\000\266\037\000\000\275\037\000\000\333\037\000\000\335\037"
  "\000\000\336\037\000\000\337\037\000\000\004 \000\000\007 \000\000\016 \000\000. \000\000/ \000\0002 \000\0009 \000"
  "\000W \000\000X \000\000_ \000\000\177 \000\000\200 \000\000\207 \000\000\261 \000\000\304 \000\000\312 \000\000\352 "
  "\000\000\027!\000\0007!\000\000^!\000\000r!\000\000\204!\000\000\220!\000\000\260!\000\000\327!\000\000\353!\000\000"
  "\375!\000\000\t\"\000\000)\"\000\000P\"\000\000d\"\000\000v\"\000\000\202\"\000\000\217\"\000\000\253\"\000\000\263\""
  "\000\000\272\"\000\000\326\"\000\000\335\"\000\000\000#\000\000\t#\000\000\020#\000\0006#\000\000H#\000\000S#\000\000"
  "o#\000\000r#\000\000y#\000\000\225#\000\000\235#\000\000\244#\000\000\300#\000\000\305#\000\000\314#\000\000\350#\000"
  "\000\351#\000\000\354#\000\000\363#\000\000\364#\000\000=$\000\000P$\000\000a$\000\000b$\000\000\200$\000\000\211$"
  "\000\000\220$\000\000\256$\000\000\266$\000\000\275$\000\000\276$\000\000\334$\000\000\335$\000\000\344$\000\000\350$"
  "\000\000\007%\000\000\020%\000\000\027%\000\000\030%\000\0006%\000\000a%\000\000\177%\000\000\244%\000\000\270%\000"
  "\000\312%\000\000\327%\000\000\367%\000\000\036&\000\0002&\000\000D&\000\000P&\000\000p&\000\000\227&\000\000\253&"
  "\000\000\275&\000\000\311&\000\000\324&\000\000\333&\000\000\345&\000\000\366&\000\000\023'\000\000^'\000\000\223'"
  "\000\000\232'\000\000\234'\000\000\332'\000\000\356'\000\000\000(\000\000((\000\000:(\000\000C(\000\000J(\000\000T("
  "\000\000f(\000\000g(\000\000h(\000\000p(\000\000z(\000\000\201(\000\000\271(\000\000\341(\000\000\342(\000\000\343("
  "\000\000\t)\000\000E)\000\000Q)\000\000R)\000\000T)\000\000\316)\000\000=*\000\000\246*\000\000\016+\000\000\177+\000"
  "\000$,\000\000\220,\000\000\372,\000\000i-\000\000\367-\000\000`.\000\000\213.\000\000\264.\000\000\337.\000\000 /"
  "\000\000\276/\000\000\324/\000\000\330/\000\000\346/\000\000\350/\000\000\351/\000\000\367/\000\000\371/\000\000\372/"
  "\000\000V0\000\000\3200\000\000\3460\000\000\3520\000\000\3700\000\000\3720\000\000\3730\000\000\t1\000\000\0131\000"
  "\000\0141\000\000h1\000\000\3331\000\000\3611\000\000\3651\000\000\0032\000\000\0052\000\000\0062\000\000\0242\000"
  "\000\0262\000\000\0272\000\000o2\000\000\3052\000\000\3455\000\000.6\000\000\3606\000\000\n\n\n<!DOCTYPE html PUBLIC "
  "\"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n\n\n\n<script type=\"tex"
  "t/javascript\" src=\"js/live/createHtml.js\"></script>\n<script type=\"text/javascript\" src=\"js.html\"></script>\n"
  "\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/styles.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" hr"
  "ef=\"\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/siteprefs.css\"/>\n<script type=\"text/javascript\" "
  "src=\"js/live/scrolling.js\"></script>\n<script type=\"text/javascript\" src=\"js/live/epg_tt_box.js\"></script>\n\n"
  "\n\n\n<div id=\"header\">\n\n\n<div class=\"page_header\">\n<a href=\"\">\n<img src=\"\" alt=\"VDR Live!\" class=\"lo"
  "go\" /></a>\n</div>\n<div id=\"navigation\">\n\n\n\n\nstyle=\"visibility: hidden\"\n\n\n<div class=\"\"><div class=\""
  "__elapsed\" id=\"\" style=\"width: %\"></div></div>\n\n\n\n<a id=\"\"  href=\"vdr_request/\?param=\"  ><img class=\""
  "\" src=\"\" alt=\"\" /></a>\n\n\n\n<a href=\"http://www.imdb.com/find\?s=all&q=\"\n<a href=\"http://www.imdb.com/titl"
  "e/\"\n target=\"_blank\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"stream.html\?channelid=\"><img cl"
  "ass=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"stream.html\?recid=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n"
  "\n\n\n<a href=\"playlist.m3u\?channelid=\" download><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"\" dow"
  "nload><img class=\"\" src=\"\" alt=\"\"  /> </a>\n\n\n\n\n<a href=\"http://localhost:/.ts\"><img class=\"\" src=\"\" "
  "alt=\"\"  /> </a>\n\n\n\n    \n    <a href=\"edit_timer.html\?epgid=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n"
  "\n\n  <a href=\"edit_timer.html\?timerid=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n\n  <script type=\"text/"
  "javascript\" src=\"js/mootools/mootools.v1.11.js\"></script>\n  <script type=\"text/javascript\" src=\"js/live/liveaj"
  "ax.js\"></script>\n  <script type=\"text/javascript\" src=\"js/live/infowin.js\"></script>\n  <script type=\"text/jav"
  "ascript\" src=\"js/live/hinttips.js\"></script>\n  <script type=\"text/javascript\" src=\"js/live/browserwin.js\"></s"
  "cript>\n  <script type=\"text/javascript\" src=\"js/live/pageenhance.js\"></script>\n  <script type=\"text/javascript"
  "\"><!--\n    var liveEnhanced = new PageEnhance({\n        infoWinOptions: {\n          resizeImg: '',\n          clo"
  "seImg: '',\n          pinImg: '',\n          pinnedImg: '',\n          loadingMsg: '',\n          errorMsg: ''\n     "
  "   },\n        notifyStrings: {\n          successMsg: '<img src=\"\" alt=\"\"> ',\n          errorMsg: '<img src=\""
  "\" alt=\"\"> '\n        }\n      });\n  --></script>\n  <script type=\"text/javascript\" src=\"js/live/vdr_status.js"
  "\"></script>\n  <script type=\"text/javascript\"><!--\n    var InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n   "
  " window.addEvent('domready', function(){\n      InfoBox.request();\n    });\n    window.addEvent('unload', function()"
  "{\n      InfoBox.pageFinished();\n    });\n  --></script>\n\n\n\n<div id=\"infobox\">\n  <div class=\"statuscontent\""
  ">\n    <div class=\"st_header\">\n      <div id=\"infobox_caption\" class=\"caption\"></div>\n      <div id=\"infobox"
  "_timenow\" class=\"now\">--:--</div>\n    </div>\n    <div class=\"st_content\">\n      <div id=\"infobox_name\" clas"
  "s=\"name\"></div>\n      <div id=\"infobox_duration\" class=\"duration\">--:--</div>\n    </div>\n    <div class=\"st"
  "_controls\">\n      <div class=\"st_update\">\n        <a href=\"javascript:InfoBox.toggleUpdate()\" ><img id=\"statu"
  "sReloadBtn\" src=\"\" alt=\"\" /></a>\n      </div>\n      <div id=\"infobox_recording_buttons\" style=\"display: non"
  "e\">\n        \n        \n        \n        \n        \n      </div>\n      <div id=\"infobox_channel_buttons\">\n   "
  "     \n        \n      </div>\n      <div class=\"st_pbar\">\n        \n      </div>\n    </div>\n  </div>\n  <div st"
  "yle=\"display: none;\">\n    <span id=\"__infobox_request_err\"></span>\n    <span id=\"__infobox_update_err\"></span"
  ">\n  </div>\n</div>\n\n\n\n  <div></div>\n    <div></div>\n  <div><a href=\"searchresults.html\?searchplain=\"><img c"
  "lass=\"icon\" src=\"\" alt=\"\"  /></a></div>\n  \n  <div class=\"hidden-xs spacer\"><img class=\"icon\" src=\"img/tr"
  "ansparent.png\" alt=\"\" /></div>\n  <div class=\"hidden-xs invisible\"></div>\n  <div class=\"hidden-xs invisible\">"
  "</div>\n  \n  <div class=\"hidden-xs\"><img class=\"icon\" src=\"img/transparent.png\" alt=\"\" /></div>\n  <div clas"
  "s=\"hidden-xs\"><img class=\"icon\" src=\"img/transparent.png\" alt=\"\" /></div>\n  <div></div>\n  <div class=\"hidd"
  "en-xs\"><img class=\"icon\" src=\"img/transparent.png\" alt=\"\" /></div>\n  \n  <div class=\"notpresent xs-visible- "
  "xs-invisible- xs-columns-\"></div>\n<div id=\"icons-\" class=\"event_status\"></div>\n<script class=\"injectIcons\">"
  "\ninjectHdSdIcon(\"icons-\", \"\", \"\", \"\")\n</script>\n\n\n\n  <div class=\"epg_description\" id=\"\">\n    <div "
  "class=\"station\">\n      <div class=\"boxheader\">\n        <div class = \"caption\">\n          <a id=\"_epg_m\"   "
  "  class = \"active\"   onclick=\"displayEPG('')\" ></a>\n          <span class=\"sep\">|</span>\n          <a id=\"_s"
  "craper_m\" class = \"inactive\" onclick=\"displayScraper('')\"></a>\n          <span class=\"sep\">|</span>\n        "
  "  <a id=\"_actors_m\"  class = \"inactive\" onclick=\"displayActors('')\" ></a>\n          <span class=\"sep\">|</spa"
  "n>\n          <a id=\"_artwork_m\" class = \"inactive\" onclick=\"displayArtwork('')\" ></a>\n        </div>\n       "
  " <div class=\"caption\"></div>\n      </div>\n    </div>\n    <div class=\"epg_content epg_\">\n      <div class=\"ep"
  "g_tools\">\n        <div class=\"tools\">\n          \n        </div>\n      </div>\n      <div class=\"epg_info\">\n"
  "        <div class=\"info\">\n          <div class=\"spacebar\"></div>\n          <div class=\"event_details\">\n    "
  "        <div class=\"time_channel\">\n              <div class=\"time\">\n                  <span class=\"bold\"></sp"
  "an>\n                \n              </div>\n                <div class=\"channel\"></div>\n            </div>\n     "
  "       <div class=\"duration\">\n              <span title=\"\"></span> / <span title=\"\"></span>\n              <di"
  "v class=\"progress\"></div>\n            </div>\n          </div>\n          <div class=\"title\"></div>\n          <"
  "div class=\"short\"></div>\n          <div class=\"description\" id=_description>\n          <span id = \"_epg_image"
  "\" class=\"epg_images\">\n         <a href=\"/epgimages/\" target=\"_blank\">\n            <img src=\"/epgimages/\" c"
  "lass=\"epg_image\"/>\n         </a>\n    <a href=\"/tvscraper/\" target=\"_blank\">\n      <img src=\"/tvscraper/\" c"
  "lass=\"epg_image\"/>\n    </a>\n    <a href=\"/tvscraper/\" target=\"_blank\">\n      <img src=\"/tvscraper/\" class="
  "\"epg_image\"/>\n    </a>\n      <a href=\"/recimages//\" target=\"_blank\">\n        <img src=\"/recimages//\" class"
  "=\"epg_image\"/>\n      </a>\n          </span> \n\n\n<div id = '_scraper' hidden>\n  <div class=\"scraper_list\">   "
  "      </div>\n  <div class=\"scraper_list\"> </div>\n    <div class=\"scraper_list\"> SE </div>\n    <div class=\"scr"
  "aper_list\">   </div>\n      <div class=\"scraper_list\">  / </div>\n    <div class=\"scraper_list\"> </div>\n      <"
  "div class=\"scraper_list\"> </div>\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n      <di"
  "v class=\"scraper_list\"></div>\n      <div class=\"cast_crew tabular\">\n        <div class=\"cast_role\">  </div>\n"
  "        <div> <a href=\"https://.wikipedia.org/wiki/\" target=\"_blank\"></a> </div>\n        <div class=\"cast_role"
  "\">  </div>\n        <div> <a href=\"https://.wikipedia.org/wiki/\" target=\"_blank\"></a> </div>\n        <div class"
  "=\"cast_role\">  </div>\n        <div> <a href=\"https://.wikipedia.org/wiki/\" target=\"_blank\"></a> </div>\n      "
  "</div>\n  <div class=\"scraper_list\">        </div>\n  <div class=\"scraper_list\">       </div>\n  <div class=\"scr"
  "aper_list\">         </div>\n  <div class=\"scraper_list\"><a href =\"\" target=\"_blank\"></a></div>\n  <div class="
  "\"scraper_list\">   </div>\n  <div class=\"scraper_list\">        </div>\n  <div class=\"scraper_list\">     </div>\n"
  "  <div class=\"scraper_list\">  / </div>\n\n    <div class=\"scraper_list\">\n      <a href=\"https://www.imdb.com/ti"
  "tle/\" target=\"_blank\">  </a>\n    </div>\n\n    <div class=\"scraper_list\">         </div>\n    <div class=\"scra"
  "per_list\">        </div>\n\n    <div class=\"scraper_list\"> </div>\n    \n    <div class=\"scraper_list\">         "
  "</div>\n\n    <div class=\"scraper_list\"></div>\n    <div class=\"cast_crew tabular\">\n      <div class=\"cast_role"
  "\">  </div>\n      <div> <a href=\"https://.wikipedia.org/wiki/\" target=\"_blank\"></a>  </div>\n        <div class="
  "\"cast_role\">  </div>\n        <div> <a href=\"https://.wikipedia.org/wiki/\" target=\"_blank\"></a> </div>\n       "
  " <div class=\"cast_role\">  </div>\n        <div> <a href=\"https://.wikipedia.org/wiki/\" target=\"_blank\"></a> </d"
  "iv>\n    </div>\n</div>\n\n<div id=\"_actors\" hidden>\n  <div class=\"event_actors\">\n    <div class=\"actor\">\n  "
  "    <div class=\"actor_photo\"><a href=\"/tvscraper/\" target=\"_blank\"><img class=\"photo\" src=\"/tvscraper/\" alt"
  "=\": \" /></a></div>\n      <div class=\"actor_name\"><a href=\"https://.wikipedia.org/wiki/\" target=\"_blank\"></a>"
  "</div>\n      <div class=\"character\"></div>\n    </div>\n  </div>\n</div>\n\n<div id=\"_artwork\" hidden>\n\n\n\n</"
  "div>\n\n<div id=\"_epg\">\n        </div>\n      </div>\n      <div class=\"spacebar\"></div></div>\n    </div>\n  </"
  "div>\n</div>\n\n\n  <a class=\"artwork\" href=\"/tvscraper/\" target=\"_blank\">\n    <img class=\"artwork\" src=\"/t"
  "vscraper/\" />\n  </a>\n\n\n\n  <div class=\"epg_description\" id=\"aboutBox\">\n    <div class=\"station\">\n      <"
  "div class=\"boxheader\"><div class=\"caption\"></div></div>\n    </div>\n    <div class=\"epg_content\"><div class=\""
  "about_content\">\n      <div class=\"about_head\"></div>\n      <div class=\"about_section\">\n        <div class=\"t"
  "abular\">\n          <div class=\"about_left\">:</div>\n          <div class=\"about_right\">Thomas Keil (Thomas)</di"
  "v>\n          <div class=\"about_left\">:</div>\n          <div class=\"about_right\">Sascha Volkenandt (LordJaxom)</"
  "div>\n          <div class=\"about_left\">:</div>\n          <div class=\"about_right\">Markus Ehrnsperger (MarkusE @"
  " <a href=\"https://www.vdr-portal.de\">VDR Portal</a>)</div>\n          <div class=\"about_left\">:</div>\n          "
  "<div class=\"about_right\">Jasmin Jessich (jasminj)</div>\n          <div class=\"about_left\">:</div>\n          <di"
  "v class=\"about_right\">Dieter Hametner (tadi)</div>\n          <div class=\"about_left\">:</div>\n          <div cla"
  "ss=\"about_right\">Christian Wieninger (winni)</div>\n          <div class=\"about_left\">:</div>\n          <div cla"
  "ss=\"about_right\">Michael Br&uuml;ckner (skiller2k1)</div>\n        </div>\n      </div>\n      <div class=\"about_h"
  "ead\"></div>\n      <div class=\"about_section\">\n        <div class=\"tabular\">\n          <div class=\"about_left"
  "\">:</div>\n          <div class=\"about_right\"></div>\n          <div class=\"about_left\">:</div>\n          <div "
  "class=\"about_right\"></div>\n        </div>\n      </div>\n      <div class=\"about_head\"></div>\n      <div class="
  "\"about_section\">\n        <div class=\"tabular\">\n          <div class=\"about_left\">EPGsearch:</div>\n          "
  "<div class=\"about_right\">\n            <img src=\"\"/>\n              : \n              : \n            (<a href=\""
  "https://github.com/vdr-projects/vdr-plugin-epgsearch\" target=\"_blank\"></a>)<br/>\n          </div>\n          <div"
  " class=\"about_left\">Streamdev server:</div>\n          <div class=\"about_right\">\n            <img src=\"\"/>\n  "
  "            : \n              : \n            (<a href=\"https://github.com/vdr-projects/vdr-plugin-streamdev\" targe"
  "t=\"_blank\"></a>)<br/>\n          </div>\n          <div class=\"about_left\">tvscraper:</div>\n          <div class"
  "=\"about_right\">\n            <img src=\"\"/>\n              : \n              : \n            (<a href=\"https://gi"
  "thub.com/MarkusEh/vdr-plugin-tvscraper\" target=\"_blank\"></a>)<br/>\n          </div>\n        </div>\n      </div>"
  "\n      <div class=\"about_head\"></div>\n      <div class=\"about_section\">\n        <div class=\"about_line\">Movi"
  "e information provided by <a target=\"_blank\" href=\"https://www.themoviedb.org/\">TMDB</a>. This product uses the T"
  "MDB API but is not endorsed or certified by TMDB.</div>\n        <div class=\"about_line\">Information provided by Th"
  "eTVDB.com. Please consider <a target=\"_blank\" href=\"https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2B"
  "ZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMr"
  "tJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8C"
  "H7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D\">supporting them.</a></div>\n      </d"
  "iv>\n      <div class=\"about_head\"></div>\n      <div class=\"about_section\">\n        <div class=\"about_line\">:"
  "<br/>\n          <a target=\"_blank\" href=\"https://github.com/MarkusEh/vdr-plugin-live/issues\">https://github.com/"
  "MarkusEh/vdr-plugin-live/issues</a></div>\n      </div>\n    </div></div>\n  </div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    hls_recording(*this, "hls_recording"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    stream_recording(*this, "stream_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[6]; // \n
  reply.out() << _tntChunks[9]; // \n
  reply.out() << _tntChunks[10]; // \n\n
  reply.out() << _tntChunks[22]; // \n
  reply.out() << _tntChunks[23]; // \n\n
  reply.out() << _tntChunks[25]; // \n
  reply.out() << _tntChunks[26]; // \n\n
  reply.out() << _tntChunks[33]; // \n
  reply.out() << _tntChunks[34]; // \n\n
  reply.out() << _tntChunks[46]; // \n
  reply.out() << _tntChunks[47]; // \n\n
  reply.out() << _tntChunks[56]; // \n
  reply.out() << _tntChunks[57]; // \n\n
  reply.out() << _tntChunks[63]; // \n
  reply.out() << _tntChunks[64]; // \n\n
  reply.out() << _tntChunks[70]; // \n
  reply.out() << _tntChunks[71]; // \n\n
  reply.out() << _tntChunks[77]; // \n
  reply.out() << _tntChunks[78]; // \n\n
  reply.out() << _tntChunks[85]; // \n
  reply.out() << _tntChunks[86]; // \n
  reply.out() << _tntChunks[87]; // \n\n
  reply.out() << _tntChunks[95]; // \n
  reply.out() << _tntChunks[96]; // \n\n
  reply.out() << _tntChunks[104]; // \n
  reply.out() << _tntChunks[105]; // \n\n
  reply.out() << _tntChunks[111]; // \n\n
  reply.out() << _tntChunks[112]; // \n\n
  reply.out() << _tntChunks[126]; // \n
  reply.out() << _tntChunks[127]; // \n\n
  reply.out() << _tntChunks[142]; // \n
  reply.out() << _tntChunks[143]; // \n\n
  reply.out() << _tntChunks[172]; // \n
  reply.out() << _tntChunks[173]; // \n\n
  reply.out() << _tntChunks[363]; // \n
  reply.out() << _tntChunks[364]; // \n
  reply.out() << _tntChunks[368]; // \n
  reply.out() << _tntChunks[369]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[5]; // <script type="text/javascript" src="js/live/createHtml.js"></script>\n<script type="text/javascript" src="js.html"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[7]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 64 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[8]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/scrolling.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[11]; // \n<div id="header">\n
  reply.out() << _tntChunks[12]; // \n
  reply.out() << _tntChunks[13]; // \n
#line 77 "pageelems.ecpp"

  bool showLogo = LiveSetup().GetShowLogo();
  bool showInfoBox = LiveSetup().GetShowInfoBox();
  if (showLogo || showInfoBox) {

  reply.out() << _tntChunks[14]; // <div class="page_header">\n
#line 83 "pageelems.ecpp"

    if (showLogo) {

  reply.out() << _tntChunks[15]; // <a href="
#line 86 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[16]; // ">\n<img src="
#line 87 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[17]; // " alt="VDR Live!" class="logo
#line 87 "pageelems.ecpp"
  if ( showInfoBox )
    reply.sout() <<  " with-infobox" ;
  reply.out() << _tntChunks[18]; // " /></a>\n
#line 88 "pageelems.ecpp"

    }

#line 91 "pageelems.ecpp"
if (showInfoBox) { 
  // <& infobox ...
  { 
#line 91 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 91 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 91 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[19]; // </div>\n
#line 93 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[20]; // <div id="navigation">\n
  reply.out() << _tntChunks[21]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 106 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[24]; // style="visibility: hidden"
#line 106 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 117 "pageelems.ecpp"

  std::string cls("__progress");
  if ((duration >= 0) && ((progress < 0) || (duration == 0)))
    cls +="_invisible";

  reply.out() << _tntChunks[27]; // <div class="
#line 122 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[28]; // "><div class="__elapsed" 
#line 122 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[29]; // id="
#line 122 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[30]; // " 
#line 122 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[31]; // style="width: 
#line 122 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[32]; // %"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 138 "pageelems.ecpp"

bool isVisible = id.empty();
int *pCounter = static_cast<int *>((void *)iCounter);
if (pCounter && isVisible) (*pCounter)++;

  reply.out() << _tntChunks[35]; // <a 
#line 143 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[36]; // id="
#line 143 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[37]; // " 
#line 143 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 143 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 143 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (isVisible ? 0 : 1));
#line 143 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[38]; //  href="vdr_request/
#line 143 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[39]; // \?param=
#line 143 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[40]; // " 
#line 143 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 143 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 143 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 143 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[41]; //  
#line 143 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[42]; // ><img class="
#line 143 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[43]; // " src="
#line 143 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[44]; // " alt="
#line 143 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[45]; // " /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 155 "pageelems.ecpp"

// generation of IMDb link to be checked here, otherwise inconsistent
if (LiveSetup().GetShowIMDb())
{
  int *pCounter = static_cast<int *>((void *)iCounter);
  if (pCounter) (*pCounter)++;
  if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[48]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 162 "pageelems.ecpp"
  reply.sout() << ( (!title.empty() && title[0] == '%')?cToSvUrlEscaped(cSv(title).substr(1)):cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[49]; // "\n
#line 163 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[50]; // <a href="http://www.imdb.com/title/
#line 164 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[51]; // "\n
#line 165 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[52]; //  target="_blank"><img class="
#line 166 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[53]; // " src="
#line 166 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[54]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 166 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 166 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 166 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[55]; //  /></a>\n
#line 167 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 180 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {
  int *pCounter = static_cast<int *>((void *)iCounter);
  if (pCounter) (*pCounter)++;

  reply.out() << _tntChunks[58]; // <a href="stream.html\?channelid=
#line 185 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[59]; // "><img class="
#line 185 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[60]; // " src="
#line 185 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[61]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 185 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 185 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 185 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[62]; //  /></a>\n
#line 186 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recId = qparam.get< std::string >("recId");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 199 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {
  int *pCounter = static_cast<int *>((void *)iCounter);
  if (pCounter) (*pCounter)++;

  reply.out() << _tntChunks[65]; // <a href="stream.html\?recid=
#line 204 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[66]; // "><img class="
#line 204 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[67]; // " src="
#line 204 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[68]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 204 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 204 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this recording into browser.")));
#line 204 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[69]; //  /></a>\n
#line 205 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 218 "pageelems.ecpp"

if (LiveFeatures<features::streamdev_server>().Loaded()) {
  int *pCounter = static_cast<int *>((void *)iCounter);
  if (pCounter) (*pCounter)++;

  reply.out() << _tntChunks[72]; // <a href="playlist.m3u\?channelid=
#line 223 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[73]; // " download><img class="
#line 223 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[74]; // " src="
#line 223 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[75]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 223 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 223 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this channel into media player.")));
#line 223 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[76]; //  /></a>\n
#line 224 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 238 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
// <a href="intent://my.example.com:8080/test.mp4#Intent;scheme=http;package=org.videolan.vlc;end">OPEN IN VLC</a>

// std::string server = request.getHost();
// server = server.substr(0, server.rfind(':'));
// cToSvConcat url("intent://", server, ":", LiveSetup().GetServerPort(), "/recstream.html?recid=", recid, "#Intent;scheme=http;package=org.videolan.vlc;end");

int *pCounter = static_cast<int *>((void *)iCounter);
if (pCounter) (*pCounter)++;

cToSvConcat url("playlist.m3u?recid=", recid);
{

  reply.out() << _tntChunks[79]; // <a href="
#line 251 "pageelems.ecpp"
  reply.sout() << ( url );
  reply.out() << _tntChunks[80]; // " download><img class="
#line 251 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[81]; // " src="
#line 251 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[82]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 251 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 251 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording into media player.")));
#line 251 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[83]; //  /> 
#line 251 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[84]; // </a>\n
#line 252 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stream_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stream_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 268 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
cToSvConcat rfid;
{
  const cRecording* recording = nullptr;
  LOCK_RECORDINGS_READ
  if (!recid.empty()) recording = RecordingsManager::GetByHash(recid, Recordings);
  if (recording) {
    struct stat st;
    if (stat(recording->FileName(), &st) == 0)
      rfid.appendFormated("%lu:%llu.rec", (unsigned long) st.st_dev, (unsigned long long) st.st_ino);
  }
}
if (!rfid.empty() ) {
  int *pCounter = static_cast<int *>((void *)iCounter);
  if (pCounter) (*pCounter)++;

  reply.out() << _tntChunks[88]; // <a href="http://localhost:
#line 284 "pageelems.ecpp"
  reply.sout() << (cToSvConcat(LiveSetup().GetStreamdevPort()));
  reply.out() << _tntChunks[89]; // /
#line 284 "pageelems.ecpp"
  reply.sout() << (rfid);
  reply.out() << _tntChunks[90]; // .ts"><img class="
#line 284 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[91]; // " src="
#line 284 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[92]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 284 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 284 "pageelems.ecpp"
    _tnt_cq8.add( "text", (tr("Stream this recording.")));
#line 284 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[93]; //  /> 
#line 284 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[94]; // </a>\n
#line 285 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 299 "pageelems.ecpp"

  tChannelID channelid;
  tEventID eventid;
  EpgEvents::DecodeDomId(epgid, channelid, eventid);
  std::string timerId;
  bool timerRecording = false;
  bool timerActive = true;
  {
    LOCK_TIMERS_READ;
    const cTimer* timer = TimerManager::GetTimer(eventid, channelid, Timers);
    if (timer) {
      timerId = SortedTimers::GetTimerId(*timer);
      timerRecording = timer->Recording();
      timerActive = timer->Flags() & tfActive;
    }
  }
  if (!timerId.empty() ) {

  reply.out() << _tntChunks[97]; //     
  // <& pageelems.edit_timer ...
  { 
#line 317 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 317 "pageelems.ecpp"
    _tnt_cq9.add( "className", (timerRecording ? "icon fading" : "icon"));
#line 317 "pageelems.ecpp"
    _tnt_cq9.add( "className", (className));
#line 317 "pageelems.ecpp"
    _tnt_cq9.add( "iCounter", (iCounter));
#line 317 "pageelems.ecpp"
    _tnt_cq9.add( "imgName", (timerRecording || timerActive? "record_timer_active.png" : "record_timer_inactive.png"));
#line 317 "pageelems.ecpp"
    _tnt_cq9.add( "timerId", (timerId));
#line 317 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[98]; // \n
#line 318 "pageelems.ecpp"

  } else {
    int *pCounter = static_cast<int *>((void *)iCounter);
    if (pCounter) (*pCounter)++;

  reply.out() << _tntChunks[99]; //     <a href="edit_timer.html\?epgid=
#line 323 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[100]; // "><img class="
#line 323 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[101]; // " src="
#line 323 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[102]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 323 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 323 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Record this")));
#line 323 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[103]; //  /></a>\n
#line 324 "pageelems.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
std::string className = qparam.get< std::string >("className");
uintptr_t iCounter = qparam.get< uintptr_t >("iCounter", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 338 "pageelems.ecpp"

  int *pCounter = static_cast<int *>((void *)iCounter);
  if (pCounter) (*pCounter)++;

  reply.out() << _tntChunks[106]; //   <a href="edit_timer.html\?timerid=
#line 342 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[107]; // "><img class="
#line 342 "pageelems.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[108]; // " src="
#line 342 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[109]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 342 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 342 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Edit timer")));
#line 342 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[110]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[113]; //   <script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n  <script type="text/javascript" src="js/live/liveajax.js"></script>\n  <script type="text/javascript" src="js/live/infowin.js"></script>\n  <script type="text/javascript" src="js/live/hinttips.js"></script>\n  <script type="text/javascript" src="js/live/browserwin.js"></script>\n  <script type="text/javascript" src="js/live/pageenhance.js"></script>\n  <script type="text/javascript"><!--\n    var liveEnhanced = new PageEnhance({\n        infoWinOptions: {\n          resizeImg: '
#line 358 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "resize.png") );
  reply.out() << _tntChunks[114]; // ',\n          closeImg: '
#line 359 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "icon_overlay_cross.png") );
  reply.out() << _tntChunks[115]; // ',\n          pinImg: '
#line 360 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "icon_overlay_pin.png") );
  reply.out() << _tntChunks[116]; // ',\n          pinnedImg: '
#line 361 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "icon_overlay_pinned.png") );
  reply.out() << _tntChunks[117]; // ',\n          loadingMsg: '
#line 362 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[118]; // ',\n          errorMsg: '
#line 363 "pageelems.ecpp"
  reply.sout() << ( tr("an error occurred!") );
  reply.out() << _tntChunks[119]; // '\n        },\n        notifyStrings: {\n          successMsg: '<img src="
#line 366 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[120]; // " alt=""> 
#line 366 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[121]; // ',\n          errorMsg: '<img src="
#line 367 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[122]; // " alt=""> 
#line 367 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[123]; // '\n        }\n      });\n  --></script>\n
#line 371 "pageelems.ecpp"

    if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[124]; //   <script type="text/javascript" src="js/live/vdr_status.js"></script>\n  <script type="text/javascript"><!--\n    var InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n    window.addEvent('domready', function(){\n      InfoBox.request(
#line 378 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[125]; // );\n    });\n    window.addEvent('unload', function(){\n      InfoBox.pageFinished();\n    });\n  --></script>\n
#line 384 "pageelems.ecpp"

    }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[128]; // <div id="infobox">\n  <div class="statuscontent">\n    <div class="st_header">\n      <div id="infobox_caption" class="caption">
#line 395 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[129]; // </div>\n      <div id="infobox_timenow" class="now">--:--</div>\n    </div>\n    <div class="st_content">\n      <div id="infobox_name" class="name"></div>\n      <div id="infobox_duration" class="duration">--:--</div>\n    </div>\n    <div class="st_controls">\n      <div class="st_update">\n        <a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 404 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 404 "pageelems.ecpp"
    _tnt_cq12.add( "text", (tr("Toggle updates on/off.")));
#line 404 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[130]; // ><img id="statusReloadBtn" src="
#line 404 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[131]; // " alt="" /></a>\n      </div>\n      <div id="infobox_recording_buttons" style="display: none">\n        
  // <& ajax_action_href ...
  { 
#line 407 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 407 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("stop_recording"));
#line 407 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_stop"));
#line 407 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("stop.png"));
#line 407 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("stop playback")));
#line 407 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[132]; // \n        
  // <& ajax_action_href ...
  { 
#line 408 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 408 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("play_recording"));
#line 408 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_play"));
#line 408 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("play.png"));
#line 408 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("resume playback")));
#line 408 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[133]; // \n        
  // <& ajax_action_href ...
  { 
#line 409 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 409 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("pause_recording"));
#line 409 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_pause"));
#line 409 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("pause.png"));
#line 409 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("pause playback")));
#line 409 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[134]; // \n        
  // <& ajax_action_href ...
  { 
#line 410 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 410 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("rwd_recording"));
#line 410 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_rwd"));
#line 410 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("rwd.png"));
#line 410 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast rewind")));
#line 410 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[135]; // \n        
  // <& ajax_action_href ...
  { 
#line 411 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 411 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("ffw_recording"));
#line 411 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_ffw"));
#line 411 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("ffw.png"));
#line 411 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("fast forward")));
#line 411 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[136]; // \n      </div>\n      <div id="infobox_channel_buttons">\n        
  // <& ajax_action_href ...
  { 
#line 414 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 414 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 414 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_prevchan"));
#line 414 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_downarrow.png"));
#line 414 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("previous channel")));
#line 414 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[137]; // \n        
  // <& ajax_action_href ...
  { 
#line 415 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 415 "pageelems.ecpp"
    _tnt_cq19.add( "action", ("switch_channel"));
#line 415 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_nextchan"));
#line 415 "pageelems.ecpp"
    _tnt_cq19.add( "image", ("one_uparrow.png"));
#line 415 "pageelems.ecpp"
    _tnt_cq19.add( "tip", (tr("next channel")));
#line 415 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[138]; // \n      </div>\n      <div class="st_pbar">\n        
  // <& progressbar ...
  { 
#line 418 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 418 "pageelems.ecpp"
    _tnt_cq20.add( "id", ("infobox_elapsed"));
#line 418 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[139]; // \n      </div>\n    </div>\n  </div>\n  <div style="display: none;">\n    <span id="__infobox_request_err">
#line 423 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[140]; // </span>\n    <span id="__infobox_update_err">
#line 424 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[141]; // </span>\n  </div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 441 "pageelems.ecpp"

  int duration = EpgEvents::Duration(startTime, endTime);
  int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
  tEventID eventId = tEventID();
  tChannelID channelId = tChannelID();
  int xsVisibleIcons = 0;
  int xsInvisibleIcons = 0;

  // using a flexbox, we do not have to differentiate between horizontal and vertical display;
  // for insertion in tables (detail == 0), we need to provide spacers for actions items being
  // temporarily unavailable, like actions for transient events
  EpgEvents::DecodeDomId(epgid, channelId, eventId);

  reply.out() << _tntChunks[144]; //   <div>
  // <& pageelems.event_timer ...
  { 
#line 454 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 454 "pageelems.ecpp"
    _tnt_cq21.add( "className", "icon");
#line 454 "pageelems.ecpp"
    _tnt_cq21.add( "epgid", (epgid));
#line 454 "pageelems.ecpp"
    _tnt_cq21.add( "iCounter", ((uintptr_t)&xsVisibleIcons));
#line 454 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[145]; // </div>\n
#line 455 "pageelems.ecpp"
 if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[146]; //     <div>
  // <& pageelems.ajax_action_href ...
  { 
#line 456 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 456 "pageelems.ecpp"
    _tnt_cq22.add( "action", "switch_channel");
#line 456 "pageelems.ecpp"
    _tnt_cq22.add( "alt", "");
#line 456 "pageelems.ecpp"
    _tnt_cq22.add( "className", "icon");
#line 456 "pageelems.ecpp"
    _tnt_cq22.add( "iCounter", ((uintptr_t)&xsVisibleIcons));
#line 456 "pageelems.ecpp"
    _tnt_cq22.add( "image", "zap.png");
#line 456 "pageelems.ecpp"
    _tnt_cq22.add( "param", (channelId));
#line 456 "pageelems.ecpp"
    _tnt_cq22.add( "tip", (tr("Switch to this channel.")));
#line 456 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[147]; // </div>\n
#line 457 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent()) {

#line 458 "pageelems.ecpp"
     if (eventId != 0) {

#line 459 "pageelems.ecpp"
       xsVisibleIcons++;

  reply.out() << _tntChunks[148]; //   <div><a href="searchresults.html\?searchplain=
#line 460 "pageelems.ecpp"
  reply.out() << ( cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[149]; // "><img class="icon" src="
#line 460 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[150]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 460 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 460 "pageelems.ecpp"
    _tnt_cq23.add( "text", (tr("Search for repeats.")));
#line 460 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[151]; //  /></a></div>\n
#line 461 "pageelems.ecpp"
     } else if (!detail) {

  reply.out() << _tntChunks[152]; //   
  reply.out() << _tntChunks[153]; // \n  <div class="hidden-xs spacer"><img class="icon" src="img/transparent.png" alt="" /></div>\n
#line 464 "pageelems.ecpp"
     }

#line 465 "pageelems.ecpp"
 } if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[154]; //   <div class="hidden-xs invisible">
  // <& pageelems.hls_channel ...
  { 
#line 466 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 466 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 466 "pageelems.ecpp"
    _tnt_cq24.add( "className", "icon");
#line 466 "pageelems.ecpp"
    _tnt_cq24.add( "iCounter", ((uintptr_t)&xsInvisibleIcons));
#line 466 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[155]; // </div>\n  <div class="hidden-xs invisible">
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 467 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 467 "pageelems.ecpp"
    _tnt_cq25.add( "channelId", (channelId));
#line 467 "pageelems.ecpp"
    _tnt_cq25.add( "className", "icon");
#line 467 "pageelems.ecpp"
    _tnt_cq25.add( "iCounter", ((uintptr_t)&xsInvisibleIcons));
#line 467 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[156]; // </div>\n
#line 468 "pageelems.ecpp"
  } else if (!detail) {

  reply.out() << _tntChunks[157]; //   
  reply.out() << _tntChunks[158]; // \n  <div class="hidden-xs"><img class="icon" src="img/transparent.png" alt="" /></div>\n  <div class="hidden-xs"><img class="icon" src="img/transparent.png" alt="" /></div>\n
#line 472 "pageelems.ecpp"
 } if (!title.empty()) {

  reply.out() << _tntChunks[159]; //   <div>
  // <& pageelems.imdb_info_href ...
  { 
#line 473 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 473 "pageelems.ecpp"
    _tnt_cq26.add( "className", "icon");
#line 473 "pageelems.ecpp"
    _tnt_cq26.add( "iCounter", ((uintptr_t)&xsVisibleIcons));
#line 473 "pageelems.ecpp"
    _tnt_cq26.add( "s_IMDB_ID", (s_IMDB_ID));
#line 473 "pageelems.ecpp"
    _tnt_cq26.add( "title", (title));
#line 473 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[160]; // </div>\n
#line 474 "pageelems.ecpp"
 } else if (!detail ) {

  reply.out() << _tntChunks[161]; //   <div class="hidden-xs"><img class="icon" src="img/transparent.png" alt="" /></div>\n
#line 476 "pageelems.ecpp"

  } if (!detail) {

  reply.out() << _tntChunks[162]; //   
  reply.out() << _tntChunks[163]; // \n  <div class="notpresent xs-visible-
#line 480 "pageelems.ecpp"
  reply.sout() << ( xsVisibleIcons );
  reply.out() << _tntChunks[164]; //  xs-invisible-
#line 480 "pageelems.ecpp"
  reply.sout() << ( xsInvisibleIcons );
  reply.out() << _tntChunks[165]; //  xs-columns-
#line 480 "pageelems.ecpp"
  reply.sout() << ( (xsVisibleIcons  + 2) / 3 );
  reply.out() << _tntChunks[166]; // "></div>\n
#line 481 "pageelems.ecpp"

  }
  if (eventId != 0 && detail > 1) {
    const char *sdhd = nullptr;
    std::string channel_Name;
    {
      LOCK_CHANNELS_READ;
      LOCK_SCHEDULES_READ;
      const cEvent* event;
      const cChannel* channel;
      EpgEvents::GetEventChannelByEpgId(event, channel, epgid, Channels, Schedules);
      cGetScraperVideo getScraperVideo(event, nullptr);
      bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginTvscraper());
      if (scraperDataAvailable) {
        int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
        sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": video_SD_HD == 2 ? "ud" : nullptr;
        if (channel) channel_Name = cSv(channel->Name());
      }
    }
    if (sdhd) {

  reply.out() << _tntChunks[167]; // <div id="icons-
#line 502 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[168]; // " class="event_status"></div>\n<script class="injectIcons">\ninjectHdSdIcon("icons-
#line 504 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[169]; // ", "
#line 504 "pageelems.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[170]; // ", "
#line 504 "pageelems.ecpp"
  reply.sout() << ( channel_Name );
  reply.out() << _tntChunks[171]; // ", "")\n</script>\n
#line 506 "pageelems.ecpp"
} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string channel = qparam.get< std::string >("channel");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t iepgEvent = qparam.get< uintptr_t >("iepgEvent");
int elapsed = qparam.get< int >("elapsed", ( -1));
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[174]; //   <div class="epg_description" id="
#line 531 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[175]; // ">\n    <div class="station">\n      <div class="boxheader">\n
#line 534 "pageelems.ecpp"

struct sEpisode2 {
    int number;
    int season;
    int absoluteNumber;
    std::string name;
    std::string firstAired;
    int runtime;
    std::string overview;
    float vote_average;
    int vote_count;
    cTvMedia episodeImage;
    std::string IMDB_ID;
};
struct sScraperMovieOrTv {
    bool found;
    bool movie;
    std::string title;
    std::string originalTitle;
    std::string tagline;
    std::string overview;
    std::vector<std::string> genres;
    std::string homepage;
    std::string releaseDate;  // for TV shows: firstAired
    bool adult;
    int runtime;
    float popularity;
    float voteAverage;
    int voteCount;
    std::vector<std::string> productionCountries;
    std::string IMDB_ID;
    std::vector<cTvMedia> posters;
    std::vector<cTvMedia> banners;
    std::vector<cTvMedia> fanarts;
// only for movies
    int budget;
    int revenue;
    int collectionId;
    std::string collectionName;
// only for TV Shows
    std::string status;
    std::vector<std::string> networks;
    int lastSeason;
// episode related
    bool episodeFound;
    cTvMedia seasonPoster;
    sEpisode2 episode;
};

EpgInfoPtr epgEvent = iepgEvent?static_cast<EpgInfo*>((void *)iepgEvent):nullptr;
sScraperMovieOrTv scraperMovieOrTv;
scraperMovieOrTv.found = false;

if (epgEvent && epgEvent->ScraperVideoAvailable()) {
  scraperMovieOrTv.found = true;
  tvType type = epgEvent->GetScraperVideo()->getVideoType();
//  esyslog("live: type = %i", (int)type);
  if (type == tMovie) scraperMovieOrTv.movie = true;
  else {
    if (type == tSeries) scraperMovieOrTv.movie = false;
    else scraperMovieOrTv.found = false;
  }
}
if (scraperMovieOrTv.found) {
  scraperMovieOrTv.found = epgEvent->GetScraperVideo()->getMovieOrTv(&scraperMovieOrTv.title, &scraperMovieOrTv.originalTitle, &scraperMovieOrTv.tagline, &scraperMovieOrTv.overview, &scraperMovieOrTv.genres, &scraperMovieOrTv.homepage, &scraperMovieOrTv.releaseDate, &scraperMovieOrTv.adult, &scraperMovieOrTv.runtime, &scraperMovieOrTv.popularity, &scraperMovieOrTv.voteAverage, &scraperMovieOrTv.voteCount, &scraperMovieOrTv.productionCountries, &scraperMovieOrTv.IMDB_ID, &scraperMovieOrTv.budget, &scraperMovieOrTv.revenue, &scraperMovieOrTv.collectionId, &scraperMovieOrTv.collectionName, &scraperMovieOrTv.status, &scraperMovieOrTv.networks, &scraperMovieOrTv.lastSeason);
}

std::vector<std::unique_ptr<cCharacter>> scraperCharacters;
if (scraperMovieOrTv.found) {
  scraperCharacters = epgEvent->GetScraperVideo()->getCharacters(false);
  scraperMovieOrTv.posters = epgEvent->GetScraperVideo()->getImages(eOrientation::portrait, 3, false);
  scraperMovieOrTv.banners = epgEvent->GetScraperVideo()->getImages(eOrientation::banner, 3, false);
  scraperMovieOrTv.fanarts = epgEvent->GetScraperVideo()->getImages(eOrientation::landscape, 3, false);
  scraperMovieOrTv.episodeFound = epgEvent->GetScraperVideo()->getEpisode(&scraperMovieOrTv.episode.name, &scraperMovieOrTv.episode.overview, &scraperMovieOrTv.episode.absoluteNumber, &scraperMovieOrTv.episode.firstAired, &scraperMovieOrTv.episode.runtime, &scraperMovieOrTv.episode.vote_average, &scraperMovieOrTv.episode.vote_count, &scraperMovieOrTv.episode.IMDB_ID);
  if (scraperMovieOrTv.episodeFound) {
    scraperMovieOrTv.episode.number = epgEvent->GetScraperVideo()->getEpisodeNumber();
    scraperMovieOrTv.episode.season = epgEvent->GetScraperVideo()->getSeasonNumber();
    scraperMovieOrTv.episode.episodeImage = epgEvent->GetScraperVideo()->getImage(cImageLevels(eImageLevel::episodeMovie), cOrientations(eOrientation::landscape), false);
    scraperMovieOrTv.seasonPoster = epgEvent->GetScraperVideo()->getImage(cImageLevels(eImageLevel::seasonMovie), cOrientations(eOrientation::portrait), false);
  }
}

const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {
//  esyslog("live: create caption menu");

  reply.out() << _tntChunks[176]; //         <div class = "caption">\n          <a id="
#line 621 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[177]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 621 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[178]; // ')" >
#line 621 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[179]; // </a>\n          <span class="sep">|</span>\n          <a id="
#line 623 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[180]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 623 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[181]; // ')">
#line 623 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[182]; // </a>\n          <span class="sep">|</span>\n          <a id="
#line 625 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[183]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 625 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[184]; // ')" >
#line 625 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[185]; // </a>\n          <span class="sep">|</span>\n          <a id="
#line 627 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[186]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 627 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[187]; // ')" >
#line 627 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[188]; // </a>\n        </div>\n
#line 629 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[189]; //         <div class="caption">
#line 632 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[190]; // </div>\n
#line 633 "pageelems.ecpp"

}

  reply.out() << _tntChunks[191]; //       </div>\n    </div>\n
#line 638 "pageelems.ecpp"
   size_t endEventType = boxId.find_first_of('_');

  reply.out() << _tntChunks[192]; //     <div class="epg_content epg_
#line 639 "pageelems.ecpp"
  reply.sout() << ( endEventType != std::string::npos ? boxId.substr(0, endEventType) : "unknown" );
  reply.out() << _tntChunks[193]; // ">\n      <div class="epg_tools">\n        <div class="tools">\n          
  // <& (tools_comp) ...
  { 
#line 642 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "archived", (archived));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "detail", (2));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "filter", (filter));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "flat", (flat));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "history_num_back", (history_num_back));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "id", (boxId));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "sort", (sort));
#line 642 "pageelems.ecpp"
    _tnt_cq27.add( "title", (title));
#line 642 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[194]; // \n        </div>\n      </div>\n      <div class="epg_info">\n        <div class="info">\n          <div class="spacebar">
  reply.out() << _tntChunks[195]; // </div>\n          <div class="event_details">\n            <div class="time_channel">\n              <div class="time">\n
#line 651 "pageelems.ecpp"
               if (!archived.empty()) {

  reply.out() << _tntChunks[196]; //                   <span class="bold">
#line 652 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[197]; // </span>\n
#line 653 "pageelems.ecpp"
               }

  reply.out() << _tntChunks[198]; //                 
#line 654 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[199]; // \n              </div>\n
#line 656 "pageelems.ecpp"
             if (!filename.empty() && !channel.empty()) {

  reply.out() << _tntChunks[200]; //                 <div class="channel">
#line 657 "pageelems.ecpp"
  reply.sout() << ( (channel) );
  reply.out() << _tntChunks[201]; // </div>\n
#line 658 "pageelems.ecpp"
             }

  reply.out() << _tntChunks[202]; //             </div>\n            <div class="duration">\n
#line 661 "pageelems.ecpp"

if (epgEvent && epgEvent->isRecording() ) {  // recording

  reply.out() << _tntChunks[203]; //               <span title="
#line 664 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[204]; // ">
#line 664 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), epgEvent->Duration()));
  reply.out() << _tntChunks[205]; // </span> / <span title="
#line 664 "pageelems.ecpp"
  reply.sout() << (tr("Event duration"));
  reply.out() << _tntChunks[206]; // ">
#line 664 "pageelems.ecpp"
  reply.sout() << (FormatDuration(tr("%d:%02d"), epgEvent->EventDuration()));
  reply.out() << _tntChunks[207]; // </span>\n
#line 665 "pageelems.ecpp"

}
if (elapsed >= 0) {

  reply.out() << _tntChunks[208]; //               <div class="progress">
  // <& pageelems.progressbar ...
  { 
#line 669 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 669 "pageelems.ecpp"
    _tnt_cq28.add( "progress", (elapsed));
#line 669 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[209]; // </div>\n
#line 670 "pageelems.ecpp"

}

  reply.out() << _tntChunks[210]; //             </div>\n          </div>\n          <div class="title">
#line 675 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[211]; // </div>\n          <div class="short">
#line 676 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[212]; // </div>\n          <div class="description" id=
#line 677 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[213]; // _description>\n          <span id = "
#line 678 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[214]; // _epg_image" class="epg_images">\n
#line 679 "pageelems.ecpp"

  std::list<std::string> images = EpgEvents::EpgImages(boxId);
  for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[215]; //          <a href="/epgimages/
#line 683 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[216]; // " target="_blank">\n            <img src="/epgimages/
#line 684 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[217]; // " class="epg_image"/>\n         </a>\n
#line 686 "pageelems.ecpp"
 } bool scraperImage = false;

#line 687 "pageelems.ecpp"
 if(!epgImage.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[218]; //     <a href="/tvscraper/
#line 688 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[219]; // " target="_blank">\n      <img src="/tvscraper/
#line 689 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[220]; // " class="epg_image"/>\n    </a>\n
#line 691 "pageelems.ecpp"
 } if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[221]; //     <a href="/tvscraper/
#line 692 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[222]; // " target="_blank">\n      <img src="/tvscraper/
#line 693 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[223]; // " class="epg_image"/>\n    </a>\n
#line 695 "pageelems.ecpp"

  }  // episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty()
  if (!scraperImage) {
    std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
    size_t delimPos = boxId.find_last_of('_');
    std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

    for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[224]; //       <a href="/recimages/
#line 704 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[225]; // /
#line 704 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[226]; // " target="_blank">\n        <img src="/recimages/
#line 705 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[227]; // /
#line 705 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[228]; // " class="epg_image"/>\n      </a>\n
#line 707 "pageelems.ecpp"

    }
  }

  reply.out() << _tntChunks[229]; //           </span> 
  reply.out() << _tntChunks[230]; // \n\n
  reply.out() << _tntChunks[231]; // \n<div id = '
#line 714 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[232]; // _scraper' hidden>\n
#line 715 "pageelems.ecpp"

std::string loc_name;
getLanguage(loc_name, "LANGUAGE") ||
getLanguage(loc_name, "LC_ALL") ||
getLanguage(loc_name, "LC_MESSAGES") ||
getLanguage(loc_name, "LANG");
if (loc_name.empty() ) {
  loc_name = std::locale("").name().substr(0,2);
  if (loc_name.length() != 2 || loc_name[0] == 'C' || loc_name[0] == '*' || loc_name[0] == 'L') loc_name = "en"; //  use en as default
}

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[233]; //   <div class="scraper_list">
#line 728 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[234]; //          
#line 728 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[235]; // </div>\n
#line 729 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[236]; //   <div class="scraper_list">
#line 732 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[237]; //  
#line 732 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[238]; // </div>\n
#line 733 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[239]; //     <div class="scraper_list">
#line 737 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[240]; //  S
#line 737 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.season )) );
  reply.out() << _tntChunks[241]; // E
#line 737 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.number)) );
#line 737 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?concat("A", cToSvInt(scraperMovieOrTv.episode.absoluteNumber)):"");
  reply.out() << _tntChunks[242]; //  
#line 737 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.name );
  reply.out() << _tntChunks[243]; // </div>\n    <div class="scraper_list">
#line 738 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[244]; //    
#line 738 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[245]; // </div>\n
#line 739 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[246]; //       <div class="scraper_list">
#line 742 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[247]; //  
#line 742 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average) );
  reply.out() << _tntChunks[248]; //  / 
#line 742 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[249]; // </div>\n
#line 743 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[250]; //     <div class="scraper_list">
#line 746 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[251]; //  
#line 746 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[252]; // </div>\n
#line 747 "pageelems.ecpp"
   if (scraperMovieOrTv.episode.runtime > 0) {

  reply.out() << _tntChunks[253]; //       <div class="scraper_list">
#line 748 "pageelems.ecpp"
  reply.sout() << ( tr("Episode runtime:") );
  reply.out() << _tntChunks[254]; //  
#line 748 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.episode.runtime*60) );
  reply.out() << _tntChunks[255]; // </div>\n
#line 749 "pageelems.ecpp"
   }

#line 750 "pageelems.ecpp"
   if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[256]; //       <a href="https://www.imdb.com/title/
#line 751 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[257]; // " target="_blank"> 
#line 751 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[258]; //  </a>\n
#line 752 "pageelems.ecpp"

    }
    bool charFound = false;
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::guestStar ||
          character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
    if (charFound) {

  reply.out() << _tntChunks[259]; //       <div class="scraper_list">
#line 761 "pageelems.ecpp"
  reply.sout() << ( tr("Guest stars and crew") );
  reply.out() << _tntChunks[260]; // </div>\n      <div class="cast_crew tabular">\n
#line 763 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 764 "pageelems.ecpp"
     if (character->getType() != eCharacterType::guestStar) continue;

  reply.out() << _tntChunks[261]; //         <div class="cast_role"> 
#line 765 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[262]; //  </div>\n        <div> <a href="https://
#line 766 "pageelems.ecpp"
  reply.sout() << ( loc_name );
  reply.out() << _tntChunks[263]; // .wikipedia.org/wiki/
#line 766 "pageelems.ecpp"
  reply.sout() << ( cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")) );
  reply.out() << _tntChunks[264]; // " target="_blank">
#line 766 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[265]; // </a> </div>\n
#line 767 "pageelems.ecpp"
   }

#line 768 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 769 "pageelems.ecpp"
     if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[266]; //         <div class="cast_role"> 
#line 770 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[267]; //  </div>\n        <div> <a href="https://
#line 771 "pageelems.ecpp"
  reply.sout() << ( loc_name );
  reply.out() << _tntChunks[268]; // .wikipedia.org/wiki/
#line 771 "pageelems.ecpp"
  reply.sout() << ( cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")) );
  reply.out() << _tntChunks[269]; // " target="_blank">
#line 771 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[270]; // </a> </div>\n
#line 772 "pageelems.ecpp"
   }

#line 773 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 774 "pageelems.ecpp"
     if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[271]; //         <div class="cast_role"> 
#line 775 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[272]; //  </div>\n        <div> <a href="https://
#line 776 "pageelems.ecpp"
  reply.sout() << ( loc_name );
  reply.out() << _tntChunks[273]; // .wikipedia.org/wiki/
#line 776 "pageelems.ecpp"
  reply.sout() << ( cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")) );
  reply.out() << _tntChunks[274]; // " target="_blank">
#line 776 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[275]; // </a> </div>\n
#line 777 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[276]; //       </div>\n
#line 779 "pageelems.ecpp"

    }  // end if !episode.<Guest stars and crew>.empty()
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[277]; //   <div class="scraper_list">
#line 784 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[278]; //         
#line 784 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[279]; // </div>\n
#line 785 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[280]; //   <div class="scraper_list">
#line 786 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[281]; //        
#line 786 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[282]; // </div>\n  <div class="scraper_list">
#line 787 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[283]; //          
#line 787 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[284]; // </div>\n
#line 788 "pageelems.ecpp"
 if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[285]; //   <div class="scraper_list"><a href ="
#line 789 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[286]; // " target="_blank">
#line 789 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[287]; // </a></div>\n
#line 790 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[288]; //   <div class="scraper_list">
#line 791 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[289]; //    
#line 791 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[290]; // </div>\n
#line 792 "pageelems.ecpp"
 if (scraperMovieOrTv.runtime > 0) {

  reply.out() << _tntChunks[291]; //   <div class="scraper_list">
#line 793 "pageelems.ecpp"
  reply.sout() << ( tr("Runtime:") );
  reply.out() << _tntChunks[292]; //         
#line 793 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.runtime*60) );
  reply.out() << _tntChunks[293]; // </div>\n
#line 794 "pageelems.ecpp"
 }

#line 795 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[294]; //   <div class="scraper_list">
#line 798 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[295]; //      
#line 798 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[296]; // </div>\n
#line 799 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[297]; //   <div class="scraper_list">
#line 803 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[298]; //  
#line 803 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[299]; //  / 
#line 803 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount) );
  reply.out() << _tntChunks[300]; // </div>\n
#line 804 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[301]; // \n
#line 810 "pageelems.ecpp"
 if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[302]; //     <div class="scraper_list">\n      <a href="https://www.imdb.com/title/
#line 812 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[303]; // " target="_blank"> 
#line 812 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[304]; //  </a>\n    </div>\n
#line 814 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[305]; // \n
#line 819 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[306]; //     <div class="scraper_list">
#line 823 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[307]; //          
#line 823 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[308]; // </div>\n
#line 824 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[309]; //     <div class="scraper_list">
#line 828 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[310]; //         
#line 828 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[311]; // </div>\n
#line 829 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[312]; // \n
#line 835 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[313]; //     <div class="scraper_list">
#line 838 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[314]; //  
#line 838 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[315]; // </div>\n
#line 839 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[316]; //     
  reply.out() << _tntChunks[317]; // \n    <div class="scraper_list">
#line 844 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[318]; //          
#line 844 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[319]; // </div>\n
  reply.out() << _tntChunks[320]; // \n
#line 848 "pageelems.ecpp"

  }
  bool charFound = false;
  for (const auto &character:scraperCharacters)
    if (character->getType() == eCharacterType::actor) { charFound = true; break; }
  if (!charFound && scraperMovieOrTv.movie) {
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
  }
  if (charFound) {

  reply.out() << _tntChunks[321]; //     <div class="scraper_list">
#line 860 "pageelems.ecpp"
  reply.sout() << ( tr("Cast and crew") );
  reply.out() << _tntChunks[322]; // </div>\n    <div class="cast_crew tabular">\n
#line 862 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 863 "pageelems.ecpp"
     if (character->getType() != eCharacterType::actor) continue;

  reply.out() << _tntChunks[323]; //       <div class="cast_role"> 
#line 864 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[324]; //  </div>\n      <div> <a href="https://
#line 865 "pageelems.ecpp"
  reply.sout() << ( loc_name );
  reply.out() << _tntChunks[325]; // .wikipedia.org/wiki/
#line 865 "pageelems.ecpp"
  reply.sout() << ( cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")) );
  reply.out() << _tntChunks[326]; // " target="_blank">
#line 865 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[327]; // </a>  </div>\n
#line 866 "pageelems.ecpp"
   }

#line 867 "pageelems.ecpp"
   if (scraperMovieOrTv.movie) {

#line 868 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 869 "pageelems.ecpp"
       if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[328]; //         <div class="cast_role"> 
#line 870 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[329]; //  </div>\n        <div> <a href="https://
#line 871 "pageelems.ecpp"
  reply.sout() << ( loc_name );
  reply.out() << _tntChunks[330]; // .wikipedia.org/wiki/
#line 871 "pageelems.ecpp"
  reply.sout() << ( cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")) );
  reply.out() << _tntChunks[331]; // " target="_blank">
#line 871 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[332]; // </a> </div>\n
#line 872 "pageelems.ecpp"
     }

#line 873 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 874 "pageelems.ecpp"
       if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[333]; //         <div class="cast_role"> 
#line 875 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[334]; //  </div>\n        <div> <a href="https://
#line 876 "pageelems.ecpp"
  reply.sout() << ( loc_name );
  reply.out() << _tntChunks[335]; // .wikipedia.org/wiki/
#line 876 "pageelems.ecpp"
  reply.sout() << ( cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")) );
  reply.out() << _tntChunks[336]; // " target="_blank">
#line 876 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[337]; // </a> </div>\n
#line 877 "pageelems.ecpp"
     }

#line 878 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[338]; //     </div>\n
#line 880 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[339]; // </div>\n
  reply.out() << _tntChunks[340]; // \n<div id="
#line 886 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[341]; // _actors" hidden>\n
#line 887 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[342]; //   <div class="event_actors">\n
#line 891 "pageelems.ecpp"

  for (const auto &character:scraperCharacters) {
    if (character->getImage().path.empty() ) continue;  // only actors with images

  reply.out() << _tntChunks[343]; //     <div class="actor">\n      <div class="actor_photo"><a href="/tvscraper/
#line 896 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[344]; // " target="_blank"><img class="photo" src="/tvscraper/
#line 896 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[345]; // " alt="
#line 896 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[346]; // : 
#line 896 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[347]; // " /></a></div>\n      <div class="actor_name"><a href="https://
#line 897 "pageelems.ecpp"
  reply.sout() << ( loc_name );
  reply.out() << _tntChunks[348]; // .wikipedia.org/wiki/
#line 897 "pageelems.ecpp"
  reply.sout() << ( cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")) );
  reply.out() << _tntChunks[349]; // " target="_blank">
#line 897 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[350]; // </a></div>\n      <div class="character">
#line 898 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[351]; // </div>\n    </div>\n
#line 900 "pageelems.ecpp"

  } // for character in scraperCharacters

  reply.out() << _tntChunks[352]; //   </div>\n
#line 904 "pageelems.ecpp"

}

  reply.out() << _tntChunks[353]; // </div>\n
  reply.out() << _tntChunks[354]; // \n<div id="
#line 909 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[355]; // _artwork" hidden>\n
#line 910 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 915 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 915 "pageelems.ecpp"
    _tnt_cq29.add( "media_p", (media_p));
#line 915 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq29);
    // &>
  }
  reply.out() << _tntChunks[356]; // \n
  // <& media ...
  { 
#line 916 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 916 "pageelems.ecpp"
    _tnt_cq30.add( "media_p", (media_f));
#line 916 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq30);
    // &>
  }
  reply.out() << _tntChunks[357]; // \n
  // <& media ...
  { 
#line 917 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 917 "pageelems.ecpp"
    _tnt_cq31.add( "media_p", (media_b));
#line 917 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[358]; // \n</div>\n
  reply.out() << _tntChunks[359]; // \n<div id="
#line 920 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[360]; // _epg">\n
#line 921 "pageelems.ecpp"

if (!long_descr.empty()) {
  cToSvConcat long_descr_html_esc = "<p>";
  AppendHtmlEscapedAndCorrectNonUTF8(long_descr_html_esc, long_descr, "</p><p>");
  long_descr_html_esc.append("</p>");
  reply.out() << long_descr_html_esc;
}

if (epgEvent) {
  bool empty = true;
  cToSvConcat supplemental_info;
  for (int i = 0; epgEvent->Contents(i); i++) {
    const char *s = cEvent::ContentToString(epgEvent->Contents(i));
    if (!isempty(s)) {
      if (empty) {
        supplemental_info.append(tr("Content"));
        supplemental_info.append(": ");
        empty = false;
      } else {
        supplemental_info.append(", ");
      }
      supplemental_info.append(s);
    }
  }
  if (epgEvent->ParentalRating()) {
    if (!empty) {
      supplemental_info.append("\n");
    }
    supplemental_info.append(tr("Parental rating"));
    supplemental_info.append(": ");
    supplemental_info.append(cToSvFormated(trVDR("ParentalRating$from %d"), epgEvent->ParentalRating()));
    empty = false;
  }
  if (!empty) {
    cToSvConcat supplemental_info_html_esc = "<p class=\"epg_event_info\">";
    AppendHtmlEscapedAndCorrectNonUTF8(supplemental_info_html_esc, supplemental_info);
    supplemental_info_html_esc.append("</p>");
    reply.out() << supplemental_info_html_esc;
  }
}

  reply.out() << _tntChunks[361]; //         </div>\n      </div>\n      <div class="spacebar">
  reply.out() << _tntChunks[362]; // </div></div>\n    </div>\n  </div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 975 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[365]; //   <a class="artwork" href="/tvscraper/
#line 979 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[366]; // " target="_blank">\n    <img class="artwork" src="/tvscraper/
#line 980 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[367]; // " />\n  </a>\n
#line 982 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[370]; //   <div class="epg_description" id="aboutBox">\n    <div class="station">\n      <div class="boxheader"><div class="caption">
#line 992 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[371]; // </div></div>\n    </div>\n    <div class="epg_content"><div class="about_content">\n      <div class="about_head">
#line 995 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[372]; // </div>\n      <div class="about_section">\n        <div class="tabular">\n          <div class="about_left">
#line 998 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[373]; // :</div>\n          <div class="about_right">Thomas Keil (Thomas)</div>\n          <div class="about_left">
#line 1000 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[374]; // :</div>\n          <div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n          <div class="about_left">
#line 1002 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[375]; // :</div>\n          <div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n          <div class="about_left">
#line 1004 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[376]; // :</div>\n          <div class="about_right">Jasmin Jessich (jasminj)</div>\n          <div class="about_left">
#line 1006 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[377]; // :</div>\n          <div class="about_right">Dieter Hametner (tadi)</div>\n          <div class="about_left">
#line 1008 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[378]; // :</div>\n          <div class="about_right">Christian Wieninger (winni)</div>\n          <div class="about_left">
#line 1010 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[379]; // :</div>\n          <div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n        </div>\n      </div>\n      <div class="about_head">
#line 1014 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[380]; // </div>\n      <div class="about_section">\n        <div class="tabular">\n          <div class="about_left">
#line 1017 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[381]; // :</div>\n          <div class="about_right">
#line 1018 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 1018 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[382]; // </div>\n          <div class="about_left">
#line 1019 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[383]; // :</div>\n          <div class="about_right">
#line 1020 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[384]; // </div>\n        </div>\n      </div>\n      <div class="about_head">
#line 1023 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[385]; // </div>\n      <div class="about_section">\n        <div class="tabular">\n          <div class="about_left">EPGsearch:</div>\n          <div class="about_right">\n
#line 1028 "pageelems.ecpp"
            Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[386]; //             <img src="
#line 1029 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[387]; // "/>\n
#line 1030 "pageelems.ecpp"
            if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[388]; //               
#line 1031 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[389]; // : 
#line 1031 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[390]; // \n
#line 1032 "pageelems.ecpp"
            } else {

  reply.out() << _tntChunks[391]; //               
#line 1033 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[392]; // : 
#line 1033 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[393]; // \n
#line 1034 "pageelems.ecpp"
            }

  reply.out() << _tntChunks[394]; //             (<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1035 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[395]; // </a>)<br/>\n          </div>\n          <div class="about_left">Streamdev server:</div>\n          <div class="about_right">\n
#line 1039 "pageelems.ecpp"

            Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[396]; //             <img src="
#line 1042 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[397]; // "/>\n
#line 1043 "pageelems.ecpp"

            if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[398]; //               
#line 1046 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[399]; // : 
#line 1046 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[400]; // \n
#line 1047 "pageelems.ecpp"

            } else {

  reply.out() << _tntChunks[401]; //               
#line 1050 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[402]; // : 
#line 1050 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[403]; // \n
#line 1051 "pageelems.ecpp"

            }

  reply.out() << _tntChunks[404]; //             (<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1054 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[405]; // </a>)<br/>\n          </div>\n          <div class="about_left">tvscraper:</div>\n          <div class="about_right">\n
#line 1058 "pageelems.ecpp"
            Features< features::tvscraper >& tvscraper = LiveFeatures< features::tvscraper >();

  reply.out() << _tntChunks[406]; //             <img src="
#line 1059 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", tvscraper.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[407]; // "/>\n
#line 1060 "pageelems.ecpp"
            if ( tvscraper.Recent() ) {

  reply.out() << _tntChunks[408]; //               
#line 1061 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[409]; // : 
#line 1061 "pageelems.ecpp"
  reply.sout() << ( tvscraper.Version() );
  reply.out() << _tntChunks[410]; // \n
#line 1062 "pageelems.ecpp"
            } else {

  reply.out() << _tntChunks[411]; //               
#line 1063 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[412]; // : 
#line 1063 "pageelems.ecpp"
  reply.sout() << ( tvscraper.MinVersion() );
  reply.out() << _tntChunks[413]; // \n
#line 1064 "pageelems.ecpp"
            }

  reply.out() << _tntChunks[414]; //             (<a href="https://github.com/MarkusEh/vdr-plugin-tvscraper" target="_blank">
#line 1065 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[415]; // </a>)<br/>\n          </div>\n        </div>\n      </div>\n      <div class="about_head">
#line 1069 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[416]; // </div>\n      <div class="about_section">\n        <div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB.</div>\n        <div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them.</a></div>\n      </div>\n      <div class="about_head">
#line 1074 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[417]; // </div>\n      <div class="about_section">\n        <div class="about_line">
#line 1076 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[418]; // :<br/>\n          <a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n      </div>\n    </div></div>\n  </div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
