////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <string>
#include <setup.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <vdr/channels.h>
#include <stringhelpers.h>
#include <livefeatures.h>

#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class todel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        todel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    todel_type todel;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "8\003\000\0009\003\000\000:\003\000\000;\003\000\000\255\003\000\000\272\003\000\000\277"
  "\003\000\000\304\003\000\000\357\003\000\000\"\005\000\000*\005\000\0000\005\000\000B\005\000\000\212\005\000\000D"
  "\006\000\000L\006\000\000R\006\000\000d\006\000\000m\006\000\000\243\006\000\000[\007\000\000\212\007\000\000\245\007"
  "\000\000\267\007\000\000\215\010\000\000\247\010\000\000\300\010\000\000\323\010\000\000\222\t\000\000\223\t\000\000"
  "\225\t\000\000\226\t\000\000\230\t\000\000\231\t\000\000\310\t\000\000\323\t\000\000\330\t\000\000c\n\000\000\177\n"
  "\000\000\205\n\000\000\304\n\000\000\326\n\000\000\260\013\000\000\000\014\000\0005\014\000\000h\014\000\000\247\014"
  "\000\000\252\014\000\000\001\015\000\000\013\015\000\000\033\015\000\0008\015\000\000g\015\000\000\207\015\000\000"
  "\210\015\000\000\211\015\000\000\213\015\000\000\345\015\000\000\000\016\000\000s\016\000\000\257\016\000\000\003\017"
  "\000\000f\017\000\000\210\017\000\000\347\017\000\000\376\017\000\000.\020\000\000R\020\000\000[\020\000\000\217\020"
  "\000\000\306\020\000\000\333\020\000\000\346\020\000\000\353\020\000\000\356\020\000\000\362\020\000\000\377\020\000"
  "\000$\021\000\000\373\021\000\000\207\022\000\000\336\022\000\000\005\023\000\000\216\023\000\000\235\023\000\000\302"
  "\023\000\000\304\023\000\000\310\023\000\000\316\023\000\000\344\023\000\000\352\023\000\000\354\023\000\000\360\023"
  "\000\000\364\023\000\000\010\024\000\000\t\024\000\000\n\024\000\000#\024\000\000J\024\000\000R\024\000\000X\024\000"
  "\000Z\024\000\000\134\024\000\000\232\024\000\000\242\024\000\000\250\024\000\000\252\024\000\000\254\024\000\000\374"
  "\024\000\000\002\025\000\000\004\025\000\000\006\025\000\000\013\025\000\000D\025\000\000L\025\000\000R\025\000\000T"
  "\025\000\000U\025\000\000Z\025\000\000\216\025\000\000\275\025\000\000\355\025\000\000\361\025\000\000\375\025\000"
  "\000M\026\000\000Q\026\000\000{\026\000\000\204\026\000\000\207\026\000\000\341\026\000\000\352\026\000\0000\027\000"
  "\0009\027\000\000<\027\000\000C\027\000\000D\027\000\000E\027\000\000S\027\000\000T\027\000\000U\027\000\000u\027\000"
  "\000{\027\000\000\203\027\000\000\211\027\000\000\233\027\000\000\235\027\000\000\252\027\000\000\261\027\000\000\300"
  "\027\000\000\301\027\000\000\302\027\000\000\345\027\000\000\353\027\000\000\363\027\000\000\371\027\000\000\013\030"
  "\000\000\031\030\000\000 \030\000\000)\030\000\0000\030\000\0001\030\000\0002\030\000\000d\030\000\000{\030\000\000"
  "\240\030\000\000\353\030\000\000W\031\000\000\326\031\000\000\350\031\000\000\t\032\000\000\227\032\000\000\317\032"
  "\000\000\322\032\000\000\325\032\000\000\024\033\000\000\242\033\000\000\327\033\000\000\027\034\000\000\032\034\000"
  "\000m\034\000\000o\034\000\000p\034\000\000q\034\000\000r\034\000\000s\034\000\000t\034\000\000u\034\000\000v\034\000"
  "\000\205\034\000\000\337\034\000\000\342\034\000\000\344\034\000\000\347\034\000\000\353\034\000\000\357\034\000\000"
  "\362\034\000\000\365\034\000\000\002\035\000\000\003\035\000\000\004\035\000\000\016\035\000\000\035\035\000\000!\035"
  "\000\000\"\035\000\000#\035\000\000$\035\000\000%\035\000\000\n\n\n\n<html>\n  <head>\n    <meta name=\"viewport\" co"
  "ntent=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n    \n<script>\nconst r"
  "ecordings_tree_creation = ;\nconst recs = [];\nconst rec_ids = Object.create(null)\nrec_ids[\"T\"] = [1, 2]\n\n// Tit"
  "le is the title of the action (like \"play in media player\"), and will be HTML-encoded here\nfunction RecordingActio"
  "nS(s, id, A, Img, Title) {\n  s.a += '<a href=\"'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=&f"
  "ilter=&flat=&history_num_back=\" title=\"'\n  addEncodeHtml(s, Title)\n  s.a += '\"><img class=\"icon\" src=\"'\n  s."
  "a += Img\n  s.a += '\" /></a>'\n}\n\nfunction RecordingActionPlaylist(s, id) {\n  s.a += '<a class=\"hidden-xs invisi"
  "ble\" href=\"playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=&filter=&flat=&history_num_back=\" title="
  "\"\" download><img class=\"hidden-xs invisible icon\" src=\"playlist.png\" /></a>'\n}\n\n// do not HTML-encode title;"
  " will be HTML-encoded here!\nfunction addEventRec_r(s, eventid, title, folder, shortText, description) {\n  let http_"
  "params = '&sort=&filter='\n  http_params += encodeURIComponent('')\n  http_params += '&flat=&history_num_back='\n  ad"
  "dEventRec(s, 'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</script>\n\n  <script ty"
  "pe=\"text/javascript\" src=\"js/live/treeview.js\"></script>\n  <script>\n  const tv = new Treeview(\"icon_overlay_mi"
  "nus.png\", \"icon_overlay_plus.png\", \"folder_open.png\", \"folder_closed.png\");\n  </script>\n</head>\n<body onpag"
  "ehide=\"saveScrollPosition('content')\" onpageshow=\"restoreScrollPosition(); clearCheckboxes(document.getElementById"
  "('form_recordings'))\">\n  \n  \n  \n  <div id=\"content\">\n    <div class=\"spacebar\"></div>\n    \n    \n    <tab"
  "le class=\"recordings-list\" cellspacing=\"0\" cellpadding=\"0\"><tbody>\n    <tr><td>\n      <div class=\"boxheader"
  "\"><div class=\"caption\"></div></div>\n    </td></tr>\n      \n      <tr class=\"recording_item\">\n        <td clas"
  "s=\"message\"></td>\n      </tr>\n    <tr><td>\n      <form method=\"post\" name=\"recordings\" id=\"form_recordings"
  "\" action=\"recordings.ecpp\">\n        <div class=\"recordings\">\n          <ul class=\"recordingslist\" style=\"di"
  "splay: revert-layer;\">\n            \n          </ul>\n        </div>\n        <input type=\"hidden\" name=\"sort\" "
  "value=\"\">\n        <input type=\"hidden\" name=\"filter\" value=\"\">\n        <input type=\"hidden\" name=\"flat\""
  " value=\"\">\n        <input type=\"hidden\" name=\"history_num_back\" value=\"\">\n        <div class=\"withmargin h"
  "idden-xs\">\n          <button class=\"red\" type=\"submit\"></button>\n\n        </div>\n      </form>\n    </td></t"
  "r>\n    </tbody></table>\n    <div class=\"spacebar\"></div>\n  </div>\n</body>\n</html>\n\n\n\n\n  <li class=\"recor"
  "ding\">\n    <div class=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n    <table><tr>\n              <t"
  "d class = \"space\">\n          <img src=\"img/transparent.png\" style=\"width: calc(var(--icon-width, 16px) * ); hei"
  "ght: var(--icon-height, 16px)\" />\n        </td>\n            <td class=\"space\">\n        <img class=\"iconic butt"
  "on recording-expander\" src=\"icon_overlay_plus.png\" />\n      </td><td class=\"space\">\n        <img class=\"recor"
  "ding_folder\" src=\"folder_closed.png\" />\n      </td>\n        <td class = space>\n          <div class=\"thumb\">"
  "\n            <img data-src=\"/tvscraper/\"\n              class=\"\"\n            />\n          </div>\n        </td"
  ">\n    <td class=\"recording_folder_name\">\n      \n    </td></tr></table>\n    </div>\n    <ul id=\"fldr_\" class="
  "\"recordingslist\" style=\"display: none;\">\n      \n    </ul>\n  </li>\n  <script>\n  recs[]=[]\n  \n</script>\n   "
  "     <script>\n        rec_ids[\"fldr_\"] = []\n        document.write(\n          '<li class=\"recording\">' +\n    "
  "        '<table class=\"recordings\" width=\"100%\">' +\n              '<tbody>' +\n                '<tr class=\"reco"
  "rding_item\">' +\n                                  '<td class = \"space\">' +\n                    '<img src=\"img/t"
  "ransparent.png\" style=\"width: calc(var(--icon-width, 16px) * ); height: var(--icon-height, 16px)\" />' +\n         "
  "         '</td>' +\n                                  '<td class=\"message\"></td>' +\n                '</tr>' +\n   "
  "           '</tbody>' +\n            '</table>' +\n          '</li>'\n        )\n      </script>\n            <script"
  ">\n        document.write(rec_string_d([, , [  ]]))\n        rec_ids[\"fldr_\"] = [, , [  ]]\n      </script>\n    \n"
  "\n<span class=\"label bold\"> </span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|"
  "</span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings."
  "html\?sort=duplicates&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=&filter=&"
  "flat=\" ></a>\n<span class=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" v"
  "alue=\"\" id=\"filter\" onchange=\"filterRecordings(this, '', '')\" />&nbsp;</span>\n<img onclick=\"clearRecordingsFi"
  "lter(document.getElementById('filter'), '', '')\" class=\"icon button clear-filter\" src=\"\" alt=\"\" />\n<span clas"
  "s=\"sep\">|</span>\n<img onclick=\"ExpandAll()\" class=\"icon button expand-all\" src=\"\" alt=\"\" />\n<img onclick="
  "\"CollapseAll()\" class=\"icon button collapse-all\" src=\"\" alt=\"\" />\n<br />\n\n\nclass=\"active\"\n\n<a href=\""
  "epginfo.html\?epgid=del_&sort=&filter=&flat=&history_num_back=\" ><img class=\"\" src=\"\" alt=\"\" /></a>\n\n<a href"
  "=\"edit_recording.html\?recid=&sort=&filter=&flat=&history_num_back=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n<"
  "!DOCTYPE html>\n<html>\n  <script>\n    history.go(-);\n  </script>\n</html>\n<div class=\"epg_description\" id=\"del"
  "_\">\n  <div class=\"station\">\n    <div class=\"boxheader\"><div class=\"caption\"></div></div>\n  </div>\n  <div c"
  "lass=\"epg_content\">\n    <form>\n      <input type=\"hidden\" name=\"epgid\" value=\"\" >\n      <input type=\"hidd"
  "en\" name=\"delete_rec\" value=\"confirmed\" >\n      <input type=\"hidden\" name=\"history_num_back\" value=\"\" id="
  "\"history_del_\">\n      <div class=\"about_head\"></div>\n      <div class=\"about_section\">\n        <div class=\""
  "tabular\">\n          <div class=\"about_left\">\n            <button id=\"confirm_del_\" class=\"green\" type=\"butt"
  "on\" onclick=\"delete_rec_back('', )\"></button>\n          </div>\n          <div class=\"about_right\">\n\n<script>"
  "\nfunction cancel_delete() {\n  if (document.referrer.indexOf(\"epginfo.html\?\") != -1) {\n    history.go(-1);\n  } "
  "else {\n    history.go(-);\n  }\n}\n</script>\n            <button id=\"close_del_\" type=\"button\" class=\"red\" on"
  "click=\"back_depending_referrer(1, )\"></button>\n          </div>\n        </div>\n      </div>\n    </form>\n  </di"
  "v>\n</div>\n\n\n\n\n\n\n\n\n\n<div id=\"icons-\" class=\"recording_status\"></div>\n<script class=\"injectIcons\">\ni"
  "njectErrorHdSdIcon(\"icons-\", , , \"\", \"\", \"\", , \"\")\n</script>\n\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n"
  "\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    todel(*this, "todel"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 42 "recordings.ecpp"

std::chrono::time_point<std::chrono::high_resolution_clock> timeStart = std::chrono::high_resolution_clock::now();

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

if (request.getMethod() != "POST") history_num_back = 0;  // we can go back in history to this page
else ++history_num_back;  // we have to go back in history to a prev page, to avoid re-send of form data

// create the "current" values of the global request parameters, based on their old values and the current arguments
// basically, this is a bad idea. Pushing "refresh" changes the sort order :( .
// Better: Urls on menue have parameters depending on the current sort option
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "datedesc" || sort == "dateasc") currentSort = sort;
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "nameasc" || sort == "namedesc") currentSort = sort;
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "errorsts" || sort == "errorsdur") currentSort = sort;
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}

deleteResult = "";
if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
  for (auto it = deletions.begin(); it != deletions.end(); ++it) {
    std::string name;
    if (RecordingsManager::DeleteRecording(*it, &name) == 0) {
      cToSvConcat delRec(tr("Deleted recording:"), " ");
      delRec.appendReplace(name, "~", "/");
      delRec << "<br/>";
      deleteResult += std::string(delRec);
    }
  }
  deletions.clear();
} else {
  throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
}

int FreeMB, UsedMB;
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));


// get data for all open nodes
std::string openTreeNodes;
if (request.hasCookie("VDR-Live-Recordings-Tree-Open-Nodes")) {
  openTreeNodes = request.getCookie("VDR-Live-Recordings-Tree-Open-Nodes");
//  dsyslog("live: VDR-Live-Recordings-Tree-Open-Nodes = %s", openTreeNodes.c_str());
}
cToSvConcat<0> recording_item;
recording_item.reserve(25000);

#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif


  // <& pageelems.doc_type ...
  { 
#line 126 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 126 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 130 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 131 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 131 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 132 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 132 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 133 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 133 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recordings_tree_creation = 
#line 135 "recordings.ecpp"
  reply.sout() << ( cToSvInt(RecordingsManager::GetLastRecordingsUpdate() ) );
  reply.out() << _tntChunks[8]; // ;\nconst recs = [];\nconst rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\n// Title is the title of the action (like "play in media player"), and will be HTML-encoded here\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 146 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[9]; // &filter=
#line 146 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[10]; // &flat=
#line 146 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[11]; // &history_num_back=
#line 146 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[12]; // " title="'\n  addEncodeHtml(s, Title)\n  s.a += '"><img class="icon" src="
#line 148 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[13]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\n\nfunction RecordingActionPlaylist(s, id) {\n  s.a += '<a class="hidden-xs invisible" href="playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=
#line 156 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[14]; // &filter=
#line 156 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[15]; // &flat=
#line 156 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[16]; // &history_num_back=
#line 156 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[17]; // " title="
#line 156 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[18]; // " download><img class="hidden-xs invisible icon" src="
#line 156 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[19]; // playlist.png" /></a>'\n}\n\n// do not HTML-encode title; will be HTML-encoded here!\nfunction addEventRec_r(s, eventid, title, folder, shortText, description) {\n  let http_params = '&sort=
#line 161 "recordings.ecpp"
  reply.sout() << ( sort );
  reply.out() << _tntChunks[20]; // &filter='\n  http_params += encodeURIComponent('
#line 162 "recordings.ecpp"
  reply.sout() << ( filter );
  reply.out() << _tntChunks[21]; // ')\n  http_params += '&flat=
#line 163 "recordings.ecpp"
  reply.sout() << ( flat );
  reply.out() << _tntChunks[22]; // &history_num_back=
#line 163 "recordings.ecpp"
  reply.sout() << ( history_num_back+1 );
  reply.out() << _tntChunks[23]; // '\n  addEventRec(s, 'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 170 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[24]; // icon_overlay_minus.png", "
#line 170 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[25]; // icon_overlay_plus.png", "
#line 170 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[26]; // folder_open.png", "
#line 170 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[27]; // folder_closed.png");\n  </script>\n</head>\n<body onpagehide="saveScrollPosition('content')" onpageshow="restoreScrollPosition(); clearCheckboxes(document.getElementById('form_recordings'))">\n  
  // <& pageelems.logo ...
  { 
#line 174 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 174 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[28]; // \n
#line 175 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[29]; //   
  // <& menu ...
  { 
#line 182 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 182 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 182 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 182 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 182 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n
#line 183 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[31]; //   
  // <& menu ...
  { 
#line 186 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 186 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 186 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 186 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 186 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[32]; // \n
#line 187 "recordings.ecpp"

}

  reply.out() << _tntChunks[33]; //   <div id="content">\n    <div class="spacebar">
  reply.out() << _tntChunks[34]; // </div>\n    
  reply.out() << _tntChunks[35]; // \n    
  reply.out() << _tntChunks[36]; // \n    <table class="recordings-list" cellspacing="0" cellpadding="0"><tbody>\n    <tr><td>\n      <div class="boxheader"><div class="caption">
#line 196 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[37]; // </div></div>\n    </td></tr>\n
#line 198 "recordings.ecpp"

    int rec_cnt;
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[38]; //       
  reply.out() << _tntChunks[39]; // \n      <tr class="recording_item">\n        <td class="message">
#line 208 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[40]; // </td>\n      </tr>\n
#line 210 "recordings.ecpp"

    } else {
// get and set sort order
// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
      bool reverse = false;
      RecordingsManager::eSortOrder sortOrder = RecordingsManager::eSortOrder::name; // default
      if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = RecordingsManager::eSortOrder::date;
      if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = RecordingsManager::eSortOrder::errors;
      if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = RecordingsManager::eSortOrder::durationDeviation;
      if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = RecordingsManager::eSortOrder::duplicatesLanguage;
      if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
      RecordingsManager::setSortOrder(sortOrder, reverse, currentFilter);  // this also updates the recordings, if required

// get root directory
      RecordingsItemDirPtr recItemRoot;
      if (currentSort.compare(0, 10, "duplicates", 10) == 0) {
        DuplicatesRecordingsTreePtr duplicatesRecordingsTree(RecordingsManager::GetDuplicatesRecordingsTree());
        if (currentFlat == "true")
          recItemRoot = duplicatesRecordingsTree->getFlatRoot();
        else
          recItemRoot = duplicatesRecordingsTree->getRoot();
      } else {
        if (currentFlat == "true")
          recItemRoot = std::make_shared<RecordingsItemDirFlat>();
        else
          recItemRoot = RecordingsManager::GetRecordingsTree()->getRoot();
      }

      uintptr_t irecording_item = (uintptr_t)&recording_item;
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;
      uintptr_t iOpenTreeNodes = (uintptr_t)&openTreeNodes;

  reply.out() << _tntChunks[41]; //     <tr><td>\n      <form method="post" name="recordings" id="form_recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: revert-layer;">\n            
  // <& recordings.recordings_item ...
  { 
#line 247 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 247 "recordings.ecpp"
    _tnt_cq7.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 247 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 247 "recordings.ecpp"
    _tnt_cq7.add( "irecording_item", (irecording_item));
#line 247 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[42]; // \n          </ul>\n        </div>\n        <input type="hidden" name="sort" value="
#line 250 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[43]; // ">\n        <input type="hidden" name="filter" value="
#line 251 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[44]; // ">\n        <input type="hidden" name="flat" value="
#line 252 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[45]; // ">\n        <input type="hidden" name="history_num_back" value="
#line 253 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[46]; // ">\n
#line 254 "recordings.ecpp"
       if (!recording_item.empty()) {

  reply.out() << _tntChunks[47]; //         <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 256 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[48]; // </button>\n
  reply.out() << _tntChunks[49]; // \n        </div>\n
#line 259 "recordings.ecpp"
       }

  reply.out() << _tntChunks[50]; //       </form>\n    </td></tr>\n
#line 262 "recordings.ecpp"

    }
std::chrono::duration<double> timeNeeded = std::chrono::high_resolution_clock::now() - timeStart;
dsyslog("live, time recordings.ecpp: %f", timeNeeded.count());

  reply.out() << _tntChunks[51]; //     </tbody></table>\n    <div class="spacebar">
  reply.out() << _tntChunks[52]; // </div>\n  </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[53]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[54]; // \n
  reply.out() << _tntChunks[55]; // \n\n
  reply.out() << _tntChunks[93]; // \n
  reply.out() << _tntChunks[94]; // \n
  reply.out() << _tntChunks[133]; // \n
  reply.out() << _tntChunks[134]; // \n
  reply.out() << _tntChunks[136]; // \n
  reply.out() << _tntChunks[137]; // \n
  reply.out() << _tntChunks[147]; // \n
  reply.out() << _tntChunks[148]; // \n
  reply.out() << _tntChunks[158]; // \n
  reply.out() << _tntChunks[159]; // \n
  reply.out() << _tntChunks[178]; // \n\n
  reply.out() << _tntChunks[179]; // \n
  reply.out() << _tntChunks[196]; // \n
  reply.out() << _tntChunks[197]; // \n
  reply.out() << _tntChunks[202]; // \n
  reply.out() << _tntChunks[203]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecording_item = qparam.get< uintptr_t >("irecording_item", ( 0));
uintptr_t iOpenTreeNodes = qparam.get< uintptr_t >("iOpenTreeNodes", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 283 "recordings.ecpp"

// get rec item of this (current) dir
RecordingsItemDirPtr recItemThisDir = *(static_cast<RecordingsItemDirPtr *>((void *)iRecItem) );
cToSvConcat<0> *recording_item = static_cast<cToSvConcat<0> *>((void *)irecording_item );
std::string openTreeNodes= *(static_cast<std::string *>((void *)iOpenTreeNodes) );
int level = recItemThisDir->Level();

// data for dirs, and prepare loop over dirs
const_rec_iterator<RecordingsItemDirPtr> l_dir_iterator = recItemThisDir->get_dir_iterator();
if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") l_dir_iterator.set_backwards(true);

bool hasSubDirs = false;
for (const RecordingsItemDirPtr &recItem: l_dir_iterator) {
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>

// search trough directory for new recordings
  bool newR = false;
  if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
  cToSvXxHash32 idHash(cToSvConcat(parentIdHash, recItem->Name()));
  iRecItem = (uintptr_t)&recItem;

  reply.out() << _tntChunks[56]; //   <li class="recording">\n    <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 308 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[57]; // ')">\n    <table><tr>\n      
#line 310 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[58]; //         <td class = "space">\n          <img src="img/transparent.png" style="width: calc(var(--icon-width, 16px) * 
#line 312 "recordings.ecpp"
  reply.sout() << ( level );
  reply.out() << _tntChunks[59]; // ); height: var(--icon-height, 16px)" />\n        </td>\n      
#line 314 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[60]; //       <td class="space">\n        <img class="iconic button recording-expander" src="
#line 316 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[61]; // icon_overlay_plus.png" />\n      </td><td class="space">\n        <img class="recording_folder" src="
#line 318 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[62]; // folder_closed.png" />\n      </td>\n
#line 320 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[63]; //         <td class = space>\n          <div class="thumb">\n            <img data-src="/tvscraper/
#line 323 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[64]; // "\n              class="
#line 324 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[65]; // "\n            />\n          </div>\n        </td>\n
#line 328 "recordings.ecpp"
         }

  reply.out() << _tntChunks[66]; //     <td class="recording_folder_name
#line 329 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[67]; // ">\n      
#line 330 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[68]; // \n    </td></tr></table>\n    </div>\n    <ul id="fldr_
#line 333 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[69]; // " class="recordingslist" style="display: none;">\n      
  // <& recordings.recordings_item ...
  { 
#line 334 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 334 "recordings.ecpp"
    _tnt_cq8.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 334 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 334 "recordings.ecpp"
    _tnt_cq8.add( "irecording_item", (irecording_item));
#line 334 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 334 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[70]; // \n    </ul>\n  </li>\n  
#line 337 "recordings.ecpp"

  hasSubDirs = true;
} // end of loop over subdirs
// now the items

const_rec_iterator<RecordingsItemRec*> l_rec_iterator = recItemThisDir->get_rec_iterator();

// do we have to get/write the recording details?
// we have to, if currentFlat == true || level == 0 || this folder is open (cookie)
bool write_recs = level == 0;
if (!write_recs) {
// check: is this folder open (cookie)?
  auto equal_fldf = [parentIdHash](cSv f) { return f.length() > 5 && f.compare(5, std::string_view::npos, parentIdHash) == 0; };
  cSplit splitOpenTreeNodes(openTreeNodes, ',', eSplitDelimBeginEnd::optional);
  write_recs = std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end();
}
if (write_recs) {
  
  reply.out() << _tntChunks[71]; // <script>\n  
#line 356 "recordings.ecpp"

  std::chrono::time_point<std::chrono::high_resolution_clock> timeStart_recs = std::chrono::high_resolution_clock::now();
  for (const RecordingsItemRec *rPtr: l_rec_iterator)
  {
    recording_item->clear();
    rPtr->AppendAsJSArray(*recording_item);
  
  reply.out() << _tntChunks[72]; // recs[
#line 363 "recordings.ecpp"
  reply.out() << (cToSvInt(rPtr->Id()));
  reply.out() << _tntChunks[73]; // ]=[
#line 363 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[74]; // ]\n  
#line 364 "recordings.ecpp"

  }
  std::chrono::duration<double> timeNeeded_recs = std::chrono::high_resolution_clock::now() - timeStart_recs;
//  dsyslog("live, time recordings.ecpp recs lv 0: %f", timeNeeded_recs.count());
  l_rec_iterator.set_begin();
  
  reply.out() << _tntChunks[75]; // \n</script>\n  
#line 372 "recordings.ecpp"

}
  if (l_rec_iterator == iterator_end()) {
    if (!hasSubDirs) {
      
  reply.out() << _tntChunks[76]; //       <script>\n        rec_ids["fldr_
#line 378 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[77]; // "] = []\n        document.write(\n          '<li class="recording">' +\n            '<table class="recordings" width="100%">' +\n              '<tbody>' +\n                '<tr class="recording_item">' +\n                
#line 384 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[78]; //                   '<td class = "space">' +\n                    '<img src="img/transparent.png" style="width: calc(var(--icon-width, 16px) * 
#line 386 "recordings.ecpp"
  reply.sout() << ( level );
  reply.out() << _tntChunks[79]; // ); height: var(--icon-height, 16px)" />' +\n                  '</td>' +\n                
#line 388 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[80]; //                   '<td class="message">
#line 389 "recordings.ecpp"
  reply.sout() << ( tr("No matching recordings found") );
  reply.out() << _tntChunks[81]; // </td>' +\n                '</tr>' +\n              '</tbody>' +\n            '</table>' +\n          '</li>'\n        )\n      </script>\n      
#line 396 "recordings.ecpp"

    }
  } else {
    bool first = true;
    const char *displayFolder = "1";
    recording_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recording_item, l_rec_iterator, first);
    
  reply.out() << _tntChunks[82]; //       <script>\n
#line 405 "recordings.ecpp"
   if (level == 0) {

  reply.out() << _tntChunks[83]; //         document.write(rec_string_d([
#line 406 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[84]; // , 
#line 406 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[85]; // , [ 
#line 406 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[86]; //  ]]))\n
#line 407 "recordings.ecpp"
   } else if (!parentIdHash.empty()) {

  reply.out() << _tntChunks[87]; //         rec_ids["fldr_
#line 408 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[88]; // "] = [
#line 408 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[89]; // , 
#line 408 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[90]; // , [ 
#line 408 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[91]; //  ]]\n
#line 409 "recordings.ecpp"
   }

  reply.out() << _tntChunks[92]; //       </script>\n    
#line 411 "recordings.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 418 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[95]; // <span class="label bold">
#line 419 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[96]; //  </span>\n<a href="recordings.html\?sort=
#line 420 "recordings.ecpp"
  reply.sout() << ( (currentSort == "nameasc") ? "namedesc" : "nameasc");
  reply.out() << _tntChunks[97]; // &filter=
#line 420 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[98]; // &flat=
#line 420 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[99]; // " 
  // <& setactive ...
  { 
#line 420 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 420 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 420 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[100]; //  >
#line 420 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[101]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 422 "recordings.ecpp"
  reply.sout() << ( (currentSort == "datedesc") ? "dateasc" : "datedesc");
  reply.out() << _tntChunks[102]; // &filter=
#line 422 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[103]; // &flat=
#line 422 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[104]; // " 
  // <& setactive ...
  { 
#line 422 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 422 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 422 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[105]; //  >
#line 422 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[106]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 424 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[107]; // &flat=
#line 424 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[108]; // " 
  // <& setactive ...
  { 
#line 424 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 424 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 424 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[109]; //  >
#line 424 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[110]; // </a>\n
#line 425 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[111]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 429 "recordings.ecpp"
  reply.sout() << ( (currentSort == "errorsts") ? "errorsdur" : "errorsts" );
  reply.out() << _tntChunks[112]; // &filter=
#line 429 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[113]; // &flat=
#line 429 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[114]; // " 
  // <& setactive ...
  { 
#line 429 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 429 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 429 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[115]; // >
#line 429 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[116]; // </a>\n
#line 430 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[117]; // <span class="sep">|</span>\n<span class="label bold">
#line 434 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[118]; // :&nbsp;<input type="text" name="filter" value="
#line 434 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[119]; // " id="filter" onchange="filterRecordings(this, '
#line 434 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[120]; // ', '
#line 434 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[121]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 434 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 434 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 434 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[122]; // </span>\n<img onclick="clearRecordingsFilter(document.getElementById('filter'), '
#line 435 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[123]; // ', '
#line 435 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[124]; // ')" class="icon button clear-filter" src="
#line 435 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "icon_overlay_cross.png") );
  reply.out() << _tntChunks[125]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 435 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 435 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Clear filter")));
#line 435 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[126]; // />\n
#line 436 "recordings.ecpp"

if (currentFlat != "true") {

  reply.out() << _tntChunks[127]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" class="icon button expand-all" src="
#line 440 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "icon_overlay_plus.png") );
  reply.out() << _tntChunks[128]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 440 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 440 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Expand all folders")));
#line 440 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[129]; // />\n<img onclick="CollapseAll()" class="icon button collapse-all" src="
#line 441 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "icon_overlay_minus.png") );
  reply.out() << _tntChunks[130]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 441 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 441 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Collapse all folders")));
#line 441 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[131]; // />\n
#line 442 "recordings.ecpp"

}

  reply.out() << _tntChunks[132]; // <br />\n
#line 446 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 454 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[135]; // class="active"
#line 455 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
std::string className = qparam.get< std::string >("className");
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 468 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[138]; // <a href="epginfo.html\?epgid=del_
#line 468 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[139]; // &sort=
#line 468 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[140]; // &filter=
#line 468 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[141]; // &flat=
#line 468 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[142]; // &history_num_back=
#line 468 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[143]; // " 
  // <& tooltip.hint ...
  { 
#line 468 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 468 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Delete this recording from hard disc!")));
#line 468 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[144]; // ><img class="
#line 468 "recordings.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[145]; // " src="
#line 468 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[146]; // " alt="" /></a>
#line 468 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
std::string className = qparam.get< std::string >("className");
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 481 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[149]; // <a href="edit_recording.html\?recid=
#line 481 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[150]; // &sort=
#line 481 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[151]; // &filter=
#line 481 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[152]; // &flat=
#line 481 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[153]; // &history_num_back=
#line 481 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[154]; // "><img class="
#line 481 "recordings.ecpp"
  reply.sout() << ( className );
  reply.out() << _tntChunks[155]; // " src="
#line 481 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[156]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 481 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 481 "recordings.ecpp"
    _tnt_cq18.add( "text", (tr("Edit recording")));
#line 481 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[157]; //  /></a>
#line 481 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::todel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::todel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string todel = qparam.get< std::string >("todel");
std::string confirmed = qparam.get< std::string >("confirmed");
std::string history_num_back = qparam.get< std::string >("history_num_back");
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 491 "recordings.ecpp"

  std::string recording_Name;
  {
    LOCK_RECORDINGS_READ;
    const cRecording *recording = RecordingsManager::GetByHash(todel, Recordings);
    if (recording == nullptr)
      throw HtmlError(tr("Couldn't find recording or no recordings available"));
    recording_Name = recording->Name();
  }
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  if (confirmed == "confirmed") {
    RecordingsManager::DeleteRecording(todel);

  reply.out() << _tntChunks[160]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-
#line 508 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[161]; // );\n  </script>\n</html>\n
#line 511 "recordings.ecpp"
  } else {

  reply.out() << _tntChunks[162]; // <div class="epg_description" id="del_
#line 512 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[163]; // ">\n  <div class="station">\n    <div class="boxheader"><div class="caption">
#line 514 "recordings.ecpp"
  reply.sout() << ( tr("Delete recordings") );
  reply.out() << _tntChunks[164]; // </div></div>\n  </div>\n  <div class="epg_content">\n    <form>\n      <input type="hidden" name="epgid" value="
#line 518 "recordings.ecpp"
  reply.sout() << (todel);
  reply.out() << _tntChunks[165]; // " >\n      <input type="hidden" name="delete_rec" value="confirmed" >\n      <input type="hidden" name="history_num_back" value="
#line 520 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[166]; // " id="history_del_
#line 520 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[167]; // ">\n      <div class="about_head">
#line 521 "recordings.ecpp"
  reply.sout() << ( cToSvFormated(tr("Delete recording \"%s\"?"), recording_Name.empty()?"No recording name available":recording_Name.c_str() ) );
  reply.out() << _tntChunks[168]; // </div>\n      <div class="about_section">\n        <div class="tabular">\n          <div class="about_left">\n            <button id="confirm_del_
#line 525 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[169]; // " class="green" type="button" onclick="delete_rec_back('
#line 525 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[170]; // ', 
#line 525 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[171]; // )">
#line 525 "recordings.ecpp"
  reply.sout() << ( tr("Delete"));
  reply.out() << _tntChunks[172]; // </button>\n          </div>\n          <div class="about_right">\n
  reply.out() << _tntChunks[173]; // \n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf("epginfo.html\?") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-
#line 534 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[174]; // );\n  }\n}\n</script>\n            <button id="close_del_
#line 538 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[175]; // " type="button" class="red" onclick="back_depending_referrer(1, 
#line 538 "recordings.ecpp"
  reply.sout() << (history_num_back );
  reply.out() << _tntChunks[176]; // )">
#line 538 "recordings.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[177]; // </button>\n          </div>\n        </div>\n      </div>\n    </form>\n  </div>\n</div>\n
#line 545 "recordings.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 560 "recordings.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 561 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 561 "recordings.ecpp"
    _tnt_cq19.add( "action", "play_recording");
#line 561 "recordings.ecpp"
    _tnt_cq19.add( "alt", "");
#line 561 "recordings.ecpp"
    _tnt_cq19.add( "className", "icon");
#line 561 "recordings.ecpp"
    _tnt_cq19.add( "image", "play.png");
#line 561 "recordings.ecpp"
    _tnt_cq19.add( "param", (id));
#line 561 "recordings.ecpp"
    _tnt_cq19.add( "tip", (tr("play this recording")));
#line 561 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[180]; // \n
#line 562 "recordings.ecpp"
   }

  // <& pageelems.hls_recording ...
  { 
#line 563 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 563 "recordings.ecpp"
    _tnt_cq20.add( "className", "icon");
#line 563 "recordings.ecpp"
    _tnt_cq20.add( "recId", (id));
#line 563 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_recording"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[181]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 564 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 564 "recordings.ecpp"
    _tnt_cq21.add( "className", "icon");
#line 564 "recordings.ecpp"
    _tnt_cq21.add( "recid", (id));
#line 564 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[182]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 565 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 565 "recordings.ecpp"
    _tnt_cq22.add( "className", "icon");
#line 565 "recordings.ecpp"
    _tnt_cq22.add( "s_IMDB_ID", (s_IMDB_ID));
#line 565 "recordings.ecpp"
    _tnt_cq22.add( "title", (title));
#line 565 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[183]; // \n
  // <& recordings.edit_rec ...
  { 
#line 566 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 566 "recordings.ecpp"
    _tnt_cq23.add( "className", "icon");
#line 566 "recordings.ecpp"
    _tnt_cq23.add( "filter", (filter));
#line 566 "recordings.ecpp"
    _tnt_cq23.add( "flat", (flat));
#line 566 "recordings.ecpp"
    _tnt_cq23.add( "history_num_back", (history_num_back));
#line 566 "recordings.ecpp"
    _tnt_cq23.add( "id", (id));
#line 566 "recordings.ecpp"
    _tnt_cq23.add( "sort", (sort));
#line 566 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[184]; // \n
  // <& recordings.del_rec ...
  { 
#line 567 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 567 "recordings.ecpp"
    _tnt_cq24.add( "className", "icon");
#line 567 "recordings.ecpp"
    _tnt_cq24.add( "filter", (filter));
#line 567 "recordings.ecpp"
    _tnt_cq24.add( "flat", (flat));
#line 567 "recordings.ecpp"
    _tnt_cq24.add( "history_num_back", (history_num_back));
#line 567 "recordings.ecpp"
    _tnt_cq24.add( "id", (id));
#line 567 "recordings.ecpp"
    _tnt_cq24.add( "sort", (sort));
#line 567 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[185]; // \n
#line 568 "recordings.ecpp"

const RecordingsItemRec* recPtr = RecordingsManager::GetByIdHash(id);
if (recPtr) {
  const char *sdhd = nullptr;
  cToSvConcat frameParams;
  StringAppendFrameParams(frameParams, recPtr);
  switch (recPtr->FrameWidth()) {
    case 720:
      sdhd = "720x576";
      break;
    case 1280:
      sdhd = "1280x720";
      break;
    case 1920:
      sdhd = "1920x1080";
      break;
    case 3840:
      sdhd = "3840x2160";
      break;
    default:
      break;
  }
  int video_SD_HD = recPtr->SD_HD();
  if (!sdhd) sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": "ud";
  cToSvConcat duration;
  AppendDuration(duration, tr("%d:%02d"), recPtr->Duration() );

  reply.out() << _tntChunks[186]; // <div id="icons-
#line 595 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[187]; // " class="recording_status"></div>\n<script class="injectIcons">\ninjectErrorHdSdIcon("icons-
#line 597 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[188]; // ", 
#line 597 "recordings.ecpp"
  reply.sout() << (cToSvInt(recPtr->RecordingErrors()));
  reply.out() << _tntChunks[189]; // , 
#line 597 "recordings.ecpp"
  reply.sout() << (cToSvInt(recPtr->DurationDeviation()));
  reply.out() << _tntChunks[190]; // , "
#line 597 "recordings.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[191]; // ", "
#line 597 "recordings.ecpp"
  reply.sout() << (recPtr->ChannelName());
  reply.out() << _tntChunks[192]; // ", "
#line 597 "recordings.ecpp"
  reply.sout() << (duration);
  reply.out() << _tntChunks[193]; // ", 
#line 597 "recordings.ecpp"
  reply.sout() << ( cToSvInt(recPtr->NumberTsFiles()) );
  reply.out() << _tntChunks[194]; // , "
#line 597 "recordings.ecpp"
  reply.sout() << (frameParams);
  reply.out() << _tntChunks[195]; // ")\n</script>\n
#line 599 "recordings.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[198]; // <img src="
#line 611 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[199]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 611 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 611 "recordings.ecpp"
    _tnt_cq25.add( "text", (archived));
#line 611 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[200]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 612 "recordings.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 612 "recordings.ecpp"
    _tnt_cq26.add( "s_IMDB_ID", (s_IMDB_ID));
#line 612 "recordings.ecpp"
    _tnt_cq26.add( "title", (title));
#line 612 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[201]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 30 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 35 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 36 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 37 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 38 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 617 "recordings.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 617 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[204]; // \n
#line 618 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
