////////////////////////////////////////////////////////////////////////
// rwd_recording.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.rwd_recording")

// <%pre>
#line 1 "rwd_recording.ecpp"


#include <setup.h>
#include <recman.h>
#include <vdr/menu.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("rwd_recording");

static const char* rawData = "\010\000\000\000\t\000\000\000\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("rwd_recording " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string param = qparam.get< std::string >("param");
  // </%args>

#line 14 "rwd_recording.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 16 "rwd_recording.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }
  reply.setContentType( "application/xml" );

  const char *error_message = "";
  switch (RecordingsManager::CheckReplay(param)) {
    case 1: error_message = tr("Couldn't find recording or no recordings available."); break;
    case 2: error_message = tr("Not playing a recording."); break;
    case 3: error_message = tr("Not playing the same recording as from request."); break;
    default: break;
  }

  if (*error_message == 0) {
#if APIVERSNUM >= 20402
    cMutexLock mutexLock;
    cReplayControl* replayControl = reinterpret_cast<cReplayControl*>(cControl::Control(mutexLock));
#else
    cReplayControl* replayControl = reinterpret_cast<cReplayControl*>(cControl::Control());
#endif
    if (replayControl)
      replayControl->Backward();
    else
      error_message = tr("Cannot control playback!");
  }


  // <& xmlresponse.ajax ...
  { 
#line 46 "rwd_recording.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 46 "rwd_recording.ecpp"
    _tnt_cq0.add( "error", (error_message));
#line 46 "rwd_recording.ecpp"
    _tnt_cq0.add( "name", ("rwd_recording"));
#line 46 "rwd_recording.ecpp"
    _tnt_cq0.add( "pname", ("recording"));
#line 46 "rwd_recording.ecpp"
    _tnt_cq0.add( "result", (*error_message == 0));
#line 46 "rwd_recording.ecpp"
    _tnt_cq0.add( "value", (param));
#line 46 "rwd_recording.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ajax"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
