////////////////////////////////////////////////////////////////////////
// searchresults.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.searchresults")

// <%pre>
#line 1 "searchresults.ecpp"


#include <epgsearch.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timers.h>
#include <recman.h>
#include <services.h>


using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class searchresults_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        searchresults_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    searchresults_actions_type searchresults_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("searchresults");

static const char* rawData = "\134\000\000\000\316\000\000\000\333\000\000\000\340\000\000\000\345\000\000\000M\001\000"
  "\000R\001\000\000\206\001\000\000\215\001\000\000\225\001\000\000\226\001\000\000\240\001\000\000\241\001\000\000\314"
  "\001\000\000\316\001\000\000\333\001\000\000\367\001\000\000;\002\000\000<\002\000\000>\002\000\000d\002\000\000f\002"
  "\000\000k\002\000\000\n<html>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" "
  "/>\n    <title>VDR-Live - </title>\n    \n    \n    \n  </head>\n  <body onpagehide=\"saveScrollPosition('content')\""
  " onpageshow=\"restoreScrollPosition()\">\n    \n    \n    <div id=\"content\">\n      <div class=\"spacebar\"></div>"
  "\n        \n          \n<script>\ndocument.write(addEventListString(, ))\n</script>\n      <div class=\"spacebar\"></"
  "div>\n    </div>\n    <script>imgLoad()</script>\n  </body>\n</html>\n\n\n\n\n<a href=\"edit_searchtimer.html\?search"
  "=\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    searchresults_actions(*this, "searchresults_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("searchresults " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string searchtimerid = qparam.get< std::string >("searchtimerid");
std::string searchtimerquery = qparam.get< std::string >("searchtimerquery");
std::string searchplain = qparam.get< std::string >("searchplain");
  // </%args>

#line 22 "searchresults.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 25 "searchresults.ecpp"
  typedef std::string searchterm_type;
  TNT_REQUEST_PAGE_VAR(std::string, searchterm, (""));   // <%request> std::string searchterm("")
  _tnt_ignore_unused<searchterm_type>(searchterm);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 28 "searchresults.ecpp"

  reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }

  pageTitle = tr("Search results");
  SearchResults results;
  if (!searchtimerid.empty())
    results.GetByID(parse_int< int >(searchtimerid));
  if (!searchtimerquery.empty())
    results.GetByQuery(SearchResults::GetQuery(searchtimerquery));
  if (!searchplain.empty())
  {
    SearchTimer s;
    s.SetId(0);
    s.SetSearch(searchplain);
    s.SetSearchMode(0);
    s.SetUseTitle(true);
    s.SetUseSubtitle(false);
    s.SetUseDescription(false);
    results.GetByQuery(s.ToText());

    searchterm = searchplain;
  }

  // <& pageelems.doc_type ...
  { 
#line 56 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 56 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 60 "searchresults.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 61 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 61 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 62 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 62 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 63 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 63 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n  </head>\n  <body onpagehide="saveScrollPosition('content')" onpageshow="restoreScrollPosition()">\n    
  // <& pageelems.logo ...
  { 
#line 66 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 66 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& menu ...
  { 
#line 67 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 67 "searchresults.ecpp"
    _tnt_cq5.add( "active", ("searchepg"));
#line 67 "searchresults.ecpp"
    _tnt_cq5.add( "component", ("searchresults.searchresults_actions"));
#line 67 "searchresults.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    <div id="content">\n      <div class="spacebar">
  reply.out() << _tntChunks[7]; // </div>\n
#line 70 "searchresults.ecpp"
      if (results.size() == 0) {

  reply.out() << _tntChunks[8]; //         
#line 71 "searchresults.ecpp"
  reply.sout() << ( tr("No search results") );
  reply.out() << _tntChunks[9]; // \n
#line 72 "searchresults.ecpp"

       } else {
        std::string current_day = "";
        bool display_pictures = !(LiveSetup().GetTvscraperImageDir().empty());
        int col_span = 4;
        if (display_pictures) col_span++;
        cToSvConcat<0> epg_item;
        epg_item.reserve(10000);
        epg_item.concat('[');
        for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
          LOCK_TIMERS_READ;
          LOCK_CHANNELS_READ;
          const cChannel* channel = result->GetChannel(Channels);
          if (!channel) continue;
          LOCK_RECORDINGS_READ;  // required because appendEpgItemWithRecItem needs also lock on recordings
          LOCK_SCHEDULES_READ;
          const cEvent *event = result->GetEvent(channel, Schedules);
          if (!event || !event->StartTime() ) continue;
          current_day = appendEpgItemWithRecItem(epg_item, current_day, event, channel, true, Timers);
        }
        epg_item.concat("]]]");
        if (current_day.empty() ) {

  reply.out() << _tntChunks[10]; //           
#line 95 "searchresults.ecpp"
  reply.sout() << ( tr("No search results") );
  reply.out() << _tntChunks[11]; // \n
#line 96 "searchresults.ecpp"
       } else {

  reply.out() << _tntChunks[12]; // <script>\ndocument.write(addEventListString(
#line 98 "searchresults.ecpp"
  reply.sout() << (col_span);
  reply.out() << _tntChunks[13]; // , 
#line 98 "searchresults.ecpp"
  reply.out() << ( epg_item.c_str() );
  reply.out() << _tntChunks[14]; // ))\n</script>\n
#line 100 "searchresults.ecpp"
       } }

  reply.out() << _tntChunks[15]; //       <div class="spacebar">
  reply.out() << _tntChunks[16]; // </div>\n    </div>\n    <script>imgLoad()</script>\n  </body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[17]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[18]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::searchresults_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("searchresults::searchresults_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 25 "searchresults.ecpp"
  typedef std::string searchterm_type;
  TNT_REQUEST_PAGE_VAR(std::string, searchterm, (""));   // <%request> std::string searchterm("")
  _tnt_ignore_unused<searchterm_type>(searchterm);
#line 22 "searchresults.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[19]; // <a href="edit_searchtimer.html\?search=
#line 111 "searchresults.ecpp"
  reply.sout() << ( searchterm );
  reply.out() << _tntChunks[20]; // ">
#line 111 "searchresults.ecpp"
  reply.sout() << ( tr("New search timer") );
  reply.out() << _tntChunks[21]; // </a>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
