////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"


#include <setup.h>
#include <stringhelpers.h>
#include <tools.h>
#include <users.h>
#include <live.h>
#include <livefeatures.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "p\001\000\000\336\001\000\000\353\001\000\000\360\001\000\000\351\005\000\000\356\005\000"
  "\000\"\006\000\000\217\006\000\000\327\006\000\000\252\007\000\000\031\010\000\000\222\010\000\000\217\t\000\000\327"
  "\t\000\000m\n\000\000\271\n\000\000o\013\000\000\354\013\000\000Y\014\000\000\250\014\000\000\317\014\000\0006\015"
  "\000\000\211\015\000\000\244\015\000\000\264\015\000\000\033\016\000\000r\016\000\000$\017\000\000\237\017\000\000"
  "\021\020\000\000\222\020\000\000\267\020\000\000\004\021\000\000\207\021\000\000\001\022\000\000u\022\000\000\350\022"
  "\000\000y\023\000\000\254\023\000\000\337\023\000\000\021\024\000\000D\024\000\000\205\024\000\000\024\025\000\000"
  "\341\025\000\000\225\026\000\000\020\027\000\000\202\027\000\000\347\027\000\000_\030\000\000\264\030\000\000\322\030"
  "\000\0005\031\000\000\367\031\000\000Z\032\000\000\355\032\000\000L\033\000\000\341\033\000\000A\034\000\000\342\034"
  "\000\000H\035\000\000b\036\000\000\261\036\000\000\330\036\000\000\211\037\000\000\375\037\000\000\211 \000\000 !\000"
  "\000\223!\000\000 \"\000\000!\"\000\000U\"\000\000V\"\000\000\207\"\000\000\210\"\000\000\276\"\000\000\277\"\000\000"
  "\362\"\000\000\363\"\000\000\"#\000\000##\000\000\245#\000\000\375#\000\000\032$\000\000\034$\000\000\035$\000\000'$"
  "\000\000\023%\000\000\217%\000\000\264%\000\000\265%\000\000\266%\000\000\n<html>\n  <head>\n<meta name=\"viewport\" "
  "content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n    <script type=\"te"
  "xt/javascript\"><!--\n    function initform()\n    {\n      changeduseauth(document.getElementById(\"useauth\"));\n  "
  "    changedChanGroups();\n      if (document.getElementById(\"message\").value != \"\")\n        alert(document.getEl"
  "ementById(\"message\").value);\n    }\n    function changeduseauth(selection)\n    {\n      document.getElementById("
  "\"authsection\").style.display = (selection.checked \? \"revert-layer\" : \"none\");\n    }\n    function setauthchan"
  "ged(selection)\n    {\n      document.getElementById(\"authchanged\").value = 1;\n    }\n    function changedChanGrou"
  "ps() {\n      if (document.getElementById(\"channelGroupsGen_individual\").checked) {\n         document.getElementBy"
  "Id(\"individual_channelGroups_section\").style.display = \"revert-layer\"\n      } else {\n         document.getEleme"
  "ntById(\"individual_channelGroups_section\").style.display = \"none\"\n      }\n    }\n    //--></script>\n  </head>"
  "\n  <body onload=\"initform()\" onpagehide=\"saveScrollPosition('content')\" onpageshow=\"restoreScrollPosition()\">"
  "\n    \n    \n    <div id=\"content\">\n      <div class=\"spacebar\"></div>\n      <form method=\"post\" action=\"se"
  "tup.html\">\n        <input type=\"hidden\" name=\"authchanged\" value=\"\" id=\"authchanged\"/>\n        <input type"
  "=\"hidden\" name=\"message\" value=\"\" id=\"message\"/>\n        <table class=\"form\" cellpadding=\"0\" cellspacing"
  "=\"0\">\n          <tr class=\"head\">\n            <td  class=\"toprow leftcol rightcol\" colspan=\"2\"><div class="
  "\"boxheader\"><div class=\"caption\"></div></div></td>\n          </tr>\n          <tr>\n            <td class=\"labe"
  "l leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <input type=\""
  "checkbox\" name=\"useauth\" id=\"useauth\" value=\"1\" onclick=\"changeduseauth(this)\"/>\n              <div id=\"au"
  "thsection\" style=\"display: none\">\n              <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"d"
  "ependent\">\n              <tr>\n                <td class=\"label\"><div class=\"withmargin\">:</div></td>\n        "
  "        <td><input type=\"text\" name=\"login\" value=\"\" id=\"login\" onchange=\"setauthchanged(this)\" /></td>\n  "
  "            </tr>\n              <tr>\n                <td class=\"label\"><div class=\"withmargin\">:</div></td>\n  "
  "              <td><input  type=\"password\" name=\"pass\" value=\"\" id=\"pass\" onchange=\"setauthchanged(this)\" />"
  "</td>\n              </tr>\n              <tr>\n                <td colspan=\"2\" class=\"label\"><div class=\"withma"
  "rgin\"><a href=\"users.html\"></a></div></td>\n              </tr>\n              <tr>\n                <td colspan="
  "\"2\" class=\"label\"><div class=\"withmargin\"></div></td>\n              </tr>\n              <tr>\n               "
  " <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"text\" name=\"localnet"
  "mask\" value=\"\" id=\"localnetmask\" />\n                </td>\n              </tr>\n              <tr>\n           "
  "     <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"text\" name=\"loca"
  "lnetmaskIPv6\" value=\"\" id=\"localnetmaskIPv6\" />\n                </td>\n              </tr>\n              <tr>"
  "\n                <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"check"
  "box\" name=\"allowlocalhost\" value=\"1\"/>\n              </tr>\n              </table>\n              </div>\n     "
  "       </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</d"
  "iv></td>\n            <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"showLogo\" id=\"showLogo"
  "\" value=\"1\"/>\n            </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div cl"
  "ass=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"s"
  "howInfoBox\" id=\"showInfoBox\" value=\"1\"/>\n            </td>\n          </tr>\n          <tr>\n            <td cl"
  "ass=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <inp"
  "ut type=\"checkbox\" name=\"useStreamdev\" id=\"useStreamdev\" value=\"1\"/>\n            </td>\n          </tr>\n   "
  "           <tr>\n                <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n                "
  "<td class=\"rightcol\"><input type=\"text\" name=\"streamdevport\" id=\"streamdevport\" value=\"\" /></td>\n         "
  "     </tr>\n              <tr>\n                <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n "
  "               <td class=\"rightcol\"><select name=\"streamdevtype\" size=\"1\" id=\"streamdevtype\">\n              "
  "    <option value=\"TS\" >TS</option>\n                  <option value=\"PES\" >PES</option>\n                  <opti"
  "on value=\"PS\" >PS</option>\n                  <option value=\"ES\" >ES</option>\n                  <option value=\""
  "EXT\" >EXT</option>\n                </select></td>\n              </tr>\n                                        <tr"
  ">\n                                                <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>"
  "\n                                                <td class=\"rightcol\">\n                                          "
  "              <input type=\"checkbox\" name=\"markNewRec\" id=\"markNewRec\" value=\"1\"/>\n                         "
  "                       </td>\n                                        </tr>\n          <tr>\n            <td class=\""
  "label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <input typ"
  "e=\"checkbox\" name=\"showIMDb\" id=\"showIMDb\" value=\"1\"/>\n            </td>\n          </tr>\n          <tr>\n "
  "           <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\"><in"
  "put type=\"number\" min=\"0\" name=\"lastchannel\" value=\"\" id=\"lastchannel\" /></td>\n          </tr>\n          "
  "<tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightco"
  "l\"><input type=\"text\" name=\"times\" value=\"\" id=\"times\" />\n              </td>\n          </tr>\n          <"
  "tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol"
  "\"><div class=\"options\">\n             <div class=\"dotted\">\n               <input id=\"channelGroupsGen_default"
  "\" name=\"channelGroupsGen\" value=\"default\"  type=\"radio\" onclick=\"changedChanGroups()\"/>\n               <lab"
  "el for=\"channelGroupsGen_default\"></label>\n             </div>\n             <div class=\"dotted\">\n             "
  "  <input id=\"channelGroupsGen_vdr\" name=\"channelGroupsGen\" value=\"vdr\"  type=\"radio\" onclick=\"changedChanGro"
  "ups()\"/>\n               <label for=\"channelGroupsGen_vdr\"></label>\n             </div>\n             <div class="
  "\"dotted\">\n               <input id=\"channelGroupsGen_flat\" name=\"channelGroupsGen\" value=\"flat\"  type=\"radi"
  "o\" onclick=\"changedChanGroups()\"/>\n               <label for=\"channelGroupsGen_flat\"></label>\n             </d"
  "iv>\n             <div class=\"dotted\">\n               <input id=\"channelGroupsGen_individual\" name=\"channelGrou"
  "psGen\" value=\"individual\"  type=\"radio\" onclick=\"changedChanGroups()\"/>\n               <label for=\"channelGr"
  "oupsGen_individual\"></label>\n             </div>\n           </div>\n\n           <div id=\"individual_channelGroup"
  "s_section\" style=\"display: none\">\n             <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"de"
  "pendent\">\n             <tr>\n               <td class=\"label\"><div class=\"withmargin\">:</div></td>\n           "
  "    <td><input type=\"text\" name=\"channelGroups\" value=\"\" id=\"channelGroups\" />\n               </td>\n       "
  "      </tr>\n             </table>\n           </div>\n\n            </td>\n          </tr>\n          <tr>\n        "
  "    <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\"><input typ"
  "e=\"number\" min=\"1\" max= \"23\" name=\"scheduleDuration\" value=\"\" id=\"scheduleDuration\" />\n              </t"
  "d>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n"
  "            <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"showChannelsWithoutEPG\" id=\"show"
  "ChannelsWithoutEPG\" value=\"1\"/>\n            </td>\n          </tr>\n\n          <tr>\n            <td class=\"lab"
  "el leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\"><select name=\"startscreen\" "
  "size=\"1\" id=\"startscreen\">\n              <option value=\"whatsonnow\" ></option>\n              <option value=\""
  "whatsonnext\" ></option>\n              <option value=\"schedule\" ></option>\n              <option value=\"multisch"
  "edule\" ></option>\n              <option value=\"recordings\" ></option>\n              <option value=\"timers\" ></"
  "option>\n            </select></td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div cl"
  "ass=\"withmargin\">:</div></td>\n            <td class=\"rightcol\"><select name=\"theme\" size=\"1\" id=\"theme\">\n"
  "              <option value=\"\" ></option>\n            </select></td>\n          </tr>\n          <tr>\n           "
  " <td class=\"buttonpanel leftcol rightcol bottomrow\" colspan=\"2\">\n              <div class=\"withmargin\">\n     "
  "         <button class=\"green\" type=\"submit\" name=\"save\" ></button>\n              </div>\n            </td>\n "
  "         </tr>\n        </table>\n      </form>\n      <div class=\"spacebar\"></div>\n    </div>\n  </body>\n</html>"
  "\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string lastchannel = qparam.get< std::string >("lastchannel");
bool useauth = qparam.get< bool >("useauth", ( false));
std::string login = qparam.get< std::string >("login");
std::string pass = qparam.get< std::string >("pass");
std::string times = qparam.get< std::string >("times");
std::string channelGroupsGen = qparam.get< std::string >("channelGroupsGen");
std::string channelGroups = qparam.get< std::string >("channelGroups");
std::string scheduleDuration = qparam.get< std::string >("scheduleDuration");
std::string startscreen = qparam.get< std::string >("startscreen");
std::string theme = qparam.get< std::string >("theme");
std::string localnetmask = qparam.get< std::string >("localnetmask");
std::string localnetmaskIPv6 = qparam.get< std::string >("localnetmaskIPv6");
std::string allowlocalhost = qparam.get< std::string >("allowlocalhost");
std::string showLogo = qparam.get< std::string >("showLogo");
std::string showInfoBox = qparam.get< std::string >("showInfoBox");
std::string useStreamdev = qparam.get< std::string >("useStreamdev");
std::string markNewRec = qparam.get< std::string >("markNewRec");
std::string showIMDb = qparam.get< std::string >("showIMDb");
std::string showChannelsWithoutEPG = qparam.get< std::string >("showChannelsWithoutEPG");
std::string streamdevport = qparam.get< std::string >("streamdevport");
std::string streamdevtype = qparam.get< std::string >("streamdevtype");
int authchanged = qparam.get< int >("authchanged", ( 0));
  // </%args>

#line 38 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 41 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}
if (!cUser::CurrentUserHasRightTo(UR_EDITSETUP))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? " checked=\"checked\"" : "" );

  std::string message;

  if ( request.getMethod() == "POST") {
    if (authchanged && useauth && (login.empty() || pass.empty()))
      message = tr("Please set login and password!");
    else
    {
      LiveSetup().SetLastChannel(lastchannel != "" ? parse_int<int>(lastchannel):0);
      LiveSetup().SetUseAuth(useauth);
      if (useauth) {
        LiveSetup().SetAdminLogin(login);
        if (pass != "")
          LiveSetup().SetAdminPassword(pass);
        LiveSetup().SetLocalNetMask(localnetmask);
        LiveSetup().SetLocalNetMaskIPv6(localnetmaskIPv6);
        LiveSetup().SetAllowLocalhost(!allowlocalhost.empty());
        LiveSetup().CheckLocalNet(request.getPeerIp());
      }
      LiveSetup().SetTimes(times);
// for multischedule
      LiveSetup().SetChannelGroupsGen(channelGroupsGen);
      LiveSetup().SetChannelGroups(channelGroups);
      LiveSetup().SetScheduleDuration(scheduleDuration);
// end multischedule
      LiveSetup().SetStartScreen(startscreen);
      LiveSetup().SetTheme(theme);
      LiveSetup().SetShowLogo(!showLogo.empty());
      LiveSetup().SetShowInfoBox(!showInfoBox.empty());
      LiveSetup().SetUseStreamdev(!useStreamdev.empty());
      LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : parse_int<int>(streamdevport));
      LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
      LiveSetup().SetMarkNewRec(!markNewRec.empty());

      LiveSetup().SetShowIMDb(!showIMDb.empty());
      LiveSetup().SetShowChannelsWithoutEPG(!showChannelsWithoutEPG.empty());
      LiveSetup().SaveSetup();

      message = tr("Setup saved.");
    }
  }
  pageTitle = tr("Setup");
  int ilastchannel = LiveSetup().GetLastChannel();
  if (ilastchannel == std::numeric_limits< int >::max())
    lastchannel = "";
  else
    lastchannel = std::string(cToSvInt(ilastchannel));

  login = LiveSetup().GetAdminLogin();
  useauth = LiveSetup().GetUseAuth();
  times = LiveSetup().GetTimes();
  channelGroups = LiveSetup().GetChannelGroups();
  channelGroupsGen = LiveSetup().GetChannelGroupsGen();
  scheduleDuration = LiveSetup().GetScheduleDuration();
  startscreen = LiveSetup().GetStartScreen();
  theme = LiveSetup().GetTheme();
  localnetmask = LiveSetup().GetLocalNetMask();
  localnetmaskIPv6 = LiveSetup().GetLocalNetMaskIPv6();
  allowlocalhost = LiveSetup().GetAllowLocalhost() ? "1" : "";
  showLogo = LiveSetup().GetShowLogo() ? "1" : "";
  showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
  useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
  streamdevport = std::string(cToSvInt(LiveSetup().GetStreamdevPort()));
  streamdevtype = LiveSetup().GetStreamdevType();
  markNewRec = LiveSetup().GetMarkNewRec() ? "1" : "";
  showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";
  showChannelsWithoutEPG = LiveSetup().GetShowChannelsWithoutEPG() ? "1" : "";

  // <& pageelems.doc_type ...
  { 
#line 120 "setup.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 120 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n  <head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 124 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 125 "setup.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 125 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 126 "setup.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 126 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    <script type="text/javascript"><!--\n    function initform()\n    {\n      changeduseauth(document.getElementById("useauth"));\n      changedChanGroups();\n      if (document.getElementById("message").value != "")\n        alert(document.getElementById("message").value);\n    }\n    function changeduseauth(selection)\n    {\n      document.getElementById("authsection").style.display = (selection.checked \? "revert-layer" : "none");\n    }\n    function setauthchanged(selection)\n    {\n      document.getElementById("authchanged").value = 1;\n    }\n    function changedChanGroups() {\n      if (document.getElementById("channelGroupsGen_individual").checked) {\n         document.getElementById("individual_channelGroups_section").style.display = "revert-layer"\n      } else {\n         document.getElementById("individual_channelGroups_section").style.display = "none"\n      }\n    }\n    //--></script>\n  </head>\n  <body onload="initform()" onpagehide="saveScrollPosition('content')" onpageshow="restoreScrollPosition()">\n    
  // <& pageelems.logo ...
  { 
#line 153 "setup.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 153 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& menu ...
  { 
#line 154 "setup.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 154 "setup.ecpp"
    _tnt_cq4.add( "active", ("setup"));
#line 154 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    <div id="content">\n      <div class="spacebar">
  reply.out() << _tntChunks[6]; // </div>\n      <form method="post" action="setup.html">\n        <input type="hidden" name="authchanged" value="
#line 158 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << _tntChunks[7]; // " id="authchanged"/>\n        <input type="hidden" name="message" value="
#line 159 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << _tntChunks[8]; // " id="message"/>\n        <table class="form" cellpadding="0" cellspacing="0">\n          <tr class="head">\n            <td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div class="caption">
#line 162 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << _tntChunks[9]; // </div></div></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 165 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << _tntChunks[10]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="useauth" id="useauth" value="1"
#line 167 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << _tntChunks[11]; //  onclick="changeduseauth(this)"/>\n              <div id="authsection" style="display: none">\n              <table border="0" cellpadding="0" cellspacing="0" class="dependent">\n              <tr>\n                <td class="label"><div class="withmargin">
#line 171 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << _tntChunks[12]; // :</div></td>\n                <td><input type="text" name="login" value="
#line 172 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << _tntChunks[13]; // " id="login" onchange="setauthchanged(this)" /></td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 175 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << _tntChunks[14]; // :</div></td>\n                <td><input  type="password" name="pass" value="
#line 176 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << _tntChunks[15]; // " id="pass" onchange="setauthchanged(this)" /></td>\n              </tr>\n              <tr>\n                <td colspan="2" class="label"><div class="withmargin"><a href="users.html">
#line 179 "setup.ecpp"
  reply.sout() << ( tr("User management") );
  reply.out() << _tntChunks[16]; // </a></div></td>\n              </tr>\n              <tr>\n                <td colspan="2" class="label"><div class="withmargin">
#line 182 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << _tntChunks[17]; // </div></td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 185 "setup.ecpp"
  reply.sout() << ( tr("IPv4 prefix") );
  reply.out() << _tntChunks[18]; // :</div></td>\n                <td><input type="text" name="localnetmask" value="
#line 186 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << _tntChunks[19]; // " id="localnetmask" />\n                
  // <& tooltip.help ...
  { 
#line 187 "setup.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 187 "setup.ecpp"
    _tnt_cq5.add( "text", (tr("Example: 192.168.178.0/24")));
#line 187 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[20]; // </td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 190 "setup.ecpp"
  reply.sout() << ( tr("IPv6 prefix") );
  reply.out() << _tntChunks[21]; // :</div></td>\n                <td><input type="text" name="localnetmaskIPv6" value="
#line 191 "setup.ecpp"
  reply.sout() << ( localnetmaskIPv6 );
  reply.out() << _tntChunks[22]; // " id="localnetmaskIPv6" />\n
#line 192 "setup.ecpp"
               // the mootools unfortunately use "::" as separator for title and text,

#line 193 "setup.ecpp"
               // so we need to escape this by inserting an invisible space U+200B in-between

  reply.out() << _tntChunks[23]; //                 
  // <& tooltip.help ...
  { 
#line 194 "setup.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 194 "setup.ecpp"
    _tnt_cq6.add( "text", (tr("Example: 2003:ec:6f23:ee00:&#x200B;:/64")));
#line 194 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[24]; // </td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 197 "setup.ecpp"
  reply.sout() << ( tr("Allow localhost") );
  reply.out() << _tntChunks[25]; // :</div></td>\n                <td><input type="checkbox" name="allowlocalhost" value="1"
#line 198 "setup.ecpp"
 CHECKIF(!allowlocalhost.empty()); 
  reply.out() << _tntChunks[26]; // />\n              </tr>\n              </table>\n              </div>\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 205 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << _tntChunks[27]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showLogo" id="showLogo" value="1"
#line 207 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << _tntChunks[28]; // />\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 211 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << _tntChunks[29]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showInfoBox" id="showInfoBox" value="1"
#line 213 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << _tntChunks[30]; // />\n            </td>\n          </tr>\n
#line 216 "setup.ecpp"
 if (LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[31]; //           <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 218 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << _tntChunks[32]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="useStreamdev" id="useStreamdev" value="1"
#line 220 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << _tntChunks[33]; // />\n            </td>\n          </tr>\n              <tr>\n                <td class="label leftcol"><div class="withmargin">
#line 224 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << _tntChunks[34]; // :</div></td>\n                <td class="rightcol"><input type="text" name="streamdevport" id="streamdevport" value="
#line 225 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << _tntChunks[35]; // " /></td>\n              </tr>\n              <tr>\n                <td class="label leftcol"><div class="withmargin">
#line 228 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << _tntChunks[36]; // :</div></td>\n                <td class="rightcol"><select name="streamdevtype" size="1" id="streamdevtype">\n                  <option value="TS" 
#line 230 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << _tntChunks[37]; // >TS</option>\n                  <option value="PES" 
#line 231 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << _tntChunks[38]; // >PES</option>\n                  <option value="PS" 
#line 232 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << _tntChunks[39]; // >PS</option>\n                  <option value="ES" 
#line 233 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << _tntChunks[40]; // >ES</option>\n                  <option value="EXT" 
#line 234 "setup.ecpp"
 SELECTIF(streamdevtype == "EXT") 
  reply.out() << _tntChunks[41]; // >EXT</option>\n                </select></td>\n              </tr>\n
#line 237 "setup.ecpp"
 }   // endif LiveFeatures<features::streamdev_server>().Loaded()

  reply.out() << _tntChunks[42]; //                                         <tr>\n                                                <td class="label leftcol"><div class="withmargin">
#line 239 "setup.ecpp"
  reply.sout() << ( tr("Mark new recordings") );
  reply.out() << _tntChunks[43]; // :</div></td>\n                                                <td class="rightcol">\n                                                        <input type="checkbox" name="markNewRec" id="markNewRec" value="1"
#line 241 "setup.ecpp"
 CHECKIF(!markNewRec.empty()); 
  reply.out() << _tntChunks[44]; // />\n                                                </td>\n                                        </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 245 "setup.ecpp"
  reply.sout() << ( tr("Show link to IMDb in list views") );
  reply.out() << _tntChunks[45]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showIMDb" id="showIMDb" value="1"
#line 247 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << _tntChunks[46]; // />\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 251 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << _tntChunks[47]; // :</div></td>\n            <td class="rightcol"><input type="number" min="0" name="lastchannel" value="
#line 252 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << _tntChunks[48]; // " id="lastchannel" /></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 255 "setup.ecpp"
  reply.sout() << ( tr("Additional fixed times in 'What's on?'") );
  reply.out() << _tntChunks[49]; // :</div></td>\n            <td class="rightcol"><input type="text" name="times" value="
#line 256 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << _tntChunks[50]; // " id="times" />\n              
  // <& tooltip.help ...
  { 
#line 257 "setup.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 257 "setup.ecpp"
    _tnt_cq7.add( "text", (tr("Format is HH:MM. Separate multiple times with a semicolon")));
#line 257 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[51]; // </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 260 "setup.ecpp"
  reply.sout() << ( tr("Channel groups for MultiSchedule") );
  reply.out() << _tntChunks[52]; // :</div></td>\n            <td class="rightcol"><div class="options">\n             <div class="dotted">\n               <input id="channelGroupsGen_default" name="channelGroupsGen" value="default" 
#line 263 "setup.ecpp"
  if ( channelGroupsGen=="default"||channelGroupsGen.empty() )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[53]; //  type="radio" onclick="changedChanGroups()"/>\n               <label for="channelGroupsGen_default">
#line 264 "setup.ecpp"
  reply.sout() << ( tr("5 channels per group") );
  reply.out() << _tntChunks[54]; // </label>\n             </div>\n             <div class="dotted">\n               <input id="channelGroupsGen_vdr" name="channelGroupsGen" value="vdr" 
#line 267 "setup.ecpp"
  if ( channelGroupsGen=="vdr" )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[55]; //  type="radio" onclick="changedChanGroups()"/>\n               <label for="channelGroupsGen_vdr">
#line 268 "setup.ecpp"
  reply.sout() << ( tr("Channel groups as defined in VDR") );
  reply.out() << _tntChunks[56]; // </label>\n             </div>\n             <div class="dotted">\n               <input id="channelGroupsGen_flat" name="channelGroupsGen" value="flat" 
#line 271 "setup.ecpp"
  if ( channelGroupsGen=="flat" )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[57]; //  type="radio" onclick="changedChanGroups()"/>\n               <label for="channelGroupsGen_flat">
#line 272 "setup.ecpp"
  reply.sout() << ( tr("All channels in one group") );
  reply.out() << _tntChunks[58]; // </label>\n             </div>\n             <div class="dotted">\n               <input id="channelGroupsGen_individual" name="channelGroupsGen" value="individual" 
#line 275 "setup.ecpp"
  if ( channelGroupsGen=="individual" )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[59]; //  type="radio" onclick="changedChanGroups()"/>\n               <label for="channelGroupsGen_individual">
#line 276 "setup.ecpp"
  reply.sout() << ( tr("Individual channel groups") );
  reply.out() << _tntChunks[60]; // </label>\n             </div>\n           </div>\n\n           <div id="individual_channelGroups_section" style="display: none">\n             <table border="0" cellpadding="0" cellspacing="0" class="dependent">\n             <tr>\n               <td class="label"><div class="withmargin">
#line 283 "setup.ecpp"
  reply.sout() << ( tr("Channel groups") );
  reply.out() << _tntChunks[61]; // :</div></td>\n               <td><input type="text" name="channelGroups" value="
#line 284 "setup.ecpp"
  reply.sout() << ( channelGroups );
  reply.out() << _tntChunks[62]; // " id="channelGroups" />\n               
  // <& tooltip.help ...
  { 
#line 285 "setup.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 285 "setup.ecpp"
    _tnt_cq8.add( "text", (tr("Separate channels with a comma ',', separate groups with a semi-colon ';'")));
#line 285 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[63]; // </td>\n             </tr>\n             </table>\n           </div>\n\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 293 "setup.ecpp"
  reply.sout() << ( tr("Duration of MultiSchedule in hours") );
  reply.out() << _tntChunks[64]; // :</div></td>\n            <td class="rightcol"><input type="number" min="1" max= "23" name="scheduleDuration" value="
#line 294 "setup.ecpp"
  reply.sout() << ( scheduleDuration );
  reply.out() << _tntChunks[65]; // " id="scheduleDuration" />\n              </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 298 "setup.ecpp"
  reply.sout() << ( tr("Show channels without EPG") );
  reply.out() << _tntChunks[66]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showChannelsWithoutEPG" id="showChannelsWithoutEPG" value="1"
#line 300 "setup.ecpp"
 CHECKIF(!showChannelsWithoutEPG.empty()); 
  reply.out() << _tntChunks[67]; // />\n            </td>\n          </tr>\n\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 305 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << _tntChunks[68]; // :</div></td>\n            <td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n              <option value="whatsonnow" 
#line 307 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << _tntChunks[69]; // >
#line 307 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << _tntChunks[70]; // </option>\n              <option value="whatsonnext" 
#line 308 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << _tntChunks[71]; // >
#line 308 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << _tntChunks[72]; // </option>\n              <option value="schedule" 
#line 309 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << _tntChunks[73]; // >
#line 309 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << _tntChunks[74]; // </option>\n              <option value="multischedule" 
#line 310 "setup.ecpp"
 SELECTIF(startscreen == "multischedule") 
  reply.out() << _tntChunks[75]; // >
#line 310 "setup.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << _tntChunks[76]; // </option>\n              <option value="recordings" 
#line 311 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << _tntChunks[77]; // >
#line 311 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << _tntChunks[78]; // </option>\n              <option value="timers" 
#line 312 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << _tntChunks[79]; // >
#line 312 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << _tntChunks[80]; // </option>\n            </select></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 316 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << _tntChunks[81]; // :</div></td>\n            <td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 318 "setup.ecpp"

{
  const std::string dirPath(Plugin::GetResourceDirectory() + "/themes");
  cReadDir d(dirPath.c_str());
  struct dirent* e;
  std::string parent("..");
  std::string current(".");
  std::string cvsDir("CVS");
  std::vector<std::string> themes;
  while ((e = d.Next())) {
    if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
      continue;
    }
    /* Check if entry is a directory: I do not rely on e->d_type
    ** here because on some systems it is always DT_UNKNOWN. Also
    ** testing for DT_DIR does not take into account symbolic
    ** links to directories.
    */
    struct stat buf;
    if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
      continue;
    }
    themes.push_back(e->d_name);
  }
  // get theme names sorted for selection
  std::sort(themes.begin(), themes.end());
  for (auto name: themes)
  {

  reply.out() << _tntChunks[82]; //               <option value="
#line 347 "setup.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[83]; // " 
#line 347 "setup.ecpp"
 SELECTIF(theme == name) 
  reply.out() << _tntChunks[84]; // >
#line 347 "setup.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[85]; // </option>\n
#line 348 "setup.ecpp"

  }
}

  reply.out() << _tntChunks[86]; //             </select></td>\n          </tr>\n          <tr>\n            <td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n              <div class="withmargin">\n              <button class="green" type="submit" name="save" >
#line 357 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << _tntChunks[87]; // </button>\n              </div>\n            </td>\n          </tr>\n        </table>\n      </form>\n      <div class="spacebar">
  reply.out() << _tntChunks[88]; // </div>\n    </div>\n  </body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[89]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[90]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
