////////////////////////////////////////////////////////////////////////
// stream.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.stream")

// <%pre>
#line 1 "stream.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <ffmpeg.h>
#include <tools.h>
#include <epg_events.h>
#include <recman.h>
#include <timers.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class recording_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recording_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
    recording_selection_type recording_selection;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("stream");

static const char* rawData = "\330\000\000\000Z\001\000\000g\001\000\000l\001\000\000q\001\000\000&\002\000\000'\002"
  "\000\000+\002\000\000,\002\000\0000\002\000\0001\002\000\000d\002\000\000\235\003\000\000\245\003\000\000'\005\000"
  "\000\021\006\000\000H\006\000\000\243\006\000\000\366\006\000\000x\007\000\000\265\007\000\000&\010\000\0002\010\000"
  "\0003\010\000\000R\010\000\000s\010\000\000\002\t\000\000\004\t\000\000\005\t\000\0001\t\000\000M\t\000\000q\t\000"
  "\000r\t\000\000s\t\000\000\314\t\000\000\346\t\000\000\372\t\000\000\373\t\000\000\001\n\000\000\002\n\000\000\024\n"
  "\000\000/\n\000\0007\n\000\000S\n\000\000[\n\000\000\134\n\000\000]\n\000\000\273\n\000\000\317\n\000\000\375\n\000"
  "\000\005\013\000\000!\013\000\000)\013\000\000*\013\000\000\n<!DOCTYPE html>\n<html>\n  <head>\n    <meta name=\"view"
  "port\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR Live - </title>\n    \n    \n    \n    <scr"
  "ipt> window.onbeforeunload = function() { player.stop(); } </script>\n  </head>\n  <body onpagehide=\"saveScrollPosit"
  "ion('content')\" onpageshow=\"restoreScrollPosition()\">\n    \n    \n    \n    <div id=\"content\">\n      <div clas"
  "s=\"spacebar\"></div>\n      <div class=\"player-container\">\n      <div id=\"player\" class=\"player\">\n\n        "
  "<script src=\"https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.min.js\"></script>\n        <script>\n        Cl"
  "appr.Log.setLevel(Clappr.Log.LEVEL_INFO);\n        var player = new Clappr.Player({\n          source: \"media//maste"
  "r_.m3u8\",\n          parentId: \"#player\",\n          width: \"100%\", height: \"100%\",\n          autoPlay: \"tru"
  "e\",\n          events: {\n            onError: function(error) { console.log('Calppr.Player error: ', error); player"
  ".play(); },\n            onEnded: function() { console.log('Clappr.Player ended'); player.play(); },\n          }\n  "
  "      });\n        </script>\n      </div>\n      </div>\n      <table class=\"listing streaming recording\" cellspac"
  "ing=\"0\" cellpadding=\"0\">\n        <tbody>\n          <script>\n            // column span 0 indicates discrding t"
  "he label\n            document.write(existingRecordingString(0, \"\", ))\n          </script>\n        </tbody>\n    "
  "  </table>\n  <table class=\"listing streaming channel\" cellspacing=\"0\" cellpadding=\"0\">\n    <tr class=\"\">\n "
  "     <td class=\"leftcol action\">\n        <div class=\"event_actions\">\n          \n        </div>\n      </td>\n "
  "     <td class=\"topaligned\">\n        <div class=\"withmargin\">\n          <div class=\"nomargin nowrap\"></div>\n"
  "          <div class=\"duration\"><div class=\"progress\"></div>\n        </div>\n      </td>\n      <td class=\"topa"
  "ligned more\">\n        <div class=\"withmargin\">\n        <a\n            \n          ><span class=\"title\"></span"
  "><br /><span class=\"short\"></span></a>\n        </div>\n      </td>\n      <td class=\"topaligned rightcol\"><div c"
  "lass=\"station withmargin\"><a  href=\"schedule.html\?channelid=\" ></a></div>\n      </td>\n    </tr>\n  </table>\n "
  "     <div class=\"spacebar\"></div>\n    </div>\n  </body>\n</html>\n\n\n<form action=\"stream.html\" method=\"get\" "
  "id=\"channels\">\n  <span>\n    <label for=\"channel\">:&nbsp;<span class=\"bold\"></span></label>\n    \n      \n  <"
  "/span>\n</form>\n<span class=\"sep\">|</span>\n\302\253&nbsp;\n<span class=\"sep\">|</span>\n&nbsp;\302\273\n\n<form "
  "action=\"stream.html=\" method=\"get\" id=\"recordings\">\n  <span>\n    <label for=\"recording\">:&nbsp;</label>\n  "
  "  \n  </span>\n</form>\n<span class=\"sep\">|</span>\n\302\253&nbsp;\n<span class=\"sep\">|</span>\n&nbsp;\302\273\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection"),
    recording_selection(*this, "recording_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel = qparam.get< int >("channel", ( -1));
std::string channelid = qparam.get< std::string >("channelid");
std::string recid = qparam.get< std::string >("recid");
  // </%args>

#line 20 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 21 "stream.ecpp"
  typedef std::string prev_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, prev_recording, ());   // <%session> std::string prev_recording
  _tnt_ignore_unused<prev_recording_type>(prev_recording);
#line 22 "stream.ecpp"
  typedef std::string next_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, next_recording, ());   // <%session> std::string next_recording
  _tnt_ignore_unused<next_recording_type>(next_recording);
#line 23 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( nullptr));   // <%session> FFmpegThread * f_worker( nullptr)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 26 "stream.ecpp"
  typedef tChannelID channelID_type;
  TNT_REQUEST_SHARED_VAR(tChannelID, channelID, ());   // <%request> tChannelID channelID
  _tnt_ignore_unused<channelID_type>(channelID);
#line 27 "stream.ecpp"
  typedef int channelNumber_type;
  TNT_REQUEST_SHARED_VAR(int, channelNumber, ());   // <%request> int channelNumber
  _tnt_ignore_unused<channelNumber_type>(channelNumber);
#line 28 "stream.ecpp"
  typedef std::string g_recid_type;
  TNT_REQUEST_SHARED_VAR(std::string, g_recid, ());   // <%request> std::string g_recid
  _tnt_ignore_unused<g_recid_type>(g_recid);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 31 "stream.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }

  pageTitle = trVDR("Stream");

  // check for session cookie.
  std::string session;
  if (request.hasCookie("tntnet")) {
    session = request.getCookie("tntnet");
    dsyslog("vdrlive::stream::session(%s)", session.c_str());
  }
  else {
    esyslog("vdrlive::stream: no session cookie found");
    return reply.redirect("");
  }

  std::string url;
  int channelVtype = 0;
  if ( qparam.has("recid") ) {
    {
      g_recid = recid;
      LOCK_RECORDINGS_READ;
      const cRecording* Recording = RecordingsManager::GetByHash(recid, Recordings);
      if (!Recording)
        throw HtmlError( tr("Couldn't find recording or no recordings available. Maybe you mistyped your request?") );
      struct stat st;
      const char* filename = Recording->FileName();
      if ( filename && stat( filename, &st ) == 0  ) {
        char buffer[50];  // suitable for accommodating url with 2x ULLONG_MAX
        int length = snprintf( buffer, sizeof( buffer ), "%lu:%llu.rec", ( unsigned long )st.st_dev, ( unsigned long long )st.st_ino );
        if ( 0 < length && length < ( int )sizeof( buffer ) ) {
          url += buffer;
        }
      }
      channelID = Recording->Info()->ChannelID();
    }
    LOCK_CHANNELS_READ;
    const cChannel* Channel = Channels->GetByChannelID( channelID );
    if ( !Channel )
      throw HtmlError( tr("Couldn't find channel for recording.") );
    channelNumber = Channel->Number();
    channelVtype = Channel->Vtype();
  } else {
    const cChannel* Channel = nullptr;
    LOCK_CHANNELS_READ;
    if ( qparam.has("channelid") ) {
      channelID = channelID.FromString(channelid.c_str());
      Channel = Channels->GetByChannelID( channelID );
    } else if ( channel > 0 ) {
      Channel = Channels->GetByNumber( channel );
    } else if (cDevice::CurrentChannel()) {
      Channel = Channels->GetByNumber(cDevice::CurrentChannel());
    } else {
      Channel = Channels->Get( Channels->GetNextNormal( -1 ) );
    }
    if ( !Channel )
      throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );
    channelID = Channel->GetChannelID();
    channelNumber = Channel->Number();
    channelVtype = Channel->Vtype();
    channelid = *channelID.ToString();
    url += channelid;
  }

  url += ".";
  for ( auto c : LiveSetup().GetStreamdevType() )
    url += std::tolower( c );
  dsyslog("vdrlive::stream::vtype(%d)", channelVtype);
  dsyslog("vdrlive::stream::f_worker(%p)", f_worker);
  if ( !f_worker) {
    f_worker = new FFmpegThread();
    dsyslog("vdrlive::stream: new FFmpegThread created");
  }

  switch(channelVtype) {
    case 27: // h264
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingH264 : tagChannelH264);
      break;
    case 36: // h265
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingHVEC : tagChannelHVEC);
      break;
    case 2: // mpeg2
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingMPG2 : tagChannelMPG2);
      break;
    default: // others
      f_worker->StartFFmpeg(session, url, qparam.has("recid") ? tagRecordingDFLT : tagChannelDFLT);
  }
  dsyslog("vdrlive::stream::StartFFmpeg(%s)", url.c_str());


  reply.out() << _tntChunks[0]; // \n<!DOCTYPE html>\n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR Live - 
#line 130 "stream.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 131 "stream.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 131 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 132 "stream.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 132 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 133 "stream.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 133 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    <script> window.onbeforeunload = function() { player.stop(); } </script>\n  </head>\n  <body onpagehide="saveScrollPosition('content')" onpageshow="restoreScrollPosition()">\n    
  // <& pageelems.logo ...
  { 
#line 137 "stream.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 137 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n
#line 138 "stream.ecpp"
  if ( qparam.has("recid") ) {

  reply.out() << _tntChunks[6]; //     
  // <& menu ...
  { 
#line 139 "stream.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 139 "stream.ecpp"
    _tnt_cq4.add( "active", ("stream"));
#line 139 "stream.ecpp"
    _tnt_cq4.add( "component", ("stream.recording_selection"));
#line 139 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n
#line 140 "stream.ecpp"
  } else {

  reply.out() << _tntChunks[8]; //     
  // <& menu ...
  { 
#line 141 "stream.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 141 "stream.ecpp"
    _tnt_cq5.add( "active", ("stream"));
#line 141 "stream.ecpp"
    _tnt_cq5.add( "component", ("stream.channel_selection"));
#line 141 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[9]; // \n
#line 142 "stream.ecpp"
  }

  reply.out() << _tntChunks[10]; //     <div id="content">\n      <div class="spacebar">
  reply.out() << _tntChunks[11]; // </div>\n      <div class="player-container">\n      <div id="player" class="player">\n\n        <script src="https://cdn.jsdelivr.net/npm/clappr@latest/dist/clappr.min.js"></script>\n        <script>\n        Clappr.Log.setLevel(Clappr.Log.LEVEL_INFO);\n        var player = new Clappr.Player({\n          source: "media/
#line 152 "stream.ecpp"
  reply.sout() << ( session );
  reply.out() << _tntChunks[12]; // /master_
#line 152 "stream.ecpp"
  reply.sout() << ( url );
  reply.out() << _tntChunks[13]; // .m3u8",\n          parentId: "#player",\n          width: "100%", height: "100%",\n          autoPlay: "true",\n          events: {\n            onError: function(error) { console.log('Calppr.Player error: ', error); player.play(); },\n            onEnded: function() { console.log('Clappr.Player ended'); player.play(); },\n          }\n        });\n        </script>\n      </div>\n      </div>\n
#line 164 "stream.ecpp"

if (qparam.has("recid")) {
dsyslog("vdrlive::stream: generating recording info");
RecordingsItemRec * rPtr = RecordingsManager::GetByIdHash(recid);
cToSvConcat<0> recording_item;
rPtr->AppendAsJSArray(recording_item);

  reply.out() << _tntChunks[14]; //       <table class="listing streaming recording" cellspacing="0" cellpadding="0">\n        <tbody>\n          <script>\n            // column span 0 indicates discrding the label\n            document.write(existingRecordingString(0, "", 
#line 175 "stream.ecpp"
  reply.out() << ( recording_item.c_str() );
  reply.out() << _tntChunks[15]; // ))\n          </script>\n        </tbody>\n      </table>\n
#line 179 "stream.ecpp"

} else {
dsyslog("vdrlive::stream: generating EPG info");
const cChannel* Channel = nullptr;
const cEvent* Event = nullptr;
EpgInfo epgEvent;
{
  LOCK_CHANNELS_READ;
  Channel = Channels->GetByChannelID(channelID);
  if (Channel) {
    LOCK_SCHEDULES_READ;
    const cSchedule *Schedule = Schedules->GetSchedule(Channel);
    if (Schedule) {
      Event = Schedule->GetPresentEvent();
      if (Event) epgEvent.CreateEpgInfo(Channel, Event);
    }
  }
}
if (!epgEvent.Id().empty() ) {
  std::string startTime(epgEvent.StartTime(tr("%I:%M %p")));
  std::string endTime(epgEvent.EndTime(tr("%I:%M %p")));

  std::string startDate(epgEvent.StartTime(tr("%a, %x")));
  std::string timeSpan(startTime + " - " + endTime);
  if (startTime.empty() && endTime.empty()) {
    char const * timeFormat = tr("%I:%M %p");
    char const * dateFormat = tr("%A, %x");
    timeSpan = std::string(cToSvDateTime(timeFormat, time(0)));
    startDate = std::string(cToSvDateTime(dateFormat, time(0)));
  }
  cToSvConcat longDescription;
  longDescription << "<p>";
  AppendHtmlEscapedAndCorrectNonUTF8(longDescription, StringWordTruncate(epgEvent.LongDescr(), LiveSetup().GetMaxTooltipChars()), "</p><p>");
  longDescription << "</p><p class=\"click-details\">";
  AppendHtmlEscapedAndCorrectNonUTF8(longDescription, tr("Click to view details."));
  longDescription << "</p>";

  bool timerRecording = false;
  if (Channel && Event) {
    LOCK_TIMERS_READ;
    const cTimer* timer = TimerManager().GetTimer(Event, Channel, Timers);
    timerRecording = timer && timer->Recording();
  }
  
  reply.out() << _tntChunks[16]; //   <table class="listing streaming channel" cellspacing="0" cellpadding="0">\n    <tr class="
#line 224 "stream.ecpp"
  if ( timerRecording )
    reply.sout() <<  "recording" ;
  reply.out() << _tntChunks[17]; // ">\n      <td class="leftcol action">\n        <div class="event_actions">\n          
  // <& pageelems.epg_tool_box ...
  { 
#line 227 "stream.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 227 "stream.ecpp"
    _tnt_cq6.add( "detail", (0));
#line 227 "stream.ecpp"
    _tnt_cq6.add( "endTime", (epgEvent.GetEndTime()));
#line 227 "stream.ecpp"
    _tnt_cq6.add( "epgid", (epgEvent.Id()));
#line 227 "stream.ecpp"
    _tnt_cq6.add( "lastCurrentChanel", (0));
#line 227 "stream.ecpp"
    _tnt_cq6.add( "startTime", (epgEvent.GetStartTime()));
#line 227 "stream.ecpp"
    _tnt_cq6.add( "title", (epgEvent.Title()));
#line 227 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n        </div>\n      </td>\n      <td class="topaligned">\n        <div class="withmargin">\n          <div class="nomargin nowrap">
#line 232 "stream.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[19]; // </div>\n          <div class="duration"><div class="progress">
  // <& pageelems.progressbar ...
  { 
#line 233 "stream.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 233 "stream.ecpp"
    _tnt_cq7.add( "duration", (epgEvent.Duration()));
#line 233 "stream.ecpp"
    _tnt_cq7.add( "progress", (epgEvent.Elapsed()));
#line 233 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[20]; // </div>\n        </div>\n      </td>\n      <td class="topaligned more">\n        <div class="withmargin">\n        <a\n
#line 239 "stream.ecpp"
             if (!longDescription.empty()) {

  reply.out() << _tntChunks[21]; //             
  // <& tooltip.hint ...
  { 
#line 240 "stream.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 240 "stream.ecpp"
    _tnt_cq8.add( "text", (longDescription));
#line 240 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 240 "stream.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 240 "stream.ecpp"
    _tnt_cq9.add( "domId", (epgEvent.Id()));
#line 240 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[22]; // \n
#line 241 "stream.ecpp"
             }

  reply.out() << _tntChunks[23]; //           ><span class="title">
#line 242 "stream.ecpp"
  reply.sout() << ( (epgEvent.Title()) );
  reply.out() << _tntChunks[24]; // </span><br /><span class="short">
#line 242 "stream.ecpp"
  reply.sout() << ( (epgEvent.ShortDescr()) );
  reply.out() << _tntChunks[25]; // </span></a>\n        </div>\n      </td>\n      <td class="topaligned rightcol"><div class="station withmargin"><a  href="schedule.html\?channelid=
#line 245 "stream.ecpp"
  reply.sout() << ( channelid );
  reply.out() << _tntChunks[26]; // " 
  // <& tooltip.hint ...
  { 
#line 245 "stream.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 245 "stream.ecpp"
    _tnt_cq10.add( "text", (tr("View the schedule of this channel")));
#line 245 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[27]; // >
#line 245 "stream.ecpp"
  reply.sout() << ( cSv(cToSvInt(channelNumber)) );
#line 245 "stream.ecpp"
  reply.sout() << ( tr(" - ") );
#line 245 "stream.ecpp"
  reply.sout() << ( (epgEvent.Caption()) );
  reply.out() << _tntChunks[28]; // </a></div>\n      </td>\n    </tr>\n  </table>\n
#line 249 "stream.ecpp"
} // if (!epgEvent.Id().empty() )

#line 250 "stream.ecpp"
} // if ( qparam.has("recid")

  reply.out() << _tntChunks[29]; //       <div class="spacebar">
  reply.out() << _tntChunks[30]; // </div>\n    </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[31]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[32]; // \n
  reply.out() << _tntChunks[45]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream::channel_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 20 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 21 "stream.ecpp"
  typedef std::string prev_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, prev_recording, ());   // <%session> std::string prev_recording
  _tnt_ignore_unused<prev_recording_type>(prev_recording);
#line 22 "stream.ecpp"
  typedef std::string next_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, next_recording, ());   // <%session> std::string next_recording
  _tnt_ignore_unused<next_recording_type>(next_recording);
#line 23 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( nullptr));   // <%session> FFmpegThread * f_worker( nullptr)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 26 "stream.ecpp"
  typedef tChannelID channelID_type;
  TNT_REQUEST_SHARED_VAR(tChannelID, channelID, ());   // <%request> tChannelID channelID
  _tnt_ignore_unused<channelID_type>(channelID);
#line 27 "stream.ecpp"
  typedef int channelNumber_type;
  TNT_REQUEST_SHARED_VAR(int, channelNumber, ());   // <%request> int channelNumber
  _tnt_ignore_unused<channelNumber_type>(channelNumber);
#line 28 "stream.ecpp"
  typedef std::string g_recid_type;
  TNT_REQUEST_SHARED_VAR(std::string, g_recid, ());   // <%request> std::string g_recid
  _tnt_ignore_unused<g_recid_type>(g_recid);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[33]; // <form action="stream.html" method="get" id="channels">\n  <span>\n    <label for="channel">
#line 260 "stream.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[34]; // :&nbsp;<span class="bold">
#line 260 "stream.ecpp"
  reply.sout() << ( cSv(cToSvInt(channelNumber)) );
  reply.out() << _tntChunks[35]; // </span></label>\n    
  // <& channels_widget ...
  { 
#line 261 "stream.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 261 "stream.ecpp"
    _tnt_cq11.add( "name", ("channel"));
#line 261 "stream.ecpp"
    _tnt_cq11.add( "onchange", ("player.stop(); document.forms.channels.submit()"));
#line 261 "stream.ecpp"
    _tnt_cq11.add( "selected", (*channelID.ToString() ));
#line 261 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[36]; // \n
#line 262 "stream.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[37]; //       
  // <& pageelems.ajax_action_href ...
  { 
#line 263 "stream.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 263 "stream.ecpp"
    _tnt_cq12.add( "action", "switch_channel");
#line 263 "stream.ecpp"
    _tnt_cq12.add( "alt", "");
#line 263 "stream.ecpp"
    _tnt_cq12.add( "className", "icon");
#line 263 "stream.ecpp"
    _tnt_cq12.add( "image", "zap.png");
#line 263 "stream.ecpp"
    _tnt_cq12.add( "param", (channelID));
#line 263 "stream.ecpp"
    _tnt_cq12.add( "tip", (tr("Switch to this channel.")));
#line 263 "stream.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[38]; // \n
#line 264 "stream.ecpp"
   }

  reply.out() << _tntChunks[39]; //   </span>\n</form>\n
#line 267 "stream.ecpp"

    int maxChannelNumber;
    {  LOCK_CHANNELS_READ;
       maxChannelNumber = Channels->MaxNumber();
    }
    bool prev = channelNumber > 1;
    bool next = channelNumber < maxChannelNumber;

  reply.out() << _tntChunks[40]; // <span class="sep">|</span>\n
#line 276 "stream.ecpp"
  if ( prev )
    reply.out() <<  "<a href=\"stream.html?channel=" << channelNumber - 1 << "\">" ;
  reply.out() << _tntChunks[41]; // \302\253&nbsp;
#line 276 "stream.ecpp"
  reply.sout() << ( tr("Prev. entry") );
#line 276 "stream.ecpp"
  if ( prev )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[42]; // \n<span class="sep">|</span>\n
#line 278 "stream.ecpp"
  if ( next )
    reply.out() <<  "<a href=\"stream.html?channel=" << channelNumber + 1 << "\">" ;
#line 278 "stream.ecpp"
  reply.sout() << ( tr("Next entry") );
  reply.out() << _tntChunks[43]; // &nbsp;\302\273
#line 278 "stream.ecpp"
  if ( next )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[44]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recording_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("stream::recording_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 20 "stream.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 21 "stream.ecpp"
  typedef std::string prev_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, prev_recording, ());   // <%session> std::string prev_recording
  _tnt_ignore_unused<prev_recording_type>(prev_recording);
#line 22 "stream.ecpp"
  typedef std::string next_recording_type;
  TNT_SESSION_SHARED_VAR(std::string, next_recording, ());   // <%session> std::string next_recording
  _tnt_ignore_unused<next_recording_type>(next_recording);
#line 23 "stream.ecpp"
  typedef FFmpegThread * f_worker_type;
  TNT_SESSION_SHARED_VAR(FFmpegThread *, f_worker, ( nullptr));   // <%session> FFmpegThread * f_worker( nullptr)
  _tnt_ignore_unused<f_worker_type>(f_worker);
#line 26 "stream.ecpp"
  typedef tChannelID channelID_type;
  TNT_REQUEST_SHARED_VAR(tChannelID, channelID, ());   // <%request> tChannelID channelID
  _tnt_ignore_unused<channelID_type>(channelID);
#line 27 "stream.ecpp"
  typedef int channelNumber_type;
  TNT_REQUEST_SHARED_VAR(int, channelNumber, ());   // <%request> int channelNumber
  _tnt_ignore_unused<channelNumber_type>(channelNumber);
#line 28 "stream.ecpp"
  typedef std::string g_recid_type;
  TNT_REQUEST_SHARED_VAR(std::string, g_recid, ());   // <%request> std::string g_recid
  _tnt_ignore_unused<g_recid_type>(g_recid);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[46]; // <form action="stream.html=" method="get" id="recordings">\n  <span>\n    <label for="recording">
#line 284 "stream.ecpp"
  reply.sout() << ( tr("Recording") );
  reply.out() << _tntChunks[47]; // :&nbsp;</label>\n    
  // <& recordings_widget ...
  { 
#line 285 "stream.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 285 "stream.ecpp"
    _tnt_cq13.add( "name", ("recid"));
#line 285 "stream.ecpp"
    _tnt_cq13.add( "onchange", ("player.stop(); document.forms.recordings.submit()"));
#line 285 "stream.ecpp"
    _tnt_cq13.add( "selected", (g_recid));
#line 285 "stream.ecpp"
    callComp(tnt::Compident(std::string(), "recordings_widget"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[48]; // \n  </span>\n</form>\n<span class="sep">|</span>\n
#line 289 "stream.ecpp"
  if ( !prev_recording.empty() )
    reply.out() <<  "<a href=\"stream.html?recid=recording_" << prev_recording << "\">" ;
  reply.out() << _tntChunks[49]; // \302\253&nbsp;
#line 289 "stream.ecpp"
  reply.sout() << ( tr("Prev. entry") );
#line 289 "stream.ecpp"
  if ( !prev_recording.empty() )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[50]; // \n<span class="sep">|</span>\n
#line 291 "stream.ecpp"
  if ( !next_recording.empty() )
    reply.out() <<  "<a href=\"stream.html?recid=recording_" << next_recording << "\">" ;
#line 291 "stream.ecpp"
  reply.sout() << ( tr("Next entry") );
  reply.out() << _tntChunks[51]; // &nbsp;\302\273
#line 291 "stream.ecpp"
  if ( !next_recording.empty() )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[52]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
