////////////////////////////////////////////////////////////////////////
// switch_channel.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.switch_channel")

// <%pre>
#line 1 "switch_channel.ecpp"


#include <exception.h>
#include <setup.h>
#include <tools.h>
#include <users.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("switch_channel");

static const char* rawData = "\034\000\000\000I\000\000\000J\000\000\000Y\000\000\000h\000\000\000o\000\000\000p\000"
  "\000\000<b>Switch-Channel Request</b>\n<hr/>\nChannel: /<br/>\nResult:  <br/>\nError:   \n<hr/>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("switch_channel " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel_number = qparam.get< int >("channel_number", ( 0));
std::string param = qparam.get< std::string >("param");
std::string async = qparam.get< std::string >("async");
  // </%args>

#line 17 "switch_channel.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 19 "switch_channel.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }
  if (!cUser::CurrentUserHasRightTo(UR_SWITCHCHNL))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

  bool ajaxReq = !async.empty() && (parse_int<int>(async) != 0);
  std::string referrer;

  if (ajaxReq) {
    reply.setContentType( "application/xml" );
  } else {
    referrer = request.getHeader("Referer:");
  }

// do work
  const char *error_message = "";
  int l_channel_number = -1;
  tChannelID channelID;
  {
    const cChannel* channel = nullptr;
    LOCK_CHANNELS_READ;
    if (qparam.has("channel_number") && channel_number > 0) {
      channel = Channels->GetByNumber(channel_number);
    } else {
      channel = Channels->GetByChannelID(tChannelID::FromString(param.c_str()));
    }
    if (channel) {
      l_channel_number = channel->Number();
      channelID = channel->GetChannelID();
    } else
      error_message = tr("Couldn't find channel or no channels available.");

    if (l_channel_number != -1) {
      if (!Channels->SwitchTo(l_channel_number)) error_message = tr("Couldn't switch to channel.");
    }
  }

// report result
  if (!ajaxReq) {
    if (!referrer.empty() && referrer.find("login") == std::string::npos) {
      return reply.redirect(referrer);
    }

  reply.out() << _tntChunks[0]; // <b>Switch-Channel Request</b>\n<hr/>\nChannel: 
#line 68 "switch_channel.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[1]; // /
#line 68 "switch_channel.ecpp"
  reply.sout() << ( channelID );
#line 68 "switch_channel.ecpp"
  reply.sout() << ( cToSvConcat(" [", l_channel_number, "]") );
  reply.out() << _tntChunks[2]; // <br/>\nResult:  
#line 69 "switch_channel.ecpp"
  reply.sout() << ( *error_message?"error":"success" );
  reply.out() << _tntChunks[3]; // <br/>\nError:   
#line 70 "switch_channel.ecpp"
  reply.sout() << ( error_message );
  reply.out() << _tntChunks[4]; // \n<hr/>\n
#line 72 "switch_channel.ecpp"

  }
  else {

  // <& xmlresponse.ajax ...
  { 
#line 76 "switch_channel.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 76 "switch_channel.ecpp"
    _tnt_cq0.add( "error", (error_message));
#line 76 "switch_channel.ecpp"
    _tnt_cq0.add( "name", ("switch_channel"));
#line 76 "switch_channel.ecpp"
    _tnt_cq0.add( "pname", ("channel"));
#line 76 "switch_channel.ecpp"
    _tnt_cq0.add( "result", (*error_message == 0));
#line 76 "switch_channel.ecpp"
    _tnt_cq0.add( "value", (channelID));
#line 76 "switch_channel.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ajax"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n
#line 77 "switch_channel.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
