////////////////////////////////////////////////////////////////////////
// timers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timers")

// <%pre>
#line 1 "timers.ecpp"


#include <timers.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timerconflict.h>
#include <livefeatures.h>
#include <users.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class event_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    event_actions_type event_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("timers");

static const char* rawData = "|\001\000\000\306\001\000\0008\002\000\000E\002\000\000J\002\000\000O\002\000\000\267\002"
  "\000\000\274\002\000\000\360\002\000\000\367\002\000\000\377\002\000\000\000\003\000\000E\003\000\000\230\003\000\000"
  "\006\004\000\000\242\004\000\000\363\004\000\000D\005\000\000\225\005\000\000\346\005\000\000\030\006\000\000E\006"
  "\000\000j\006\000\000\213\006\000\000\245\006\000\000$\007\000\0007\007\000\000W\007\000\000\203\007\000\000\205\007"
  "\000\000\206\007\000\000\251\007\000\000$\010\000\000'\010\000\0009\010\000\000\200\010\000\000\211\010\000\000\213"
  "\010\000\000\214\010\000\000\215\010\000\000\217\010\000\000\236\010\000\000\312\010\000\000\337\010\000\000\027\t"
  "\000\000\031\t\000\000<\t\000\000t\t\000\000v\t\000\000\231\t\000\000\321\t\000\000\323\t\000\000\364\t\000\000,\n"
  "\000\000.\n\000\000O\n\000\000j\n\000\000y\n\000\000\234\n\000\000\253\n\000\000\260\n\000\000\274\n\000\000\275\n"
  "\000\000\365\n\000\000\366\n\000\000\036\013\000\000\?\013\000\000Z\013\000\000g\013\000\000h\013\000\000\222\013\000"
  "\000\225\013\000\000\232\013\000\000\323\013\000\000\325\013\000\000\332\013\000\000\016\014\000\000\035\014\000\000"
  "\211\014\000\000\260\014\000\000\271\014\000\000\354\014\000\0006\015\000\000]\015\000\000f\015\000\000\237\015\000"
  "\000\256\015\000\000\312\015\000\000\356\015\000\000\357\015\000\000\360\015\000\000\n\016\000\000\017\016\000\000H"
  "\016\000\000M\016\000\000<!DOCTYPE html>\n<html>\n  <script>\n    history.go(-1);\n  </script>\n</html>\n\n<html>\n  "
  "<head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title"
  ">\n    \n    \n    \n  </head>\n  <body onpagehide=\"saveScrollPosition('content')\" onpageshow=\"restoreScrollPositi"
  "on()\">\n    \n    \n    <div id=\"content\">\n      <div class=\"spacebar\"></div>\n        \n      <table class=\"l"
  "isting timers\" cellspacing=\"0\" cellpadding=\"0\">\n            <tr class=\"spacer\">\n              <td colspan=\""
  "12\"/>\n            </tr>\n        <tr class=\"head\">\n          <td colspan=\"12\">\n            <div class=\"boxhe"
  "ader\"><div class=\"caption\"></div></div>\n          </td>\n        </tr>\n        <tr class=\"description\">\n     "
  "     <td class=\"leftcol\">&nbsp;</td>\n          <td><div class=\"withmargin\"></div></td>\n          <td class=\"td"
  "-hidden-xs\"><div class=\"withmargin hidden-xs\"></div></td>\n          <td class=\"td-hidden-xs\"><div class=\"withm"
  "argin hidden-xs\"></div></td>\n          <td class=\"td-hidden-xs\"><div class=\"withmargin hidden-xs\"></div></td>\n"
  "          <td class=\"td-hidden-xs\"><div class=\"withmargin hidden-xs\"></div></td>\n          <td><div class=\"with"
  "margin\"></div></td>\n          <td class=\"td-hidden-xs\"><div class=\"xs-nomargin hidden-xs\"></div></td>\n        "
  "  <td class=\"\"><div class=\"withmargin\"></div></td>\n          <td class=\"rightcol\"><img class=\"action-rightcol"
  "\" src=\"img/transparent.png\" alt=\"\" /></td>\n        </tr>\n        <tr class=\"\">\n          <td class=\"leftco"
  "l \"><div class=\"state\"><img class=\"icon\" src=\"\"  /></div></td>\n          <td class=\"\"><div class=\"withmarg"
  "in\">\n             <table class=\"noborder\"><tr><td class=\"noborder\"><span class=\"display-xs nowrap\" >  - </spa"
  "n></td></tr>\n               <tr><td class=\"noborder\"><a href=\"schedule.html\?channel=\" title=\": --\"></a></td><"
  "/tr>\n             </table>\n          </div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs with"
  "margin nowrap\"  >  </div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmargin nowrap\"  > "
  " </div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmargin nowrap\"  ></div></td>\n       "
  "   <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmargin nowrap\"  ></div></td>\n          <td class=\"\"><di"
  "v class=\"withmargin\">\n            <a \n            class=\"apopup\" title=\"\">\n            </a>\n            \n "
  "           </div>\n          </td>\n          <td class=\"  td-hidden-xs\"><div class=\"xs-nomargin\"></div></td>\n  "
  "        <td class=\"\"><div class=\"withmargin\">\n\n            \n              <a href=\"epginfo.html\?epgid=\"> </"
  "a>\n            <a href=\"edit_searchtimer.html\?searchtimerid=\"></a>\n          </div></td>\n          <td class=\""
  "rightcol \">\n            \n            <div class=\"event_actions\">\n              <a class=\"action-rightcol\" hre"
  "f=\"timers.html\?timerid=&action=toggle\"><img class=\"icon\" src=\"\" alt=\"\"  /></a>\n              <div class=\"a"
  "ction-rightcol\"></div>\n              <a class=\"action-rightcol\" href=\"timers.html\?timerid=&action=delete\"><img"
  " class=\"icon\" src=\"\" alt=\"\"  /></a>\n            </div>\n          </td>\n        </tr>\n      </table>\n      "
  "<div class=\"spacebar\"></div>\n    </div>\n  </body>\n</html>\n\n\n<a href=\"edit_timer.html\"></a>\n<span class=\"s"
  "ep\">|</span>\n<a href=\"timerconflicts.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    event_actions(*this, "event_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string timerid = qparam.get< std::string >("timerid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 23 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 26 "timers.ecpp"

  reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }

  pageTitle = trVDR("Timers");
  TimerConflicts timerConflicts;

  if ( !timerid.empty()  && !action.empty() ) {
    std::string tId = SortedTimers::DecodeDomId(timerid);
//    dsyslog("live: DEBUG: TIMER: tId = %s", tId.c_str());
    int timer_id;
    const char *remote;
    {
      LOCK_TIMERS_READ;
      const cTimer* timer = SortedTimers::GetByTimerId(tId, Timers);
      if (!timer)
        throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
      timer_id = timer->Id();
      remote   = timer->Remote();
    }
    if (action == "delete") {
      if (!cUser::CurrentUserHasRightTo(UR_DELTIMERS))
        throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
//                        dsyslog("live: timers.ecpp timer->Id() %d", timer->Id());
//                        dsyslog("live: timers.ecpp timer->Remote() %s", timer->Remote());
      TimerManager().DelTimer(timer_id, remote);
      timerNotifier.SetTimerModification();
    }
    if (action == "toggle") {
      TimerManager().ToggleTimerActive(timer_id, remote);
      timerNotifier.SetTimerModification();
    }

  reply.out() << _tntChunks[0]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-1);\n  </script>\n</html>\n
#line 69 "timers.ecpp"

  } else {
  std::string previousDay = "";

  // <& pageelems.doc_type ...
  { 
#line 73 "timers.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 73 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 77 "timers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[2]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 78 "timers.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 78 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 79 "timers.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 79 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 80 "timers.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 80 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n  </head>\n  <body onpagehide="saveScrollPosition('content')" onpageshow="restoreScrollPosition()">\n    
  // <& pageelems.logo ...
  { 
#line 83 "timers.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 83 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& menu ...
  { 
#line 84 "timers.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 84 "timers.ecpp"
    _tnt_cq5.add( "active", ("timers"));
#line 84 "timers.ecpp"
    _tnt_cq5.add( "component", ("timers.event_actions"));
#line 84 "timers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n    <div id="content">\n      <div class="spacebar">
  reply.out() << _tntChunks[8]; // </div>\n
#line 87 "timers.ecpp"

    #ifdef DEBUG_LOCK
      dsyslog("live: pages/timers.ecpp LOCK_TIMERS_READ");
    #endif
      {
      LOCK_TIMERS_READ;
      cSortedTimers sortedTimers(Timers);
      if (sortedTimers.Size() == 0) {

  reply.out() << _tntChunks[9]; //         
#line 96 "timers.ecpp"
  reply.sout() << ( tr("No timer defined") );
  reply.out() << _tntChunks[10]; // \n
#line 97 "timers.ecpp"
      } else {

  reply.out() << _tntChunks[11]; //       <table class="listing timers" cellspacing="0" cellpadding="0">\n
#line 99 "timers.ecpp"

        // check for remote timers:
        bool noRemoteTimers = true;
        for (int i = 0; noRemoteTimers && i < sortedTimers.Size(); i++) {
          noRemoteTimers &= sortedTimers[i]->Local();
        }
        // check for search timers or tvscraper autotimer:
        bool noSearchTimers = true;
        for (int i = 0; noSearchTimers && i < sortedTimers.Size(); i++) {
          std::string recID;
          std::string recName;
          const cTimer *timer = sortedTimers[i];
          noSearchTimers &= timer->Local() && SortedTimers::SearchTimerInfo(*timer, "s-id").empty() && SortedTimers::TvScraperTimerInfo(*timer, recID, recName).empty();
        }
        // output of the timer list:
        for (int i = 0; i < sortedTimers.Size(); i++) {
          const cTimer *timer = sortedTimers[i];
          cToSvConcat longDescription;
          cToSvConcat searchTimName;
          std::string searchTimId;
          std::string recID;
          std::string recName;

          longDescription << "<p>";
          AppendHtmlEscapedAndCorrectNonUTF8(longDescription, SortedTimers::GetTimerInfo(*timer), "</p><p>");
          longDescription << "</p>";
          if (timer->Event())
          {
            bool truncated = false;
            LOCK_SCHEDULES_READ;
            if (timer->Event()->Description() ) {
              longDescription << "<hr><p>";
              AppendHtmlEscapedAndCorrectNonUTF8(longDescription, StringWordTruncate(timer->Event()->Description(), LiveSetup().GetMaxTooltipChars(), truncated), "</p><p>");
              if (truncated) longDescription << " ...";
              longDescription << "</p>";
            }
          }
          AppendHtmlEscapedAndCorrectNonUTF8(searchTimName, SortedTimers::SearchTimerInfo(*timer, "searchtimer"));
          searchTimId = SortedTimers::SearchTimerInfo(*timer, "s-id");
          if (searchTimName.empty() && searchTimId.empty() ) AppendHtmlEscapedAndCorrectNonUTF8(searchTimName, SortedTimers::TvScraperTimerInfo(*timer, recID, recName));
          std::string currentDay = SortedTimers::GetTimerDays(timer);
          const cTimer *nextTimer =  NULL;
          if (i < (sortedTimers.Size() - 1)) nextTimer = sortedTimers[i + 1];
          bool bottom = false;
          if (i == sortedTimers.Size() - 1) bottom = true;
          else {
            std::string nextDay = SortedTimers::GetTimerDays(nextTimer);
            bottom = (currentDay != nextDay);
          }
          if (previousDay != currentDay) {
            if (!previousDay.empty()) {

  reply.out() << _tntChunks[12]; //             <tr class="spacer">\n              <td colspan="12"/>\n            </tr>\n
#line 154 "timers.ecpp"

            }
            previousDay = currentDay;

  reply.out() << _tntChunks[13]; //         <tr class="head">\n          <td colspan="12">\n            <div class="boxheader"><div class="caption">
#line 160 "timers.ecpp"
  reply.sout() << ( currentDay );
  reply.out() << _tntChunks[14]; // </div></div>\n          </td>\n        </tr>\n        <tr class="description">\n          <td class="leftcol">&nbsp;</td>\n          <td><div class="withmargin">
#line 165 "timers.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << _tntChunks[15]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 166 "timers.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << _tntChunks[16]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 167 "timers.ecpp"
  reply.sout() << ( trVDR("Stop")  );
  reply.out() << _tntChunks[17]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 168 "timers.ecpp"
  reply.sout() << ( tr("Duration") );
  reply.out() << _tntChunks[18]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 169 "timers.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << _tntChunks[19]; // </div></td>\n          <td><div class="withmargin">
#line 170 "timers.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << _tntChunks[20]; // </div></td>\n          <td class="td-hidden-xs
#line 171 "timers.ecpp"
  reply.sout() << ( noRemoteTimers ? " notpresent" : " remotetimer" );
  reply.out() << _tntChunks[21]; // "><div class="xs-nomargin hidden-xs">
#line 171 "timers.ecpp"
  reply.sout() << ( trVDR("Record on") );
  reply.out() << _tntChunks[22]; // </div></td>\n          <td class="
#line 172 "timers.ecpp"
  reply.sout() << ( noSearchTimers ? "notpresent" : "searchtimer" );
  reply.out() << _tntChunks[23]; // "><div class="withmargin">
#line 172 "timers.ecpp"
  reply.sout() << ( tr("Search timer") );
  reply.out() << _tntChunks[24]; // </div></td>\n          <td class="rightcol"><img class="action-rightcol" src="img/transparent.png" alt="" /></td>\n        </tr>\n
#line 175 "timers.ecpp"

          }
          std::string timerStateClass = "inactive";
          std::string timerStateIcon = "transparent.png";
          std::string timerStateHint;
          if (timer->Recording()) {
            timerStateClass = "recording";
            timerStateIcon = "arrow_rec.png";
            timerStateHint = tr("Timer is recording.");
          }
          else if (timer->Flags() & tfActive) {
            if (timerConflicts.HasConflict(timer->Id() )) {
              timerStateClass = "conflict";
              timerStateIcon = "timer_conflict.png";
              timerStateHint = tr("Timer has a conflict.");
            }
            else {
              timerStateClass = "active";
              timerStateIcon = "arrow.png";
              timerStateHint = tr("Timer is active.");
            }
          }
          cToSvConcat<0> timerFile;
          AppendHtmlEscapedAndCorrectNonUTF8(timerFile, timer->File());

  reply.out() << _tntChunks[25]; //         <tr class="
#line 200 "timers.ecpp"
  reply.sout() << ( timerStateClass );
  reply.out() << _tntChunks[26]; // ">\n          <td class="leftcol 
#line 201 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[27]; // "><div class="state"><img class="icon" src="
#line 201 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateIcon) );
  reply.out() << _tntChunks[28]; // " 
#line 201 "timers.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 201 "timers.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 201 "timers.ecpp"
    _tnt_cq6.add( "text", (timerStateHint));
#line 201 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[29]; //  
#line 201 "timers.ecpp"
 } 
  reply.out() << _tntChunks[30]; // /></div></td>\n          <td class="
#line 202 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[31]; // "><div class="withmargin">\n             <table class="noborder"><tr><td class="noborder"><span class="display-xs nowrap" > 
#line 203 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[32]; //  - 
#line 203 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[33]; // </span></td></tr>\n
#line 204 "timers.ecpp"
            {

#line 205 "timers.ecpp"
              LOCK_CHANNELS_READ;

  reply.out() << _tntChunks[34]; //                <tr><td class="noborder"><a href="schedule.html\?channel=
#line 206 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << _tntChunks[35]; // " title="
#line 206 "timers.ecpp"
  reply.sout() << (tr("Transponder"));
  reply.out() << _tntChunks[36]; // : 
#line 206 "timers.ecpp"
  reply.sout() << (*cSource::ToString(timer->Channel()->Source() ));
  reply.out() << _tntChunks[37]; // -
#line 206 "timers.ecpp"
  reply.sout() << (cToSvConcat(timer->Channel()->Frequency()));
  reply.out() << _tntChunks[38]; // -
#line 206 "timers.ecpp"
  reply.sout() << (timer->Channel()->Parameters());
  reply.out() << _tntChunks[39]; // ">
#line 206 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << _tntChunks[40]; // </a></td></tr>\n
#line 207 "timers.ecpp"
            }

  reply.out() << _tntChunks[41]; //              </table>\n          </div></td>\n
#line 210 "timers.ecpp"
         cToSvConcat longDescriptionTitle;

#line 211 "timers.ecpp"
         if (!longDescription.empty()) longDescriptionTitle << "title=\"" << longDescription << "\"";

  reply.out() << _tntChunks[42]; //           <td class="
#line 212 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[43]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 212 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[44]; //  >
#line 212 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[45]; //   </div></td>\n          <td class="
#line 213 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[46]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 213 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[47]; //  >
#line 213 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[48]; //   </div></td>\n          <td class="
#line 214 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[49]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 214 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[50]; //  >
#line 214 "timers.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), timer->StopTime() - timer->StartTime()) );
  reply.out() << _tntChunks[51]; // </div></td>\n          <td class="
#line 215 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[52]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" 
#line 215 "timers.ecpp"
  reply.out() << (longDescriptionTitle);
  reply.out() << _tntChunks[53]; //  >
#line 215 "timers.ecpp"
  reply.sout() << ( timer->Priority() );
  reply.out() << _tntChunks[54]; // </div></td>\n          <td class="
#line 216 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[55]; // "><div class="withmargin">\n
#line 217 "timers.ecpp"
         if(timer->Event()) {

#line 218 "timers.ecpp"
           LOCK_CHANNELS_READ;

#line 219 "timers.ecpp"
           LOCK_SCHEDULES_READ;

  reply.out() << _tntChunks[56]; //             <a 
  // <& tooltip.display ...
  { 
#line 220 "timers.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 220 "timers.ecpp"
    _tnt_cq7.add( "domId", (EpgEvents::EncodeDomId(timer->Channel()->GetChannelID(), timer->Event()->EventID())));
#line 220 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[57]; // \n            class="apopup" title="
#line 221 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[58]; // ">\n            
#line 222 "timers.ecpp"
  reply.out() << ( cToSvReplace(timerFile, "~", "~<wbr>") );
  reply.out() << _tntChunks[59]; // </a>\n
#line 223 "timers.ecpp"
         } else {

  reply.out() << _tntChunks[60]; //             
#line 224 "timers.ecpp"
  reply.out() << ( cToSvReplace(timerFile, "~", "~<wbr>") );
  reply.out() << _tntChunks[61]; // \n
#line 225 "timers.ecpp"
         }

  reply.out() << _tntChunks[62]; //             </div>\n          </td>\n          <td class="
#line 228 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[63]; //  
#line 228 "timers.ecpp"
  reply.sout() << ( noRemoteTimers ? "notpresent" : "remotetimer" );
  reply.out() << _tntChunks[64]; //  td-hidden-xs"><div class="xs-nomargin">
#line 228 "timers.ecpp"
  reply.sout() << ( timer->Local()?trVDR(" "):timer->Remote() );
  reply.out() << _tntChunks[65]; // </div></td>\n          <td class="
#line 229 "timers.ecpp"
  reply.sout() << ( noSearchTimers ? "notpresent" : "searchtimer" );
#line 229 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  " bottomrow" ;
  reply.out() << _tntChunks[66]; // "><div class="withmargin">\n
#line 230 "timers.ecpp"
          if ( !timer->Local() || searchTimId.empty() ) {

  reply.out() << _tntChunks[67]; // \n            
#line 232 "timers.ecpp"
  reply.out() << ( cToSvReplace(searchTimName, "~", "~<wbr>") );
  reply.out() << _tntChunks[68]; // \n
#line 233 "timers.ecpp"
           if (!recID.empty() ) {

  reply.out() << _tntChunks[69]; //               <a href="epginfo.html\?epgid=
#line 234 "timers.ecpp"
  reply.sout() << ( recID );
  reply.out() << _tntChunks[70]; // "> 
#line 234 "timers.ecpp"
  reply.out() << ( cToSvReplace(recName, "~", "~<wbr>") );
  reply.out() << _tntChunks[71]; // </a>\n
#line 235 "timers.ecpp"
           }

#line 236 "timers.ecpp"
          } else {

  reply.out() << _tntChunks[72]; //             <a href="edit_searchtimer.html\?searchtimerid=
#line 237 "timers.ecpp"
  reply.sout() << ( searchTimId );
  reply.out() << _tntChunks[73]; // ">
#line 237 "timers.ecpp"
  reply.out() << ( cToSvReplace(searchTimName, "~", "~<wbr>") );
  reply.out() << _tntChunks[74]; // </a>\n
#line 238 "timers.ecpp"
          }

  reply.out() << _tntChunks[75]; //           </div></td>\n          <td class="rightcol 
#line 240 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[76]; // ">\n            
  reply.out() << _tntChunks[77]; // \n            <div class="event_actions">\n              <a class="action-rightcol" href="timers.html\?timerid=
#line 243 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(SortedTimers::GetTimerId(*timer)) );
  reply.out() << _tntChunks[78]; // &action=toggle"><img class="icon" src="
#line 243 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[79]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 243 "timers.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 243 "timers.ecpp"
    _tnt_cq8.add( "text", (tr("Toggle timer active/inactive")));
#line 243 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[80]; //  /></a>\n              <div class="action-rightcol">
  // <& pageelems.edit_timer ...
  { 
#line 244 "timers.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 244 "timers.ecpp"
    _tnt_cq9.add( "className", "icon");
#line 244 "timers.ecpp"
    _tnt_cq9.add( "timerId", (SortedTimers::GetTimerId(*timer)));
#line 244 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[81]; // </div>\n              <a class="action-rightcol" href="timers.html\?timerid=
#line 245 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(SortedTimers::GetTimerId(*timer)) );
  reply.out() << _tntChunks[82]; // &action=delete"><img class="icon" src="
#line 245 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[83]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 245 "timers.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 245 "timers.ecpp"
    _tnt_cq10.add( "text", (tr("Delete timer")));
#line 245 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[84]; //  /></a>\n            </div>\n          </td>\n        </tr>\n
#line 249 "timers.ecpp"
       }

  reply.out() << _tntChunks[85]; //       </table>\n
#line 251 "timers.ecpp"
     }

#line 252 "timers.ecpp"
     }

  reply.out() << _tntChunks[86]; //       <div class="spacebar">
  reply.out() << _tntChunks[87]; // </div>\n    </div>\n  </body>\n</html>\n
#line 257 "timers.ecpp"
 }

  // <%include> page_exit.eh
  reply.out() << _tntChunks[88]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[89]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers::event_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 23 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[90]; // <a href="edit_timer.html">
#line 261 "timers.ecpp"
  reply.sout() << ( tr("New timer") );
  reply.out() << _tntChunks[91]; // </a>\n
#line 262 "timers.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[92]; // <span class="sep">|</span>\n<a href="timerconflicts.html">
#line 264 "timers.ecpp"
  reply.sout() << ( tr("Timer conflicts") );
  reply.out() << _tntChunks[93]; // </a>\n
#line 265 "timers.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
