////////////////////////////////////////////////////////////////////////
// tooltip.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.tooltip")

// <%pre>
#line 1 "tooltip.ecpp"


#include <setup.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class hint_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hint_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class display_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        display_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class display_scraper_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        display_scraper_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class help_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        help_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    hint_type hint;
    display_type display;
    display_scraper_type display_scraper;
    help_type help;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("tooltip");

static const char* rawData = "4\000\000\000;\000\000\000=\000\000\000>\000\000\000W\000\000\000Y\000\000\000Z\000\000"
  "\000s\000\000\000\201\000\000\000\202\000\000\000\236\000\000\000\256\000\000\000\262\000\000\000title=\"\"\n\nhref="
  "\"epginfo.html\?epgid=\"\n\nhref=\"epginfo.html\?epgid=&tab=scraper\"\n\n<img class=\"icon help\" src=\"\" alt=\"\" t"
  "itle=\"\"/>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    hint(*this, "hint"),
    display(*this, "display"),
    display_scraper(*this, "display_scraper"),
    help(*this, "help")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%cpp>
  reply.out() << _tntChunks[2]; // \n
  reply.out() << _tntChunks[5]; // \n
  reply.out() << _tntChunks[8]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hint_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip::hint " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string text = qparam.get< std::string >("text");
  // </%args>

  // <%cpp>
  reply.out() << _tntChunks[0]; // title="
#line 12 "tooltip.ecpp"
  reply.sout() << ( text );
  reply.out() << _tntChunks[1]; // "\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::display_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip::display " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string domId = qparam.get< std::string >("domId");
  // </%args>

  // <%cpp>
  reply.out() << _tntChunks[3]; // href="epginfo.html\?epgid=
#line 19 "tooltip.ecpp"
  reply.sout() << ( domId );
  reply.out() << _tntChunks[4]; // "\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::display_scraper_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip::display_scraper " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string domId = qparam.get< std::string >("domId");
  // </%args>

  // <%cpp>
  reply.out() << _tntChunks[6]; // href="epginfo.html\?epgid=
#line 26 "tooltip.ecpp"
  reply.sout() << ( domId );
  reply.out() << _tntChunks[7]; // &tab=scraper"\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::help_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip::help " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string text = qparam.get< std::string >("text");
  // </%args>

  // <%cpp>
  reply.out() << _tntChunks[9]; // <img class="icon help" src="
#line 33 "tooltip.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "help.png") );
  reply.out() << _tntChunks[10]; // " alt="" title="
#line 33 "tooltip.ecpp"
  reply.sout() << ( text );
  reply.out() << _tntChunks[11]; // "/>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
