////////////////////////////////////////////////////////////////////////
// users.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.users")

// <%pre>
#line 1 "users.ecpp"


#include <users.h>
#include <setup.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class user_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        user_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    user_actions_type user_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("users");

static const char* rawData = "t\000\000\000\346\000\000\000\363\000\000\000\370\000\000\000`\001\000\000e\001\000\000"
  "\231\001\000\000Q\002\000\000|\002\000\000\333\002\000\000\"\003\000\000`\003\000\000z\003\000\000\246\003\000\000"
  "\001\004\000\000\032\004\000\000#\004\000\000V\004\000\000}\004\000\000\206\004\000\000\312\004\000\0003\005\000\000"
  "\250\005\000\000\323\005\000\000\367\005\000\000\370\005\000\000\371\005\000\000\022\006\000\000\027\006\000\000\n<ht"
  "ml>\n  <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - "
  "</title>\n    \n    \n  </head>\n  <body onpagehide=\"saveScrollPosition('content')\" onpageshow=\"restoreScrollPosit"
  "ion()\">\n    \n    \n    <div id=\"content\">\n      <div class=\"spacebar\"></div>\n      <table class=\"listing us"
  "ers\" cellspacing=\"0\" cellpadding=\"0\">\n        <tr class=\"head\">\n          <td colspan=\"3\">\n            <d"
  "iv class=\"boxheader\"><div class=\"caption\"></div></div>\n          </td>\n        </tr>\n        <tr class=\"descr"
  "iption\">\n          <td class=\"action leftcol\" ><div class=\"withmargin\"></div></td>\n          <td class=\"right"
  "col\" colspan=\"2\"/>\n        </tr>\n          <tr class=\"account\">\n            <td class=\"leftcol \"><div class"
  "=\"withmargin\"></div></td>\n            <td class=\"rightcol \">\n              <div class=\"user_actions\">\n      "
  "          <a href=\"edit_user.html\?userid=\"><img class=\"icon\" src=\"\" alt=\"\"  /></a>\n                <a href="
  "\"users.html\?userid=&action=delete\"><img class=\"icon\" src=\"\" alt=\"\"  /></a>\n              </div></td>\n     "
  "       </td>\n          </tr>\n          <tr class=\"account\">\n            <td class=\"message leftcol bottomrow\">"
  "<div class=\"withmargin\"></div></td>\n            <td class=\"bottomrow\"></td>\n            <td class=\"rightcol bo"
  "ttomrow\"></td>\n          </tr>\n      </table>\n      <div class=\"spacebar\"></div>\n    </div>\n  </body>\n</html"
  ">\n\n\n<a href=\"edit_user.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    user_actions(*this, "user_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("users " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string userid = qparam.get< std::string >("userid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 15 "users.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 18 "users.ecpp"

if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

#line 25 "users.ecpp"

  pageTitle = tr("Users");
  if ( !userid.empty() ) {
    if (action == "delete")
    {
      cUser* user = Users.GetByUserId( userid );
      if (user) {
        // invalid userid may occur if page is reloaded
        Users.Del(user);
        Users.Save();
      }
    }
  }

  // <& pageelems.doc_type ...
  { 
#line 39 "users.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 39 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 43 "users.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 44 "users.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 44 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 45 "users.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 45 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n  </head>\n  <body onpagehide="saveScrollPosition('content')" onpageshow="restoreScrollPosition()">\n    
  // <& pageelems.logo ...
  { 
#line 48 "users.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 48 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& menu ...
  { 
#line 49 "users.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 49 "users.ecpp"
    _tnt_cq4.add( "active", ("users"));
#line 49 "users.ecpp"
    _tnt_cq4.add( "component", ("users.user_actions"));
#line 49 "users.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    <div id="content">\n      <div class="spacebar">
  reply.out() << _tntChunks[6]; // </div>\n      <table class="listing users" cellspacing="0" cellpadding="0">\n        <tr class="head">\n          <td colspan="3">\n            <div class="boxheader"><div class="caption">
#line 55 "users.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[7]; // </div></div>\n          </td>\n        </tr>\n
#line 58 "users.ecpp"
       if (Users.Count() > 0) {

  reply.out() << _tntChunks[8]; //         <tr class="description">\n          <td class="action leftcol" ><div class="withmargin">
#line 60 "users.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[9]; // </div></td>\n          <td class="rightcol" colspan="2"/>\n        </tr>\n
#line 63 "users.ecpp"

          cUser* user = Users.First();
          while (user)
          {
            bool bottom = (Users.Next(user) == NULL);
            if (user)
            {

  reply.out() << _tntChunks[10]; //           <tr class="account">\n            <td class="leftcol 
#line 72 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[11]; // "><div class="withmargin">
#line 72 "users.ecpp"
  reply.sout() << ( user->Name() );
  reply.out() << _tntChunks[12]; // </div></td>\n            <td class="rightcol 
#line 73 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[13]; // ">\n              <div class="user_actions">\n                <a href="edit_user.html\?userid=
#line 75 "users.ecpp"
  reply.sout() << ( user->Id() );
  reply.out() << _tntChunks[14]; // "><img class="icon" src="
#line 75 "users.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[15]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 75 "users.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 75 "users.ecpp"
    _tnt_cq5.add( "text", (tr("Edit user")));
#line 75 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[16]; //  /></a>\n                <a href="users.html\?userid=
#line 76 "users.ecpp"
  reply.sout() << ( user->Id() );
  reply.out() << _tntChunks[17]; // &action=delete"><img class="icon" src="
#line 76 "users.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[18]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 76 "users.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 76 "users.ecpp"
    _tnt_cq6.add( "text", (tr("Delete user")));
#line 76 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[19]; //  /></a>\n              </div></td>\n            </td>\n          </tr>\n
#line 80 "users.ecpp"

            }
            user = Users.Next(user);
          }
        } else {

  reply.out() << _tntChunks[20]; //           <tr class="account">\n            <td class="message leftcol bottomrow"><div class="withmargin">
#line 87 "users.ecpp"
  reply.sout() << ( tr("No user configured") );
  reply.out() << _tntChunks[21]; // </div></td>\n            <td class="bottomrow"></td>\n            <td class="rightcol bottomrow"></td>\n          </tr>\n
#line 91 "users.ecpp"
       }

  reply.out() << _tntChunks[22]; //       </table>\n      <div class="spacebar">
  reply.out() << _tntChunks[23]; // </div>\n    </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[24]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[25]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::user_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("users::user_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 15 "users.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[26]; // <a href="edit_user.html">
#line 100 "users.ecpp"
  reply.sout() << ( tr("New user") );
  reply.out() << _tntChunks[27]; // </a>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
