////////////////////////////////////////////////////////////////////////
// whats_on.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.whats_on")

// <%pre>
#line 1 "whats_on.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <epgsearch.h>

using namespace vdrlive;

static const size_t maximumTruncShortDescrLength = 100;   // characters for the short description in the "boxes"
static const size_t maximumTruncDescriptionLength = 150;  // characters for the description in the "boxes"


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class whats_on_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        whats_on_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    whats_on_actions_type whats_on_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("whats_on");

static const char* rawData = "t\001\000\000u\001\000\000v\001\000\000w\001\000\000\345\001\000\000\362\001\000\000\367"
  "\001\000\000\374\001\000\000\311\002\000\000\225\003\000\0002\004\000\0007\004\000\000k\004\000\000r\004\000\000\031"
  "\005\000\0009\005\000\000\?\005\000\000e\005\000\000\362\005\000\000\364\005\000\000\365\005\000\000]\006\000\000\021"
  "\007\000\000:\007\000\000\242\007\000\000\373\007\000\000,\010\000\000c\010\000\000j\010\000\000\230\010\000\000\231"
  "\010\000\000\244\010\000\000\321\010\000\000\376\010\000\000\033\t\000\000E\t\000\000\224\t\000\000\323\t\000\000\035"
  "\n\000\000 \n\000\000Y\n\000\000e\n\000\000f\n\000\000\207\n\000\000\247\n\000\000\263\n\000\000\344\n\000\000\345\n"
  "\000\000\004\013\000\000+\013\000\000f\013\000\000\215\013\000\000\217\013\000\000\220\013\000\000\265\013\000\000"
  "\304\013\000\000\321\013\000\000\355\013\000\000\021\014\000\000\022\014\000\000\023\014\000\000\025\014\000\000\037"
  "\014\000\000G\014\000\000V\014\000\000\200\014\000\000\251\014\000\000\271\014\000\000\346\014\000\000\350\014\000"
  "\000X\015\000\000b\015\000\000i\015\000\000l\015\000\000v\015\000\000\250\015\000\000\252\015\000\000\365\015\000\000"
  "2\016\000\000<\016\000\000e\016\000\000g\016\000\000\207\016\000\000\263\016\000\000\277\016\000\000\314\016\000\000"
  "\316\016\000\000\323\016\000\000\375\016\000\000\t\017\000\000\026\017\000\000\030\017\000\000\035\017\000\000\n\n\n"
  "\n<html>\n  <head>\n<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live -"
  " </title>\n    \n    \n    \n    <script type=\"text/javascript\"><!--\n    function showtime(selection)\n    {\n    "
  "  if (selection.options[selection.selectedIndex].value != \"\")\n        window.location.href = \"whats_on.html\?type"
  "=at&mode=&fixtime=\" + selection.options[selection.selectedIndex].value;\n    }\n    function showspectime(selection)"
  "\n    {\n      if (selection.value != \"\")\n        window.location.href = \"whats_on.html\?type=at&mode=&attime=\" "
  "+ selection.value;\n    }\n    //--></script>\n  </head>\n  <body onpagehide=\"saveScrollPosition('content')\" onpage"
  "show=\"restoreScrollPosition()\">\n    \n    \n    <div id=\"content\">\n      <div class=\"spacebar\"></div>\n      "
  "<table class=\"listing whats_on\" cellspacing=\"0\" cellpadding=\"0\">\n        <tr class=\"head\">\n          <td co"
  "lspan=\"4\"><div class=\"boxheader\"><div class=\"caption\"></div></div></td>\n        </tr>\n      \n      <div clas"
  "s=\"event_collection\">\n      <div class=\"event\">\n        <div class=\"station\">\n          <div class=\"boxhead"
  "er\"><div class=\"caption\"><a href=\"schedule.html\?channel=\" ></a></div></div>\n        </div>\n        <div class"
  "=\"content\">\n          <div class=\"tools\">\n            \n          </div>\n          <div class=\"whatson_info\""
  ">\n            <div class=\"epg_details\">\n              <div class=\"info nowrap\">\n                <div class=\"d"
  "ate margin_right\"></div>\n                <div class=\"time\"></div>\n               </div>\n              <div clas"
  "s=\"duration\">\n                <div class=\"progress\"></div>\n              </div>\n            </div>\n          "
  "  <div class=\"title withmargin\"></div>\n            <div class=\"short withmargin\"></div>\n            <div class="
  "\"description withmargin\"></div>\n              <div class=\"more withmargin\"><a ></a></div>\n          </div>\n   "
  "     </div>\n      </div>\n      <tr>\n        <td class=\"action leftcol \"><div class=\"event_actions\"></div></td>"
  "\n        <td class=\"topaligned \">\n          <div class=\"withmargin\">\n            <div class=\"nomargin nowrap"
  "\"></div>\n            <div class=\"duration\"><div class=\"progress\"></div></div>\n          </div>\n        </td>"
  "\n        <td class=\"topaligned \">\n            <div class=\"more withmargin\">\n            <a\n            \n    "
  "        ><span class=\"title\"></span><br/><span class=\"short\"></span></a>\n            <div class=\"withmargin\">"
  "\n            \n          </div>\n        </td>\n        <td class=\"topaligned rightcol \"><div class=\"station with"
  "margin\"><span class=\"channel_id\"></span> <a href=\"schedule.html\?channel=\" ></a></div>\n        </td>\n      </t"
  "r>\n      </table>\n      </div>\n      <div class=\"spacebar\"></div>\n    </div>\n  </body>\n</html>\n\n\n\n\n<a cl"
  "ass=\"\" href=\"whats_on.html\?type=now&amp;mode=\" id=\"nowhref\"></a>\n<span class=\"sep\">|</span>\n<a class=\"\" "
  "href=\"whats_on.html\?type=next&amp;mode=\" id=\"nexthref\"></a>\n<span class=\"sep\">|</span>\n<span class=\"\"></sp"
  "an>\n<select name=\"userdeftimes\" size=\"1\" id=\"userdeftimes\" onchange=\"showtime(this)\">\n  <option value=\"0\""
  "/>\n  <option value=\"\"> </option>\n</select>\n<span class=\"sep\">|</span>\n<span class=\"\"></span>\n<input type="
  "\"text\" size=\"6\" name=\"spectime\" id=\"spectime\" value = \"\" onchange=\"showspectime(this)\"/>\n<span class=\"s"
  "ep\">|</span>\n<a class=\"\" href=\"whats_on.html\?type=favs&amp;mode=\"></a>\n<span class=\"sep\">|</span>\n<a href="
  "\"whats_on.html\?mode=detail&amp;type=&amp;attime=&amp;fixtime=\"></a>\n<a href=\"whats_on.html\?mode=list&amp;type=&"
  "amp;attime=&amp;fixtime=\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    whats_on_actions(*this, "whats_on_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string type = qparam.get< std::string >("type", ( "now"));
std::string mode = qparam.get< std::string >("mode");
std::string attime = qparam.get< std::string >("attime");
std::string fixtime = qparam.get< std::string >("fixtime");
  // </%args>

#line 22 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 27 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 28 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 29 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 30 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 31 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 35 "whats_on.ecpp"

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}


std::string head;
time_t seektime = 0;
std::string displaytime;
std::string headTime;
std::string headDate;

if (mode.empty())
  mode = LiveSetup().GetLastWhatsOnListMode();
else
  LiveSetup().SetLastWhatsOnListMode(mode);

current_type = type;
current_mode = mode;
current_attime = attime;
current_fixtime = fixtime;

char const * timeFormat = tr("%I:%M %p");
char const * dateFormat = tr("%A, %x");
if (mode == "detail") {
  dateFormat = tr("%a, %x");
}

if (type == "now") {
  headTime = std::string(cToSvDateTime(timeFormat, time(0)));
  headDate = std::string(cToSvDateTime(dateFormat, time(0)));
  head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + " " + headTime;
} else if (type == "next") {
  headTime = std::string(cToSvDateTime(timeFormat, time(0) + 3600));
  headDate = std::string(cToSvDateTime(dateFormat, time(0) + 3600));
  head = tr("What's on next?");
} else if (type == "at") {
  if (attime != "")
    displaytime = ExpandTimeString(attime);
  else if (fixtime != "")
    displaytime = ExpandTimeString(fixtime);
  current_displaytime = displaytime;

  seektime = GetTimeT(displaytime);
  if (seektime - time(0) + 3600 < 0) // if wanted time is past more then 1h, then use tomorrow
    seektime += SECSINDAY;
  headTime = std::string(cToSvDateTime(timeFormat, seektime));
  headDate = std::string(cToSvDateTime(dateFormat, seektime));
  head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + std::string(" ") + headTime;
} else if (type == "favs") {
  head = tr("Favorites");
}


  // <& pageelems.doc_type ...
  { 
#line 92 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 92 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 96 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 97 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 97 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 98 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 98 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 99 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 99 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n    <script type="text/javascript"><!--\n    function showtime(selection)\n    {\n      if (selection.options[selection.selectedIndex].value != "")\n        window.location.href = "whats_on.html\?type=at&mode=
#line 104 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[8]; // &fixtime=" + selection.options[selection.selectedIndex].value;\n    }\n    function showspectime(selection)\n    {\n      if (selection.value != "")\n        window.location.href = "whats_on.html\?type=at&mode=
#line 109 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[9]; // &attime=" + selection.value;\n    }\n    //--></script>\n  </head>\n  <body onpagehide="saveScrollPosition('content')" onpageshow="restoreScrollPosition()">\n    
  // <& pageelems.logo ...
  { 
#line 114 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 114 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n    
  // <& menu ...
  { 
#line 115 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 115 "whats_on.ecpp"
    _tnt_cq5.add( "active", ("whats_on"));
#line 115 "whats_on.ecpp"
    _tnt_cq5.add( "component", ("whats_on.whats_on_actions"));
#line 115 "whats_on.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[11]; // \n    <div id="content">\n      <div class="spacebar">
  reply.out() << _tntChunks[12]; // </div>\n
#line 118 "whats_on.ecpp"
      if (mode == "list") {

  reply.out() << _tntChunks[13]; //       <table class="listing whats_on" cellspacing="0" cellpadding="0">\n        <tr class="head">\n          <td colspan="4"><div class="boxheader"><div class="caption">
#line 121 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[14]; // </div></div></td>\n        </tr>\n
#line 123 "whats_on.ecpp"
      } else {

  reply.out() << _tntChunks[15]; //       
  reply.out() << _tntChunks[16]; // \n      <div class="event_collection">\n
#line 126 "whats_on.ecpp"
      }

#line 127 "whats_on.ecpp"

  std::vector<EpgInfo> eventList;

  // collect the broadcasts
  if (type != "favs")
  {
    {
      LOCK_CHANNELS_READ;
      LOCK_SCHEDULES_READ;
      for (const cChannel *Channel = Channels->First(); Channel && Channel->Number() <= LiveSetup().GetLastChannel(); Channel = Channels->Next(Channel)) {
        if (Channel->GroupSep()) {
          continue;
        }
        const cSchedule *Schedule = Schedules->GetSchedule(Channel);
        if (!Schedule) {
          continue;
        }
        const cEvent *Event = nullptr;
        if (type == "now")
          Event = Schedule->GetPresentEvent();
        else if (type == "next")
          Event = Schedule->GetFollowingEvent();
        else if (type == "at")
          Event = Schedule->GetEventAround(seektime);

        if (!Event && !LiveSetup().GetShowChannelsWithoutEPG()) continue;

        eventList.emplace_back(Channel, Event);
      }
    }
  }
  else // get favorite broadcasts from epgsearch
  {
    SearchResults results;
    SearchTimers timers;  // this class "automatically" receives the data from epgsearch
    for (SearchTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
      if (!timer->UseInFavorites()) continue;
      SearchResults curresults;
      curresults.GetByID(timer->Id());
      results.merge(curresults);
    }
    time_t now = time(NULL);
    for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
      long diff = result->StartTime() - now;
      if (labs(diff) >= 24*60*60) continue; // skip broadcasts more than a day away
      LOCK_CHANNELS_READ;
      LOCK_SCHEDULES_READ;
      const cChannel* Channel = result->GetChannel(Channels);
      if (!Channel) continue;
      eventList.emplace_back(Channel, result->GetEvent(Channel, Schedules) );
    }
  }

  // display broadcasts
  for(std::vector<EpgInfo>::size_type i = 0; i < eventList.size(); ++i) {
    EpgInfoPtr epgEvent = &(eventList[i]);

    bool shortDescrTruncated = false;
    bool descriptionTruncated = false;
    cToSvConcat longDescription;
    if (!epgEvent->LongDescr().empty()) {
      longDescription << "<p>";
      AppendHtmlEscapedAndCorrectNonUTF8(longDescription, StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars(), descriptionTruncated), "</p><p>");
      if (descriptionTruncated) longDescription << " ...";
      longDescription << "</p>";
    }
    longDescription << "<p class=\"click-details\">" << tr("Click to view details.") << "</p>";

    std::string truncShortDescr(StringWordTruncate(epgEvent->ShortDescr(), maximumTruncShortDescrLength, shortDescrTruncated));
    std::string truncDescription(StringWordTruncate(epgEvent->LongDescr(), maximumTruncDescriptionLength, descriptionTruncated));
    int chNumber = epgEvent->ChannelNumber();

    std::string startTime(epgEvent->StartTime(tr("%I:%M %p")));
    std::string endTime(epgEvent->EndTime(tr("%I:%M %p")));
    std::string startDate(epgEvent->StartTime(tr("%a, %x")));

    std::string timeSpan(startTime + " - " + endTime);

    if (startTime.empty() && endTime.empty()) {
      timeSpan = mode=="detail" ? headTime : std::string();
      startDate = headDate;
    }
    if (mode == "detail") {

  reply.out() << _tntChunks[17]; //       <div class="event">\n        <div class="station">\n          <div class="boxheader"><div class="caption"><a href="schedule.html\?channel=
#line 213 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
  reply.out() << _tntChunks[18]; // " 
  // <& tooltip.hint ...
  { 
#line 213 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 213 "whats_on.ecpp"
    _tnt_cq6.add( "text", (tr("View the schedule of this channel")));
#line 213 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[19]; // >
#line 213 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
#line 213 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
#line 213 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << _tntChunks[20]; // </a></div></div>\n        </div>\n        <div class="content">\n          <div class="tools">\n            
  // <& pageelems.epg_tool_box ...
  { 
#line 217 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 217 "whats_on.ecpp"
    _tnt_cq7.add( "detail", (1));
#line 217 "whats_on.ecpp"
    _tnt_cq7.add( "endTime", (epgEvent->GetEndTime()));
#line 217 "whats_on.ecpp"
    _tnt_cq7.add( "epgid", (epgEvent->Id()));
#line 217 "whats_on.ecpp"
    _tnt_cq7.add( "startTime", (epgEvent->GetStartTime()));
#line 217 "whats_on.ecpp"
    _tnt_cq7.add( "title", (epgEvent->Title()));
#line 217 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[21]; // \n          </div>\n          <div class="whatson_info">\n            <div class="epg_details">\n              <div class="info nowrap">\n                <div class="date margin_right">
#line 222 "whats_on.ecpp"
  reply.sout() << ( (startDate) );
  reply.out() << _tntChunks[22]; // </div>\n                <div class="time">
#line 223 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[23]; // </div>\n               </div>\n              <div class="duration">\n                <div class="progress">
  // <& pageelems.progressbar ...
  { 
#line 226 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 226 "whats_on.ecpp"
    _tnt_cq8.add( "duration", (epgEvent->Duration()));
#line 226 "whats_on.ecpp"
    _tnt_cq8.add( "progress", (epgEvent->Elapsed()));
#line 226 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[24]; // </div>\n              </div>\n            </div>\n            <div class="title withmargin">
#line 229 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[25]; // </div>\n            <div class="short withmargin">
#line 230 "whats_on.ecpp"
  reply.sout() << ( truncShortDescr );
#line 230 "whats_on.ecpp"
  if ( shortDescrTruncated )
    reply.sout() <<  " ..." ;
  reply.out() << _tntChunks[26]; // </div>\n            <div class="description withmargin">
#line 231 "whats_on.ecpp"
  reply.sout() << ( truncDescription );
#line 231 "whats_on.ecpp"
  if ( descriptionTruncated )
    reply.sout() <<  " ..." ;
  reply.out() << _tntChunks[27]; // </div>\n
#line 232 "whats_on.ecpp"
           if (shortDescrTruncated || descriptionTruncated) {

  reply.out() << _tntChunks[28]; //               <div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 233 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 233 "whats_on.ecpp"
    _tnt_cq9.add( "text", (longDescription));
#line 233 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 233 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 233 "whats_on.ecpp"
    _tnt_cq10.add( "domId", (epgEvent->Id()));
#line 233 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[29]; // >
#line 233 "whats_on.ecpp"
  reply.sout() << ( tr("more") );
  reply.out() << _tntChunks[30]; // </a></div>\n
#line 234 "whats_on.ecpp"
           }

  reply.out() << _tntChunks[31]; //           </div>\n        </div>\n      </div>\n
#line 238 "whats_on.ecpp"

    } else { // mode == "list"
      bool lastCurrentChanel = i == (eventList.size() - 1);
      tChannelID chanId;
      tEventID eventId;
      EpgEvents::DecodeDomId(epgEvent->Id(), chanId, eventId);

      // Searching for channel logos
      cToSvConcat chanlogoimg;
      if (!LiveSetup().GetChanLogoDir().empty() ) {
        std::string chanlogofile = std::string(cToSvReplace(epgEvent->Caption(), "/", "_").concat(".png"));
        std::string chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
        struct stat chanfilebuf;
        bool logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        if (!logo_available) {
          chanlogofile = std::string(cToSvToLower(chanlogofile));
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (!logo_available) {
          chanlogofile = cToSvReplace(epgEvent->Caption(), "/", "~").concat(".png");
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (!logo_available) {
          chanlogofile = std::string(cToSvToLower(chanlogofile));
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (!logo_available) {
          chanlogofile = cToSvReplace(epgEvent->Caption(), "/", "_").concat(".svg");
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (!logo_available) {
          chanlogofile = std::string(cToSvToLower(chanlogofile));
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (!logo_available) {
          chanlogofile = cToSvReplace(epgEvent->Caption(), "/", "~").concat(".svg");
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (!logo_available) {
          chanlogofile = std::string(cToSvToLower(chanlogofile));
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (logo_available) {
          chanlogoimg.append("<img src=\"chanlogos/");
          AppendHtmlEscapedAndCorrectNonUTF8(chanlogoimg, chanlogofile);
          chanlogoimg.append("\" alt=\"");
          AppendHtmlEscapedAndCorrectNonUTF8(chanlogoimg, epgEvent->Caption());
          chanlogoimg.append("\" loading=\"lazy\" class=\"channel_logo\">");
        }
      }

  reply.out() << _tntChunks[32]; //       <tr>\n        <td class="action leftcol 
#line 297 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[33]; // "><div class="event_actions">
  // <& pageelems.epg_tool_box ...
  { 
#line 297 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 297 "whats_on.ecpp"
    _tnt_cq11.add( "detail", (0));
#line 297 "whats_on.ecpp"
    _tnt_cq11.add( "endTime", (epgEvent->GetEndTime()));
#line 297 "whats_on.ecpp"
    _tnt_cq11.add( "epgid", (epgEvent->Id()));
#line 297 "whats_on.ecpp"
    _tnt_cq11.add( "startTime", (epgEvent->GetStartTime()));
#line 297 "whats_on.ecpp"
    _tnt_cq11.add( "title", (epgEvent->Title()));
#line 297 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[34]; // </div></td>\n        <td class="topaligned 
#line 298 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[35]; // ">\n          <div class="withmargin">\n            <div class="nomargin nowrap">
#line 300 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[36]; // </div>\n            <div class="duration"><div class="progress">
  // <& pageelems.progressbar ...
  { 
#line 301 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 301 "whats_on.ecpp"
    _tnt_cq12.add( "duration", (epgEvent->Duration()));
#line 301 "whats_on.ecpp"
    _tnt_cq12.add( "progress", (epgEvent->Elapsed()));
#line 301 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[37]; // </div></div>\n          </div>\n        </td>\n        <td class="topaligned 
#line 304 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[38]; // ">\n
#line 305 "whats_on.ecpp"
          if (eventId != 0) {

  reply.out() << _tntChunks[39]; //             <div class="more withmargin">\n            <a\n
#line 308 "whats_on.ecpp"
            if (!longDescription.empty()) {

  reply.out() << _tntChunks[40]; //             
  // <& tooltip.hint ...
  { 
#line 309 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 309 "whats_on.ecpp"
    _tnt_cq13.add( "text", (longDescription));
#line 309 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq13);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 309 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 309 "whats_on.ecpp"
    _tnt_cq14.add( "domId", (epgEvent->Id()));
#line 309 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[41]; // \n
#line 310 "whats_on.ecpp"
            }

  reply.out() << _tntChunks[42]; //             ><span class="title">
#line 311 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[43]; // </span><br/><span class="short">
#line 311 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[44]; // </span></a>\n
#line 312 "whats_on.ecpp"
          } else {

  reply.out() << _tntChunks[45]; //             <div class="withmargin">\n            
#line 314 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[46]; // \n
#line 315 "whats_on.ecpp"
          }

  reply.out() << _tntChunks[47]; //           </div>\n        </td>\n
#line 318 "whats_on.ecpp"

      cToSvConcat hint("<p>", epgEvent->Caption().data(), "</p><p class=\"click-details\">", tr("View the schedule of this channel"), "</p>");

  reply.out() << _tntChunks[48]; //         <td class="topaligned rightcol 
#line 321 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[49]; // "><div class="station withmargin"><span class="channel_id">
#line 321 "whats_on.ecpp"
  reply.sout() << ( cToSvInt(chNumber) );
#line 321 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
  reply.out() << _tntChunks[50]; // </span> <a href="schedule.html\?channel=
#line 321 "whats_on.ecpp"
  reply.sout() << ( cToSvInt(chNumber) );
  reply.out() << _tntChunks[51]; // " 
  // <& tooltip.hint ...
  { 
#line 321 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 321 "whats_on.ecpp"
    _tnt_cq15.add( "text", (hint));
#line 321 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[52]; // >
#line 321 "whats_on.ecpp"
  reply.out() << ( chanlogoimg );
#line 321 "whats_on.ecpp"
  reply.sout() << ( chanlogoimg.empty()?epgEvent->Caption():"" );
  reply.out() << _tntChunks[53]; // </a></div>\n        </td>\n      </tr>\n
#line 324 "whats_on.ecpp"
  }

#line 325 "whats_on.ecpp"

  }

#line 328 "whats_on.ecpp"
  if (mode == "list") {

  reply.out() << _tntChunks[54]; //       </table>\n
#line 330 "whats_on.ecpp"
   } else {

  reply.out() << _tntChunks[55]; //       </div>\n
#line 332 "whats_on.ecpp"
   }

  reply.out() << _tntChunks[56]; //       <div class="spacebar">
  reply.out() << _tntChunks[57]; // </div>\n    </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[58]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[59]; // \n
  reply.out() << _tntChunks[60]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::whats_on_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on::whats_on_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 22 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 27 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 28 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 29 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 30 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 31 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[61]; // <a class="
#line 342 "whats_on.ecpp"
  if ( current_type == "now" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[62]; // " href="whats_on.html\?type=now&amp;mode=
#line 342 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[63]; // " id="nowhref">
#line 342 "whats_on.ecpp"
  reply.sout() << ( tr("Now") );
  reply.out() << _tntChunks[64]; // </a>\n<span class="sep">|</span>\n<a class="
#line 344 "whats_on.ecpp"
  if ( current_type == "next" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[65]; // " href="whats_on.html\?type=next&amp;mode=
#line 344 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[66]; // " id="nexthref">
#line 344 "whats_on.ecpp"
  reply.sout() << ( tr("Next") );
  reply.out() << _tntChunks[67]; // </a>\n<span class="sep">|</span>\n<span class="
#line 346 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime != "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[68]; // ">
#line 346 "whats_on.ecpp"
  reply.sout() << ( tr("What's on") );
  reply.out() << _tntChunks[69]; // </span>\n<select name="userdeftimes" size="1" id="userdeftimes" onchange="showtime(this)">\n  <option value="0"/>\n
#line 349 "whats_on.ecpp"

  std::string string_times = LiveSetup().GetTimes();
  cSplit parts(string_times, ';');
  auto part = parts.begin();
  for (int i = 0; part != parts.end(); ++i, ++part) {

  reply.out() << _tntChunks[70]; //   <option 
#line 355 "whats_on.ecpp"
 reply.out() << ( (current_fixtime != "" && *part == current_displaytime) ? "selected=\"selected\"" : "" ); 
  reply.out() << _tntChunks[71]; // value="
#line 355 "whats_on.ecpp"
  reply.sout() << ( *part );
  reply.out() << _tntChunks[72]; // "> 
#line 355 "whats_on.ecpp"
  reply.sout() << ( cToSvConcat(tr("at"), ' ', *part) );
  reply.out() << _tntChunks[73]; // </option>\n
#line 356 "whats_on.ecpp"

  }

  reply.out() << _tntChunks[74]; // </select>\n<span class="sep">|</span>\n<span class="
#line 361 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime == "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[75]; // ">
#line 361 "whats_on.ecpp"
  reply.sout() << ( tr("at") );
  reply.out() << _tntChunks[76]; // </span>\n<input type="text" size="6" name="spectime" id="spectime" value = "
#line 362 "whats_on.ecpp"
  if ( current_attime != "" )
    reply.sout() <<  current_displaytime ;
  reply.out() << _tntChunks[77]; // " onchange="showspectime(this)"/>\n<span class="sep">|</span>\n
#line 364 "whats_on.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[78]; // <a class="
#line 365 "whats_on.ecpp"
  if ( current_type == "favs" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[79]; // " href="whats_on.html\?type=favs&amp;mode=
#line 365 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[80]; // ">
#line 365 "whats_on.ecpp"
  reply.sout() << ( tr("Favorites") );
  reply.out() << _tntChunks[81]; // </a>\n<span class="sep">|</span>\n
#line 367 "whats_on.ecpp"
 }

#line 368 "whats_on.ecpp"
 if ( current_mode == "list" ) {

  reply.out() << _tntChunks[82]; // <a href="whats_on.html\?mode=detail&amp;type=
#line 369 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[83]; // &amp;attime=
#line 369 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[84]; // &amp;fixtime=
#line 369 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[85]; // ">
#line 369 "whats_on.ecpp"
  reply.sout() << ( tr("Details view") );
  reply.out() << _tntChunks[86]; // </a>\n
#line 370 "whats_on.ecpp"
 } else {

  reply.out() << _tntChunks[87]; // <a href="whats_on.html\?mode=list&amp;type=
#line 371 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[88]; // &amp;attime=
#line 371 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[89]; // &amp;fixtime=
#line 371 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[90]; // ">
#line 371 "whats_on.ecpp"
  reply.sout() << ( tr("List view") );
  reply.out() << _tntChunks[91]; // </a>\n
#line 372 "whats_on.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
